//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "compiler.h"

//Die Klasse Compiler war ursprnglich nur fr die verbindung mit FreeBASIC und das anzeigen der Ausgabe zustndig.
//In Zukunft wird die Klasse auch die Debugger Ausgabe anzeigen.


Compiler::Compiler(MainWindow *main, QWidget *parent)
        : QWidget(parent)
{
    this->main = main;
    stack = 1024;
    object = false;
    assembler = false;
    debug = false;
    thread = false;
    profile = false;
    console = true;
    fpu = true;
    compile = 3;
    typ = 1;
    fehler = 0;
    exeName = "";
    ver = 1;
    arch = 2;
    process2 = new QProcess;
    connect(process2,SIGNAL(destroyed()),this,SLOT(stopRun()));

    //Compilerpfad
    //TODO: Compilerpfad aus settings.ini lesen
    fb = QString("\"").append(main->getSettings()->value("Compiler/Path").toString()).append("\"");


    parentWindow = main;
    QDockWidget *compiler = new QDockWidget(main->getSettings()->value("Lang/Compiler_Output").toString(), main);
    compiler->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea | Qt::TopDockWidgetArea);
    compiler->setObjectName("compilerDock");

    QWidget *widget = new QWidget;
    QVBoxLayout *vbox = new QVBoxLayout;
    vbox->setContentsMargins(0,0,0,0);

    //Tabbar der Ausgabe
    QTabBar *bar = new QTabBar;
    bar->setShape(QTabBar::RoundedSouth);
    bar->setExpanding(false);
    bar->addTab(main->getSettings()->value("Lang/Compiler_Output").toString());
    bar->addTab(main->getSettings()->value("Lang/Compiler_Problems").toString());
    bar->addTab(main->getSettings()->value("Lang/Compiler_Errors").toString());
    bar->addTab(main->getSettings()->value("Lang/Compiler_Warnings").toString());
    bar->addTab(main->getSettings()->value("Lang/Compiler_Debugger").toString());
    bar->addTab(main->getSettings()->value("Lang/Compiler_LV").toString());

    connect(bar,SIGNAL(currentChanged(int)),this,SLOT(tabChange(int)));

    view = new QTextEdit;
    view->setReadOnly(true);
    view->setLineWrapMode(QTextEdit::NoWrap);

    error = new QListWidget;
    error->hide();
    connect(error,SIGNAL(clicked(QModelIndex)),this,SLOT(gotoError(QModelIndex)));
    warning = new QListWidget;
    warning->hide();
    connect(warning,SIGNAL(clicked(QModelIndex)),this,SLOT(gotoError(QModelIndex)));
    problem = new QListWidget;
    problem->hide();
    connect(problem,SIGNAL(clicked(QModelIndex)),this,SLOT(gotoError(QModelIndex)));

    vbox->addWidget(view);
    vbox->addWidget(problem);
    vbox->addWidget(error);
    vbox->addWidget(warning);
    vbox->addWidget(bar);
    widget->setLayout(vbox);
    compiler->setWidget(widget);
    main->addDockWidget(Qt::BottomDockWidgetArea, compiler);
}








//Erstellt das Projekt. Grter Teil ist nur das generieren des Compileraufrufs
void Compiler::erstellen()
{
    fb = QString("\"").append(main->getSettings()->value("Compiler/Path").toString()).append("\"");
    QFileInfo info(main->getSettings()->value("Compiler/Path").toString());
    if (info.exists() == false)
    {
        view->clear();
        error->clear();
        warning->clear();
        problem->clear();
        view->setText(main->getSettings()->value("Lang/Compiler_Path_Error").toString());
        return;
    }
    text.clear();

    QString name = parentWindow->getManager()->projektPath;

    QString string = fb;

    string.append(" -b \"");
    string.append(parentWindow->getManager()->getBasFileList().join("\" -b \""));

    QString fileName = name;
    QStringList list1 = fileName.split(".");
    fileName = list1.first();

    fileName.append(".exe");

    string.append("\" -x ").append("\"").append(fileName).append("\"");
    string.append(" -v -maxerr inf");


    char buffer[255];
    itoa(stack,buffer,10);
    string.append(" -t ").append(buffer);


    if (ver == 1)
    {
        string.append(" -lang fb");
    } else if(ver == 2)
    {
        string.append(" -lang qb");
    } else if(ver == 3)
    {
        string.append(" -lang deprecated");
    } else if(ver == 4)
    {
        string.append(" -lang fblite");
    }


    if (arch == 1)
    {
        string.append(" -arch 386");
    } else if(arch == 2)
    {
        string.append(" -arch 486");
    } else if(arch == 3)
    {
        string.append(" -arch 586");
    } else if(arch == 4)
    {
        string.append(" -arch 686");
    }


    if (fpu == true)
    {
        string.append(" -fpu FPU");
    } else
    {
        string.append(" -fpu SSE");
    }


    if(fehler == 1)
    {
        string.append(" -e");
    } else if(fehler == 2)
    {
        string.append(" -ex");
    } else if(fehler == 3)
    {
        string.append(" -exx");
    }


    if (debug == true)
    {
        string.append(" -g");
    }


    if (thread == true)
    {
        string.append(" -mt");
    }


    if (profile == true)
    {
        string.append(" -profile");
    }


    if (console == false)
    {
        string.append(" -s gui");
    }


    if (assembler == true)
    {
        string.append(" -R");
    }


    if (object == true)
    {
        string.append(" -C");
    }


    if(typ == 2)
    {
        string.append(" -dylib");
    } else if(typ == 3)
    {
        string.append(" -lib");
    }


    if (compile == 1)
    {
        string.append(" -r");
    } else if(compile == 2)
    {
        string.append(" -c");
    }

    string.append(" -noerrline");

    string.append(" ").append(zusatz);
    string.remove(QRegExp("[\n]"));
    exe = fileName;
    view->clear();
    error->clear();
    warning->clear();
    problem->clear();
    text = string;
    text.append("\n");
    main->getErstellenAct()->setEnabled(false);
    main->getErstellenausAct()->setEnabled(false);
    main->getErstellenAct2()->setEnabled(false);
    main->getErstellenausAct2()->setEnabled(false);
    process = new QProcess;
    process->start(string);
    connect(process,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(finished(int,QProcess::ExitStatus)));



}









//Gleich wie erstellen() aber startet das programm auch nach dem Compilieren.
void Compiler::erstellenaus()
{
    fb = QString("\"").append(main->getSettings()->value("Compiler/Path").toString()).append("\"");
    QFileInfo info(main->getSettings()->value("Compiler/Path").toString());
    if (info.exists() == false)
    {
        view->clear();
        error->clear();
        warning->clear();
        problem->clear();
        view->setText(main->getSettings()->value("Lang/Compiler_Path_Error").toString());
        return;
    }
    text.clear();

    QString name = parentWindow->getManager()->projektPath;

    QString string = fb;

    string.append(" -b \"");
    string.append(parentWindow->getManager()->getBasFileList().join("\" -b \""));

    QString fileName = name;
    QStringList list1 = fileName.split(".");
    fileName = list1.first();

    fileName.append(".exe");

    string.append("\" -x ").append("\"").append(fileName).append("\"");
    string.append(" -v -maxerr inf");


    char buffer[255];
    itoa(stack,buffer,10);
    string.append(" -t ").append(buffer);


    if (ver == 1)
    {
        string.append(" -lang fb");
    } else if(ver == 2)
    {
        string.append(" -lang qb");
    } else if(ver == 3)
    {
        string.append(" -lang deprecated");
    } else if(ver == 4)
    {
        string.append(" -lang fblite");
    }


    if (arch == 1)
    {
        string.append(" -arch 386");
    } else if(arch == 2)
    {
        string.append(" -arch 486");
    } else if(arch == 3)
    {
        string.append(" -arch 586");
    } else if(arch == 4)
    {
        string.append(" -arch 686");
    }


    if (fpu == true)
    {
        string.append(" -fpu FPU");
    } else
    {
        string.append(" -fpu SSE");
    }


    if(fehler == 1)
    {
        string.append(" -e");
    } else if(fehler == 2)
    {
        string.append(" -ex");
    } else if(fehler == 3)
    {
        string.append(" -exx");
    }


    if (debug == true)
    {
        string.append(" -g");
    }


    if (thread == true)
    {
        string.append(" -mt");
    }


    if (profile == true)
    {
        string.append(" -profile");
    }


    if (console == false)
    {
        string.append(" -s gui");
    }


    if (assembler == true)
    {
        string.append(" -R");
    }


    if (object == true)
    {
        string.append(" -C");
    }


    if(typ == 2)
    {
        string.append(" -dylib");
    } else if(typ == 3)
    {
        string.append(" -lib");
    }


    if (compile == 1)
    {
        string.append(" -r");
    } else if(compile == 2)
    {
        string.append(" -c");
    }


    string.append(" -noerrline");
    string.append(" ").append(zusatz);
    string.remove(QRegExp("[\n]"));
    exe = fileName;
    view->clear();
    error->clear();
    warning->clear();
    problem->clear();
    text = string;
    text.append("\n");
    main->getErstellenAct()->setEnabled(false);
    main->getErstellenausAct()->setEnabled(false);
    main->getErstellenAct2()->setEnabled(false);
    main->getErstellenausAct2()->setEnabled(false);
    process = new QProcess;
    process->start(string);
    connect(process,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(finished2(int,QProcess::ExitStatus)));
}










//Wird aufgerufen sobald erstellen() zu ende ist und liest die ganze Compilerausgabe.
void Compiler::finished(int exitCode, QProcess::ExitStatus exitStatus)
{
    QStringList list;
    QString string;
    QString string2;
    QListWidgetItem *item;
    QListWidgetItem *item2;
    int temp = 0;

    if (exitStatus == QProcess::NormalExit)
    {
        for (;process->canReadLine() == true;)
        {
            temp = 0;
            string = process->readLine();
            string.remove(QRegExp("[\n]"));
            string.remove(-1,1);
            list = string.split(" ");

            if (list.join(" ").contains(")") == true)
            {
                for(int i = 0;i < list.count();i++)
                {
                    if (list[i].contains(")") == true)
                    {
                        temp = i;
                        break;
                    }
                }
            }

            if (list.count() < 3)
                continue;


            if (list[temp+1] == "error")
            {
                string2 = createToolTip(list,temp+1);    //Ermittelt den Hilfe Text
                item = new QListWidgetItem(QIcon("16x16\\status\\dialog-error.png"),list.join(" "));
                item->setToolTip(string2);
                error->addItem(item);
                item2 = new QListWidgetItem(QIcon("16x16\\status\\dialog-error.png"),list.join(" "));
                item2->setToolTip(string2);
                problem->addItem(item2);
            }

            if (list[temp+1] == "warning")
            {
                string2 = createToolTip(list,temp+1);   //Ermittelt den Hilfe Text
                item = new QListWidgetItem(QIcon("16x16\\status\\dialog-warning.png"),list.join(" "));
                item->setToolTip(string2);
                warning->addItem(item);
                item2 = new QListWidgetItem(QIcon("16x16\\status\\dialog-warning.png"),list.join(" "));
                item2->setToolTip(string2);
                problem->addItem(item2);
            }

            text.append(string);
            text.append("\n");
        }

    } else
    {
        //Wird nur bei Fehlern aufgerufen.
        QMessageBox box;
        box.setText("FreeBASIC ist abgestrzt.");
        box.setIcon(QMessageBox::Critical);
        box.exec();
    }
    view->setText(text);
    main->getErstellenAct()->setEnabled(true);
    main->getErstellenausAct()->setEnabled(true);
    main->getErstellenAct2()->setEnabled(true);
    main->getErstellenausAct2()->setEnabled(true);
    delete process;
}









//Wird aufgerufen wenn erstellenaus() fertig ist.
void Compiler::finished2(int exitCode, QProcess::ExitStatus exitStatus)
{
    QStringList list;
    QString string;
    QString string2;
    QListWidgetItem *item;
    QListWidgetItem *item2;
    int temp = 0;

    if (exitStatus == QProcess::NormalExit)
    {
        for (;process->canReadLine() == true;)
        {
            temp = 0;
            string = process->readLine();
            string.remove(QRegExp("[\n]"));
            string.remove(-1,1);
            list = string.split(" ");

            if (list.join(" ").contains(" error ") == true || list.join(" ").contains(" warning ") == true)
            {
                for(int i = 0;i < list.count();i++)
                {
                    if (list[i].contains("error") == true || list[i].contains("warning") == true)
                    {
                        temp = i;
                        break;
                    }
                }
            }


            if (list.count() < 3)
                continue;

            if (list[temp] == "error")
            {
                string2 = createToolTip(list,temp);
                item = new QListWidgetItem(QIcon("16x16\\status\\dialog-error.png"),list.join(" "));
                item->setToolTip(string2);
                error->addItem(item);
                item2 = new QListWidgetItem(QIcon("16x16\\status\\dialog-error.png"),list.join(" "));
                item2->setToolTip(string2);
                problem->addItem(item2);
            }

            if (list[temp] == "warning")
            {
                string2 = createToolTip(list,temp);
                item = new QListWidgetItem(QIcon("16x16\\status\\dialog-warning.png"),list.join(" "));
                item->setToolTip(string2);
                warning->addItem(item);
                item2 = new QListWidgetItem(QIcon("16x16\\status\\dialog-warning.png"),list.join(" "));
                item2->setToolTip(string2);
                problem->addItem(item2);
            }
            text.append(string);
            text.append("\n");
        }

    } else
    {
        QMessageBox box;
        box.setText("FreeBASIC ist abgestrzt.");
        box.setIcon(QMessageBox::Critical);
        box.exec();
    }

    main->getErstellenAct()->setEnabled(true);
    main->getErstellenausAct()->setEnabled(true);
    main->getErstellenAct2()->setEnabled(true);
    main->getErstellenausAct2()->setEnabled(true);
    view->setText(text);
    delete process;

    main->getStopAct()->setEnabled(true);
    process->startDetached(QString("\"").append(exe).append("\""));

}









//Wechseln der Tabs
void Compiler::tabChange(int index)
{
    if (index == 0)
    {
        error->hide();
        warning->hide();
        problem->hide();
        view->show();
    } else if(index == 1)
    {
        view->hide();
        warning->hide();
        error->hide();
        problem->show();
    } else if(index == 2)
    {
        view->hide();
        warning->hide();
        problem->hide();
        error->show();
    } else if(index == 3)
    {
        view->hide();
        error->hide();
        problem->hide();
        warning->show();
    }
}









//Ermittelt Hilfe Texte zu den Fehlern
QString Compiler::createToolTip(QStringList string, int start)
{
    int number;
    QString n = string[start+1];
    QString s = "";
    if (string[start] == "error")
    {
        n.remove(-1,1);
        number = n.toInt();
        switch(number)
        {
            case 1:
            return s.append(QString("Es werden fr diese Funktion/dieses Sub mehr/weniger Parameter bentigt.\n\nLsungsmglichkeiten:\n- berprfe die Dekleration der Funktion/des Subs.\n- Vergleiche die Parameter die du Verwendet hast und die Parameter die von der Dekleration verlangt werden und nimm gegebenen falls nderungen vor."));


            case 41:
            return s.append(QString("Die Variable '").append(string[start+5]).append("' wurde nicht deklariert.\n\nLsungsmglichkeiten:\n- Deklariere die Variable mit 'dim'\n- berprfe die Schreibweise, mglicherweise hast du einen Schreibfehler gemacht."));


            case 55:
            return s.append(QString("Du hast versucht einen Parameter mit dem falschen Typ zu bergeben.\n\nLsungsmglichkeiten:\n- berprfe den Funktionsaufruf un nimm gegebenenfalls nderungen vor.\n- berprfe die dekleration der Funktion, vielleicht hast du die Reihenfolge verwechselt."));


            case 96:
            return s.append(QString("FreeBASIC hat 'loop' gefunden obwohl kein 'do' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'do' an der entsprechenden Stelle ein.\n- Entferne 'loop'."));


            case 97:
            return s.append(QString("FreeBASIC hat 'next' gefunden obwohl kein 'for' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'for' an der entsprechenden Stelle ein.\n- Entferne 'next'."));


            case 98:
            return s.append(QString("FreeBASIC hat 'wend' gefunden obwohl kein 'while' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'while' an der entsprechenden Stelle ein.\n- Entferne 'wend'."));


            case 99:
            return s.append(QString("FreeBASIC hat 'end with' gefunden obwohl kein 'with' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'with' an der entsprechenden Stelle ein.\n- Entferne 'end with'."));


            case 100:
            return s.append(QString("FreeBASIC hat 'end if' gefunden obwohl kein 'if' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'if' an der entsprechenden Stelle ein.\n- Entferne 'end if'."));


            case 101:
            return s.append(QString("FreeBASIC hat 'end select' gefunden obwohl kein 'select' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'select' an der entsprechenden Stelle ein.\n- Entferne 'end select'."));


            case 102:
            return s.append(QString("FreeBASIC hat 'end sub' oder 'end function' gefunden obwohl kein 'function' oder 'sub' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'function' oder 'sub' an der entsprechenden Stelle ein.\n- Entferne 'end sub' oder 'end function'."));


            case 106:
            return s.append(QString("FreeBASIC hat 'elseif' gefunden obwohl kein 'if' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'if' an der entsprechenden Stelle ein.\n- Entferne 'elseif'."));


            case 107:
            return s.append(QString("FreeBASIC hat 'else' gefunden obwohl kein 'if' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'if' an der entsprechenden Stelle ein.\n- Entferne 'else'."));


            case 108:
            return s.append(QString("FreeBASIC hat 'case' gefunden obwohl kein 'select' vorranging.\n\nLsungsmglichkeiten:\n- Fge 'select' an der entsprechenden Stelle ein.\n- Entferne 'case'."));


            case 115:
            return s.append(QString("FreeBASIC hat 'end sub' erwartet aber das Sub wurde mit einem anderen 'end' abgeschlossen.\nHinweis: Du darfst Funktions, Sub, Construktor, und Destruktor definitionen nicht verschachteln.\n\nLsungsmglichkeiten:\n- Benutzte 'end sub'."));


            case 116:
            return s.append(QString("FreeBASIC hat 'end function' erwartet aber die Funktion wurde mit einem anderen 'end' abgeschlossen.\nHinweis: Du darfst Funktions, Sub, Construktor, und Destruktor definitionen nicht verschachteln.\n\nLsungsmglichkeiten:\n- Benutzte 'end function'."));


            case 140:
            return s.append(QString("Der Index des Arrays ist ungltig. Hast du einen String als Index verwendet?\n\nLsungsmglichkeiten:\n- Verwende einen Integer Wert der im Rahmen der Definition liegt als Index."));


        }
    }
    if (string[start] == "warning")
    {
        n.remove(-4,4);
        number = n.toInt();
        switch(number)
        {
            case 3:
            return s.append(QString("Du hast versucht einer Funktion als Parameter einen falschen Zeigertyp zu bergeben.\nWenn die Datentypen des erwarteten Zeigers und des bergebenen Zeigers unterschiedlich gro sind, kann dies zum Programmabsturz fhren.\n\nLsungsmglichkeiten:\n- bergebe den richtigen Zeiger.\n- ndere die Funktion (falls du sie selber geschrieben hast)."));


            case 7:
            return s.append(QString("Ein von dir gewhlter Bezeichner fr eine Variable oder Funktion ist zu lang.\n\n\nLsungsmglichkeiten:\n- Verwende einen krzeren Bezeichner."));


            case 8:
            return s.append(QString("Eine von dir verwendete Zahl ist zu lang.\n\nLsungsmglichkeiten:\n- Verwende eine krzere Zahl."));


            case 9:
            return s.append(QString("Ein von dir verwendeter String ist zu lang.\n\nLsungsmglichkeiten:\n- Verwende einen krzeren String."));


            case 12:
            return s.append(QString("Du hast die Variable '").append(string[start+5]).append("' verwendet ohne sie vorher explizit zu deklarieren.\nWenn der gewhlte Sprachdialekt keine Fehler anzeigt und das Programm fertig kompiliert wird kann dies zu unerwarteten Ereignissen fhren.\n\nLsungsmglichkeiten:\n- Deklariere die Variable mit 'dim'.\n- Sollte 'dim' beim gewhlten Sprachdialekt nicht ntig sein, initialisiere die Variable explizit mit '='."));


            case 13:
            return s.append(QString("Du hast vergessen die abschlieenden Anfhrungszeichen zu setzen.\nWenn du mehrere Befehle pro Zeile verwendest knnte dies zu ernsthaften Fehlern fhren.\n\nLsungsmglichkeiten:\n- Setze die abschlieenden Anfhrungszeichen."));


            case 14:
            return s.append(QString("Die Funktion hat keinen Rckgabewert.\nDies kann zu Problemen fhren, muss aber nicht.\n\nLsungsmglichkeiten:\n- Benutze ein Sub. Subs haben keinen Rckgabewert."));


            case 24:
            return s.append(QString("Der Array ist zu gro fr den Stack. Dies fhrt zu ernsthaften Fehlern die normalerweise den Absturtz des Programms zur Folge haben.\n\nLsungsmglichkeiten:\n- ndere unter Projekt->Projekt Einstellungen die gre des Stacks.\n- Deklariere den Array global mit 'dim shared'."));
        }

    }
    return QString("");
}











void Compiler::gotoError(const QModelIndex & index)
{
    QString string = index.data().toString();
    QString number;
    QStringList list2;
    if (string.contains(") error ") == true)
    {
        QStringList list = string.split(") error ");
        string = list.first();
        list = string.split("(");
        number = list.last();
        list2 = number.split(")");
        number = list2.first();
        list.removeLast();
        main->openFile2(list.join("("));
        QTextCursor cur(main->getText()->text2->document());
        cur.movePosition(QTextCursor::Down,QTextCursor::MoveAnchor,number.toInt()-1);
        cur.movePosition(QTextCursor::StartOfLine);
        cur.movePosition(QTextCursor::EndOfLine,QTextCursor::KeepAnchor);
        main->getText()->text2->setTextCursor(cur);
        main->getText()->text2->setFocus();
    } else if(string.contains(") warning ") == true)
    {
        QStringList list = string.split(") warning ");
        string = list.first();
        list = string.split("(");
        number = list.last();
        list2 = number.split(")");
        number = list2.first();
        list.removeLast();
        main->openFile2(list.join("("));
        QTextCursor cur(main->getText()->text2->document());
        cur.movePosition(QTextCursor::Down,QTextCursor::MoveAnchor,number.toInt()-1);
        cur.movePosition(QTextCursor::StartOfLine);
        cur.movePosition(QTextCursor::EndOfLine,QTextCursor::KeepAnchor);
        main->getText()->text2->setTextCursor(cur);
        main->getText()->text2->setFocus();
    }
}






void Compiler::stopRun()
{
    process2->close();
    main->getStopAct()->setEnabled(false);
}








void Compiler::compile_file()
{
    fb = QString("\"").append(main->getSettings()->value("Compiler/Path").toString()).append("\"");
    QFileInfo info(main->getSettings()->value("Compiler/Path").toString());
    if (info.exists() == false)
    {
        view->clear();
        error->clear();
        warning->clear();
        problem->clear();
        view->setText(main->getSettings()->value("Lang/Compiler_Path_Error").toString());
        return;
    }
    text.clear();

    QString name = parentWindow->getManager()->projektPath;

    QString string = fb;

    string.append(" -b \"");
    int i = main->getBar()->currentIndex();
    QVariant d = main->getBar()->tabData(i);
    QString text2 = main->getPathMap()->value(d.toInt(),0);
    string.append(text2);

    QString fileName = text2;
    QStringList list1 = fileName.split(".");
    fileName = list1.first();

    fileName.append(".exe");

    string.append("\" -x ").append("\"").append(fileName).append("\"");
    string.append(" -v -maxerr inf");


    char buffer[255];
    itoa(stack,buffer,10);
    string.append(" -t ").append(buffer);


    if (ver == 1)
    {
        string.append(" -lang fb");
    } else if(ver == 2)
    {
        string.append(" -lang qb");
    } else if(ver == 3)
    {
        string.append(" -lang deprecated");
    } else if(ver == 4)
    {
        string.append(" -lang fblite");
    }


    if (arch == 1)
    {
        string.append(" -arch 386");
    } else if(arch == 2)
    {
        string.append(" -arch 486");
    } else if(arch == 3)
    {
        string.append(" -arch 586");
    } else if(arch == 4)
    {
        string.append(" -arch 686");
    }


    if (fpu == true)
    {
        string.append(" -fpu FPU");
    } else
    {
        string.append(" -fpu SSE");
    }


    if(fehler == 1)
    {
        string.append(" -e");
    } else if(fehler == 2)
    {
        string.append(" -ex");
    } else if(fehler == 3)
    {
        string.append(" -exx");
    }


    if (debug == true)
    {
        string.append(" -g");
    }


    if (thread == true)
    {
        string.append(" -mt");
    }


    if (profile == true)
    {
        string.append(" -profile");
    }


    if (console == false)
    {
        string.append(" -s gui");
    }


    if (assembler == true)
    {
        string.append(" -R");
    }


    if (object == true)
    {
        string.append(" -C");
    }


    if(typ == 2)
    {
        string.append(" -dylib");
    } else if(typ == 3)
    {
        string.append(" -lib");
    }


    if (compile == 1)
    {
        string.append(" -r");
    } else if(compile == 2)
    {
        string.append(" -c");
    }

    string.append(" -noerrline");

    string.append(" ").append(zusatz);
    string.remove(QRegExp("[\n]"));
    exe = fileName;
    view->clear();
    error->clear();
    warning->clear();
    problem->clear();
    text = string;
    text.append("\n");
    main->getErstellenAct()->setEnabled(false);
    main->getErstellenausAct()->setEnabled(false);
    main->getErstellenAct2()->setEnabled(false);
    main->getErstellenausAct2()->setEnabled(false);
    process = new QProcess;
    process->start(string);
    connect(process,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(finished(int,QProcess::ExitStatus)));



}









void Compiler::compilerun_file()
{
    fb = QString("\"").append(main->getSettings()->value("Compiler/Path").toString()).append("\"");
    QFileInfo info(main->getSettings()->value("Compiler/Path").toString());
    if (info.exists() == false)
    {
        view->clear();
        error->clear();
        warning->clear();
        problem->clear();
        view->setText(main->getSettings()->value("Lang/Compiler_Path_Error").toString());
        return;
    }
    text.clear();

    QString name = parentWindow->getManager()->projektPath;

    QString string = fb;

    string.append(" -b \"");
    int i = main->getBar()->currentIndex();
    QVariant d = main->getBar()->tabData(i);
    QString text2 = main->getPathMap()->value(d.toInt(),0);
    string.append(text2);

    QString fileName = text2;
    QStringList list1 = fileName.split(".");
    fileName = list1.first();

    fileName.append(".exe");

    string.append("\" -x ").append("\"").append(fileName).append("\"");
    string.append(" -v -maxerr inf");


    char buffer[255];
    itoa(stack,buffer,10);
    string.append(" -t ").append(buffer);


    if (ver == 1)
    {
        string.append(" -lang fb");
    } else if(ver == 2)
    {
        string.append(" -lang qb");
    } else if(ver == 3)
    {
        string.append(" -lang deprecated");
    } else if(ver == 4)
    {
        string.append(" -lang fblite");
    }


    if (arch == 1)
    {
        string.append(" -arch 386");
    } else if(arch == 2)
    {
        string.append(" -arch 486");
    } else if(arch == 3)
    {
        string.append(" -arch 586");
    } else if(arch == 4)
    {
        string.append(" -arch 686");
    }


    if (fpu == true)
    {
        string.append(" -fpu FPU");
    } else
    {
        string.append(" -fpu SSE");
    }


    if(fehler == 1)
    {
        string.append(" -e");
    } else if(fehler == 2)
    {
        string.append(" -ex");
    } else if(fehler == 3)
    {
        string.append(" -exx");
    }


    if (debug == true)
    {
        string.append(" -g");
    }


    if (thread == true)
    {
        string.append(" -mt");
    }


    if (profile == true)
    {
        string.append(" -profile");
    }


    if (console == false)
    {
        string.append(" -s gui");
    }


    if (assembler == true)
    {
        string.append(" -R");
    }


    if (object == true)
    {
        string.append(" -C");
    }


    if(typ == 2)
    {
        string.append(" -dylib");
    } else if(typ == 3)
    {
        string.append(" -lib");
    }


    if (compile == 1)
    {
        string.append(" -r");
    } else if(compile == 2)
    {
        string.append(" -c");
    }

    string.append(" -noerrline");

    string.append(" ").append(zusatz);
    string.remove(QRegExp("[\n]"));
    exe = fileName;
    view->clear();
    error->clear();
    warning->clear();
    problem->clear();
    text = string;
    text.append("\n");
    main->getErstellenAct()->setEnabled(false);
    main->getErstellenausAct()->setEnabled(false);
    main->getErstellenAct2()->setEnabled(false);
    main->getErstellenausAct2()->setEnabled(false);
    process = new QProcess;
    process->start(string);
    connect(process,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(finished2(int,QProcess::ExitStatus)));



}
