#ifndef CHECKBOX_H
#define CHECKBOX_H

#include <QtGui>

class Checkbox;

class CheckboxSizer : public QWidget
{
    Q_OBJECT
public:
    CheckboxSizer(Checkbox *lb, int t,QWidget *parent = 0);
    int typ;
    int x1, y1;
    int x4, y4;
    bool p;
    Checkbox *listbox;

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void paintEvent (QPaintEvent * event);
};



class Checkbox : public QCheckBox
{
    Q_OBJECT
public:
    Checkbox(QString t, QWidget *parent);
    QString name;
    int x;
    int y;
    int width;
    int height;
    void setOnClick(QString oc) {OnClick = oc;}
    QString getOnClick() {return OnClick;}
    void setSizer();

    QWidget *config;
    QWidget *window;

private:
    QString OnClick;
    int x1, y1;
    int x4, y4;
    bool p;
    int typ;
    CheckboxSizer *s1;
    CheckboxSizer *s2;
    CheckboxSizer *s3;
    CheckboxSizer *s4;
    CheckboxSizer *s5;
    CheckboxSizer *s6;
    CheckboxSizer *s7;
    CheckboxSizer *s8;

private slots:
    void valueChange();
    void showConf();

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseDoubleClickEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *e);
};

#endif // CHECKBOX_H
