#ifndef GUI_COMBOBOX_H
#define GUI_COMBOBOX_H

#include <QtGui>



class ComboBox;

class ComboboxSizer : public QWidget
{
    Q_OBJECT
public:
    ComboboxSizer(ComboBox *lb, int t,QWidget *parent = 0);
    int typ;
    int x1, y1;
    int x4, y4;
    bool p;
    ComboBox *listbox;

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void paintEvent (QPaintEvent * event);
};




class ComboBox : public QComboBox
{
    Q_OBJECT
public:
    ComboBox(QWidget *parent);
    QString name;
    int x;
    int y;
    int width;
    int height;
    void setOnClick(QString oc) {OnClick = oc;}
    QString getOnClick() {return OnClick;}
    void setSizer();

    QWidget *config;
    QWidget *window;

private:
    QString OnClick;
    int x1, y1;
    int x4, y4;
    bool p;
    int typ;
    ComboboxSizer *s1;
    ComboboxSizer *s2;
    ComboboxSizer *s3;
    ComboboxSizer *s4;
    ComboboxSizer *s5;
    ComboboxSizer *s6;
    ComboboxSizer *s7;
    ComboboxSizer *s8;

private slots:
    void valueChange();
    void showConf();

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseDoubleClickEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *e);
};

#endif // GUI_COMBOBOX_H
