#include "gui_comboboxconfig.h"

ComboBoxConfig::ComboBoxConfig() : QDialog()
{
    QVBoxLayout *vbox = new QVBoxLayout;




    QHBoxLayout *h1 = new QHBoxLayout;
    h1->addWidget(new QLabel("Horizontal: "));
    hspin = new QSpinBox();
    hspin->setMinimum(0);

    hspin->setValue(80);
    hslider = new QSlider(Qt::Horizontal);
    hslider->setMinimum(0);

    hslider->setValue(80);
    connect(hslider,SIGNAL(valueChanged(int)),hspin,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),hslider,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h1->addWidget(hslider);
    h1->addWidget(hspin);
    vbox->addLayout(h1);


    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addWidget(new QLabel("Vertical: "));
    vspin = new QSpinBox();
    vspin->setMinimum(0);

    vspin->setValue(30);
    vslider = new QSlider(Qt::Horizontal);
    vslider->setMinimum(0);

    vslider->setValue(30);
    connect(vslider,SIGNAL(valueChanged(int)),vspin,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),vslider,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h2->addWidget(vslider);
    h2->addWidget(vspin);
    vbox->addLayout(h2);


    QHBoxLayout *h4 = new QHBoxLayout;
    h4->addWidget(new QLabel("X: "));
    xspin = new QSpinBox();
    xspin->setMinimum(0);

    xslider = new QSlider(Qt::Horizontal);
    xslider->setMinimum(0);

    connect(xslider,SIGNAL(valueChanged(int)),xspin,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),xslider,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h4->addWidget(xslider);
    h4->addWidget(xspin);
    vbox->addLayout(h4);


    QHBoxLayout *h5 = new QHBoxLayout;
    h5->addWidget(new QLabel("Y: "));
    yspin = new QSpinBox();
    yspin->setMinimum(0);
    yslider = new QSlider(Qt::Horizontal);
    yslider->setMinimum(0);

    connect(yslider,SIGNAL(valueChanged(int)),yspin,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),yslider,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h5->addWidget(yslider);
    h5->addWidget(yspin);
    vbox->addLayout(h5);


    QHBoxLayout *h6 = new QHBoxLayout;
    h6->addWidget(new QLabel("OnClick: "));
    text3 = new QLineEdit();
    connect(text3,SIGNAL(textChanged(QString)),this,SLOT(onClickChange()));
    h6->addWidget(text3);
    vbox->addLayout(h6);

    QHBoxLayout *h7 = new QHBoxLayout;
    h7->addStretch();
    QPushButton *button = new QPushButton("OK");
    connect(button,SIGNAL(clicked()),this,SLOT(ok()));
    h7->addWidget(button);
    vbox->addLayout(h7);

    setLayout(vbox);
}








void ComboBoxConfig::valueChange()
{
    button->setOnClick(text3->text());
    button->resize(hspin->value(),vspin->value());
    button->move(xspin->value(),yspin->value());
}



void ComboBoxConfig::textChange()
{

}


void ComboBoxConfig::onClickChange()
{
    button->setOnClick(text3->text());

}




void ComboBoxConfig::closeEvent(QCloseEvent *event)
{
    delete this;
}




void ComboBoxConfig::ok()
{
    closeEvent(new QCloseEvent());
}
