#include "gui_config.h"
#include "mainwindow.h"
#include "gui_mainwindow2.h"
extern MainWindow *main_window;
extern MainWindow2 *gui;

Config::Config(int t) : QDialog()
{
    typ = t;
    QVBoxLayout *vbox = new QVBoxLayout;

    if (t == 1 || t == 2 || t == 4 || t == 5 || t == 7)
    {
        QHBoxLayout *h3 = new QHBoxLayout;
        h3->addWidget(new QLabel(main_window->getSettings()->value("Lang/Designer_Dialog_Beschriftung").toString()));
        text2 = new QLineEdit();
        connect(text2,SIGNAL(textChanged(QString)),this,SLOT(textChange()));
        h3->addWidget(text2);
        vbox->addLayout(h3);
    } else if (t == 0)
    {
        QHBoxLayout *h3 = new QHBoxLayout;
        h3->addWidget(new QLabel(main_window->getSettings()->value("Lang/Designer_Dialog_Titel").toString()));
        text2 = new QLineEdit();
        connect(text2,SIGNAL(textChanged(QString)),this,SLOT(textChange()));
        h3->addWidget(text2);
        vbox->addLayout(h3);
    }


    QHBoxLayout *h1 = new QHBoxLayout;
    h1->addWidget(new QLabel(main_window->getSettings()->value("Lang/Designer_Dialog_H").toString()));
    hspin = new QSpinBox();
    hspin->setMinimum(0);

    hspin->setValue(80);
    hslider = new QSlider(Qt::Horizontal);
    hslider->setMinimum(0);

    hslider->setValue(80);
    connect(hslider,SIGNAL(valueChanged(int)),hspin,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),hslider,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h1->addWidget(hslider);
    h1->addWidget(hspin);
    vbox->addLayout(h1);


    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addWidget(new QLabel(main_window->getSettings()->value("Lang/Designer_Dialog_V").toString()));
    vspin = new QSpinBox();
    vspin->setMinimum(0);

    vspin->setValue(30);
    vslider = new QSlider(Qt::Horizontal);
    vslider->setMinimum(0);

    vslider->setValue(30);
    connect(vslider,SIGNAL(valueChanged(int)),vspin,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),vslider,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h2->addWidget(vslider);
    h2->addWidget(vspin);
    vbox->addLayout(h2);


    QHBoxLayout *h4 = new QHBoxLayout;
    h4->addWidget(new QLabel("X: "));
    xspin = new QSpinBox();
    xspin->setMinimum(0);

    xslider = new QSlider(Qt::Horizontal);
    xslider->setMinimum(0);

    connect(xslider,SIGNAL(valueChanged(int)),xspin,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),xslider,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h4->addWidget(xslider);
    h4->addWidget(xspin);
    vbox->addLayout(h4);


    QHBoxLayout *h5 = new QHBoxLayout;
    h5->addWidget(new QLabel("Y: "));
    yspin = new QSpinBox();
    yspin->setMinimum(0);
    yslider = new QSlider(Qt::Horizontal);
    yslider->setMinimum(0);

    connect(yslider,SIGNAL(valueChanged(int)),yspin,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),yslider,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h5->addWidget(yslider);
    h5->addWidget(yspin);
    vbox->addLayout(h5);


    if (typ == 0)
    {
        QHBoxLayout *h6 = new QHBoxLayout;
        h6->addWidget(new QLabel("OnPaint: "));
        text3 = new QLineEdit();
        connect(text3,SIGNAL(textChanged(QString)),this,SLOT(onPaintChange()));
        h6->addWidget(text3);
        vbox->addLayout(h6);

        QHBoxLayout *h10 = new QHBoxLayout;
        h10->addWidget(new QLabel("OnResize: "));
        text4 = new QLineEdit();
        connect(text4,SIGNAL(textChanged(QString)),this,SLOT(onResizeChange()));
        h10->addWidget(text4);
        vbox->addLayout(h10);

        QHBoxLayout *h11 = new QHBoxLayout;
        h11->addWidget(new QLabel("OnMove: "));
        text5 = new QLineEdit();
        connect(text5,SIGNAL(textChanged(QString)),this,SLOT(onMoveChange()));
        h11->addWidget(text5);
        vbox->addLayout(h11);

        QHBoxLayout *h12 = new QHBoxLayout;
        h12->addWidget(new QLabel("OnClose: "));
        text6 = new QLineEdit();
        connect(text6,SIGNAL(textChanged(QString)),this,SLOT(onCloseChange()));
        h12->addWidget(text6);
        vbox->addLayout(h12);
    }
    if (typ == 1 || typ == 2)
    {
        QHBoxLayout *h6 = new QHBoxLayout;
        h6->addWidget(new QLabel("OnClick: "));
        text3 = new QLineEdit();
        connect(text3,SIGNAL(textChanged(QString)),this,SLOT(onClickChange()));
        h6->addWidget(text3);
        vbox->addLayout(h6);
    }
    else if (typ == 4 || typ == 5 || typ == 7)
    {
        QHBoxLayout *h6 = new QHBoxLayout;
        h6->addWidget(new QLabel("OnChange: "));
        text3 = new QLineEdit();
        connect(text3,SIGNAL(textChanged(QString)),this,SLOT(onChangeChange()));
        h6->addWidget(text3);
        vbox->addLayout(h6);

        pw = new QCheckBox(main_window->getSettings()->value("Lang/Designer_Dialog_Passwort").toString());
        connect(pw,SIGNAL(clicked()),this,SLOT(valueChange()));
        vbox->addWidget(pw);
        number = new QCheckBox(main_window->getSettings()->value("Lang/Designer_Dialog_NurZahlen").toString());
        connect(number,SIGNAL(clicked()),this,SLOT(valueChange()));
        vbox->addWidget(number);
    }

    QHBoxLayout *h7 = new QHBoxLayout;
    h7->addStretch();
    QPushButton *button = new QPushButton("OK");
    connect(button,SIGNAL(clicked()),this,SLOT(ok()));
    h7->addWidget(button);
    vbox->addLayout(h7);

    setLayout(vbox);

    sub = new QMdiSubWindow;
    sub->setWidget(this);
    gui->getArea()->addSubWindow(sub);
}








void Config::valueChange()
{
    if (typ == 0)
    {
        window->setWindowTitle(text2->text());
        window->resize(hspin->value(),vspin->value());
        window->move(xspin->value(),yspin->value());
    }
    else if (typ == 1)
    {
        button->setOnClick(text3->text());
        button->setText(text2->text());
        button->resize(hspin->value(),vspin->value());
        button->move(xspin->value(),yspin->value());
    }
    else if (typ == 2)
    {
        checkbox->setOnClick(text3->text());
        checkbox->setText(text2->text());
        checkbox->resize(hspin->value(),vspin->value());
        checkbox->move(xspin->value(),yspin->value());
    } else if (typ == 3)
    {
        combo->resize(hspin->value(),vspin->value());
        combo->move(xspin->value(),yspin->value());
    } else if (typ == 4)
    {
        edit->setText(text2->text());
        edit->resize(hspin->value(),vspin->value());
        edit->move(xspin->value(),yspin->value());
        edit->password = pw->isChecked();
        edit->number = number->isChecked();
    } else if (typ == 5)
    {
        textedit->setText(text2->text());
        textedit->resize(hspin->value(),vspin->value());
        textedit->move(xspin->value(),yspin->value());
        textedit->password = pw->isChecked();
        textedit->number = number->isChecked();
    } else if (typ == 6)
    {
        listbox->resize(hspin->value(),vspin->value());
        listbox->move(xspin->value(),yspin->value());
    } else if (typ == 7)
    {
        richedit->setText(text2->text());
        richedit->resize(hspin->value(),vspin->value());
        richedit->move(xspin->value(),yspin->value());
        richedit->password = pw->isChecked();
        richedit->number = number->isChecked();
    }
}



void Config::textChange()
{
    if (typ == 0)
    {
        window->setWindowTitle(text2->text());
    }
    else if (typ == 1)
    {
        button->setText(text2->text());
    }
    else if (typ == 2)
    {
        checkbox->setText(text2->text());
    }
    else if (typ == 4)
    {
        edit->setText(text2->text());
    }
    else if (typ == 5)
    {
        textedit->setText(text2->text());
    } else if (typ == 7)
    {
        textedit->setText(text2->text());
    }
}


void Config::onClickChange()
{
    if (typ == 1)
    {
        button->setOnClick(text3->text());
    }
    if (typ == 2)
    {
        checkbox->setOnClick(text3->text());
    }
    if (typ == 3)
    {
    }
}




void Config::onChangeChange()
{
    if (typ == 4)
    {
        edit->onChange = text3->text();
    } else if(typ == 5)
    {
        textedit->onChange = text3->text();
    } else if(typ == 7)
    {
        textedit->onChange = text3->text();
    }
}




void Config::closeEvent(QCloseEvent *event)
{
    delete this;
}




void Config::onPaintChange()
{
    window->onpaint = text3->text();
}


void Config::onMoveChange()
{
    window->onmove = text5->text();
}



void Config::onResizeChange()
{
    window->onresize = text4->text();
}



void Config::onCloseChange()
{
    window->onclose = text6->text();
}



void Config::ok()
{
    closeEvent(new QCloseEvent());
    delete sub;
}
