#ifndef CONFIG_H
#define CONFIG_H

#include <QtGui>
#include <QScrollArea>
#include "gui_window.h"
#include "gui_pushbutton.h"
#include "gui_checkbox.h"
#include "gui_lineedit.h"
#include "gui_multilineedit.h"
#include "gui_combobox.h"
#include "gui_listbox.h"
#include "gui_richedit.h"


class Config : public QDialog
{
    Q_OBJECT
public:
    Config(int t);
    QWidget *buttons;

    QSpinBox *vspin;
    QSpinBox *hspin;
    QSpinBox *xspin;
    QSpinBox *yspin;
    QSlider *vslider;
    QSlider *hslider;
    QSlider *xslider;
    QSlider *yslider;
    QLineEdit *text2;
    QLineEdit *text3;
    QLineEdit *text4;
    QLineEdit *text5;
    QLineEdit *text6;
    QMdiSubWindow *sub;

    QCheckBox *pw;
    QCheckBox *number;

    int typ;
    Window *window;
    PushButton *button;
    Checkbox *checkbox;
    ComboBox *combo;
    MultiLineEdit *textedit;
    LineEdit *edit;
    Listbox *listbox;
    RichEdit *richedit;
private slots:
    void valueChange();
    void onClickChange();
    void onChangeChange();
    void onPaintChange();
    void onMoveChange();
    void onResizeChange();
    void onCloseChange();
    void textChange();
    void ok();

protected:
    void closeEvent(QCloseEvent *event);
};

#endif // CONFIG_H
