#include <QtGui>
#include "gui_createbuttondialog.h"
#include "mainwindow.h"

extern QWindowsStyle *winStyle;
extern MainWindow *main_window;

CreateButtonDialog::CreateButtonDialog(int t, Window *window)
        : QDialog()
{
    typ = t;
    bOK = false;
    resize(350,0);
    QVBoxLayout *vbox = new QVBoxLayout;

    QHBoxLayout *h6 = new QHBoxLayout;
    h6->addWidget(new QLabel(main_window->getSettings()->value("Lang/Designer_Dialog_Name").toString()));
    name = new QLineEdit();
    connect(name,SIGNAL(textChanged(QString)),this,SLOT(valueChange()));
    h6->addWidget(name);
    vbox->addLayout(h6);

    if (typ == 1 || typ == 2 || typ == 4 || typ == 5 || typ == 7)
    {
        QHBoxLayout *h3 = new QHBoxLayout;
        h3->addWidget(new QLabel(main_window->getSettings()->value("Lang/Designer_Dialog_Beschriftung").toString()));
        text = new QLineEdit();
        connect(text,SIGNAL(textChanged(QString)),this,SLOT(valueChange()));
        h3->addWidget(text);
        vbox->addLayout(h3);
    }


    QHBoxLayout *h1 = new QHBoxLayout;
    h1->addWidget(new QLabel(main_window->getSettings()->value("Lang/Designer_Dialog_H").toString()));
    hspin = new QSpinBox();
    hspin->setMinimum(0);
    hspin->setMaximum(window->size().width());
    hspin->setValue(80);
    hslider = new QSlider(Qt::Horizontal);
    hslider->setMinimum(0);
    hslider->setMaximum(window->size().width());
    hslider->setValue(80);
    connect(hslider,SIGNAL(valueChanged(int)),hspin,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),hslider,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h1->addWidget(hslider);
    h1->addWidget(hspin);
    vbox->addLayout(h1);


    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addWidget(new QLabel(main_window->getSettings()->value("Lang/Designer_Dialog_V").toString()));
    vspin = new QSpinBox();
    vspin->setMinimum(0);
    vspin->setMaximum(window->size().height());
    vspin->setValue(30);
    vslider = new QSlider(Qt::Horizontal);
    vslider->setMinimum(0);
    vslider->setMaximum(window->size().height());
    vslider->setValue(30);
    connect(vslider,SIGNAL(valueChanged(int)),vspin,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),vslider,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h2->addWidget(vslider);
    h2->addWidget(vspin);
    vbox->addLayout(h2);


    QHBoxLayout *h4 = new QHBoxLayout;
    h4->addWidget(new QLabel("X: "));
    xspin = new QSpinBox();
    xspin->setMinimum(0);
    xspin->setMaximum(window->size().width()-1);
    xslider = new QSlider(Qt::Horizontal);
    xslider->setMinimum(0);
    xslider->setMaximum(window->size().width()-1);
    connect(xslider,SIGNAL(valueChanged(int)),xspin,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),xslider,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h4->addWidget(xslider);
    h4->addWidget(xspin);
    vbox->addLayout(h4);


    QHBoxLayout *h5 = new QHBoxLayout;
    h5->addWidget(new QLabel("Y: "));
    yspin = new QSpinBox();
    yspin->setMinimum(0);
    yspin->setMaximum(window->size().height()-1);
    yslider = new QSlider(Qt::Horizontal);
    yslider->setMinimum(0);
    yslider->setMaximum(window->size().height()-1);
    connect(yslider,SIGNAL(valueChanged(int)),yspin,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),yslider,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h5->addWidget(yslider);
    h5->addWidget(yspin);
    vbox->addLayout(h5);


    QHBoxLayout *hb = new QHBoxLayout;
    QPushButton *ok = new QPushButton("OK");
    connect(ok,SIGNAL(clicked()),this,SLOT(OK()));
    hb->addStretch();
    hb->addWidget(ok);
    vbox->addLayout(hb);

    if (typ == 1)
    {
        button = new QPushButton(text->text(),window);
        button->resize(hspin->value(),vspin->value());
        button->move(xspin->value(),yspin->value());
        button->setStyle(winStyle);
        button->show();
        char buffer[255];
        sprintf(buffer,"%d",window->buttonList.count());
        name->setText(QString("Button").append(buffer));
    } else if (typ == 2)
    {
        checkbox = new QCheckBox(text->text(),window);
        vspin->setValue(checkbox->size().height());
        hspin->setValue(100);
        checkbox->move(xspin->value(),yspin->value());
        checkbox->setStyle(winStyle);
        checkbox->show();
        char buffer[255];
        sprintf(buffer,"%d",window->checkList.count());
        name->setText(QString("Checkbox").append(buffer));
    } else if (typ == 3)
    {
        combo = new QComboBox(window);
        vspin->setValue(combo->size().height());
        hspin->setValue(100);
        combo->move(xspin->value(),yspin->value());
        combo->setStyle(winStyle);
        combo->show();
        char buffer[255];
        sprintf(buffer,"%d",window->comboboxList.count());
        name->setText(QString("Combobox").append(buffer));
    } else if (typ == 4)
    {
        edit = new QLineEdit(text->text(),window);
        vspin->setValue(20);
        hspin->setValue(100);
        edit->move(xspin->value(),yspin->value());
        edit->setStyle(winStyle);
        edit->show();
        char buffer[255];
        sprintf(buffer,"%d",window->lineeditList.count());
        name->setText(QString("LEdit").append(buffer));
    } else if (typ == 5)
    {
        textedit = new QTextEdit(text->text(),window);
        vspin->setValue(20);
        hspin->setValue(100);
        textedit->move(xspin->value(),yspin->value());
        textedit->setStyle(winStyle);
        textedit->show();
        char buffer[255];
        sprintf(buffer,"%d",window->multilineeditList.count());
        name->setText(QString("MLEdit").append(buffer));
    } else if (typ == 6)
    {
        listbox = new QListView(window);
        vspin->setValue(20);
        hspin->setValue(100);
        listbox->move(xspin->value(),yspin->value());
        listbox->setStyle(winStyle);
        listbox->show();
        char buffer[255];
        sprintf(buffer,"%d",window->listboxList.count());
        name->setText(QString("Listbox").append(buffer));
    } else if (typ == 7)
    {
        richedit = new QTextEdit(text->text(),window);
        vspin->setValue(20);
        hspin->setValue(100);
        richedit->move(xspin->value(),yspin->value());
        richedit->setStyle(winStyle);
        richedit->show();
        char buffer[255];
        sprintf(buffer,"%d",window->richeditList.count());
        name->setText(QString("Richedit").append(buffer));
    }
    setLayout(vbox);
}







void CreateButtonDialog::OK()
{
    bOK = true;
    done(0);
}






void CreateButtonDialog::valueChange()
{
    if (typ == 1)
    {
        button->setText(text->text());
        button->resize(hspin->value(),vspin->value());
        button->move(xspin->value(),yspin->value());
    } else if (typ == 2)
    {
        checkbox->setText(text->text());
        checkbox->resize(hspin->value(),vspin->value());
        checkbox->move(xspin->value(),yspin->value());
    } else if (typ == 3)
    {
        combo->resize(hspin->value(),vspin->value());
        combo->move(xspin->value(),yspin->value());
    } else if (typ == 4)
    {
        edit->setText(text->text());
        edit->resize(hspin->value(),vspin->value());
        edit->move(xspin->value(),yspin->value());
    } else if (typ == 5)
    {
        textedit->setText(text->text());
        textedit->resize(hspin->value(),vspin->value());
        textedit->move(xspin->value(),yspin->value());
    } else if (typ == 6)
    {
        listbox->resize(hspin->value(),vspin->value());
        listbox->move(xspin->value(),yspin->value());
    } else if (typ == 7)
    {
        richedit->setText(text->text());
        richedit->resize(hspin->value(),vspin->value());
        richedit->move(xspin->value(),yspin->value());
    }
}
