#include "gui_createlineeditdialog.h"
#include <QtGui>

extern QWindowsStyle *winStyle;

CreateLineEditDialog::CreateLineEditDialog(QWidget *window)
        : QDialog()
{
    bOK = false;
    resize(350,0);
    QVBoxLayout *vbox = new QVBoxLayout;

    QHBoxLayout *h3 = new QHBoxLayout;
    h3->addWidget(new QLabel("Beschriftung: "));
    text = new QLineEdit();
    connect(text,SIGNAL(textChanged(QString)),this,SLOT(valueChange()));
    h3->addWidget(text);
    vbox->addLayout(h3);



    QHBoxLayout *h1 = new QHBoxLayout;
    h1->addWidget(new QLabel("Horizontal: "));
    hspin = new QSpinBox();
    hspin->setMinimum(0);
    hspin->setMaximum(window->size().width());
    hslider = new QSlider(Qt::Horizontal);
    hslider->setMinimum(0);
    hslider->setMaximum(window->size().width());
    connect(hslider,SIGNAL(valueChanged(int)),hspin,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),hslider,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h1->addWidget(hslider);
    h1->addWidget(hspin);
    vbox->addLayout(h1);


    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addWidget(new QLabel("Vertical: "));
    vspin = new QSpinBox();
    vspin->setMinimum(0);
    vspin->setMaximum(window->size().height());
    vslider = new QSlider(Qt::Horizontal);
    vslider->setMinimum(0);
    vslider->setMaximum(window->size().height());
    connect(vslider,SIGNAL(valueChanged(int)),vspin,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),vslider,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h2->addWidget(vslider);
    h2->addWidget(vspin);
    vbox->addLayout(h2);


    QHBoxLayout *h4 = new QHBoxLayout;
    h4->addWidget(new QLabel("X: "));
    xspin = new QSpinBox();
    xspin->setMinimum(0);
    xspin->setMaximum(window->size().width()-1);
    xslider = new QSlider(Qt::Horizontal);
    xslider->setMinimum(0);
    xslider->setMaximum(window->size().width()-1);
    connect(xslider,SIGNAL(valueChanged(int)),xspin,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),xslider,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h4->addWidget(xslider);
    h4->addWidget(xspin);
    vbox->addLayout(h4);


    QHBoxLayout *h5 = new QHBoxLayout;
    h5->addWidget(new QLabel("Y: "));
    yspin = new QSpinBox();
    yspin->setMinimum(0);
    yspin->setMaximum(window->size().height()-1);
    yslider = new QSlider(Qt::Horizontal);
    yslider->setMinimum(0);
    yslider->setMaximum(window->size().height()-1);
    connect(yslider,SIGNAL(valueChanged(int)),yspin,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),yslider,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h5->addWidget(yslider);
    h5->addWidget(yspin);
    vbox->addLayout(h5);


    QHBoxLayout *hb = new QHBoxLayout;
    QPushButton *ok = new QPushButton("OK");
    connect(ok,SIGNAL(clicked()),this,SLOT(OK()));
    hb->addStretch();
    hb->addWidget(ok);
    vbox->addLayout(hb);

    button = new QLineEdit(text->text(),window);
    vspin->setValue(20);
    hspin->setValue(100);
    button->move(xspin->value(),yspin->value());
    button->setStyle(winStyle);
    button->show();
    setLayout(vbox);
}







void CreateLineEditDialog::OK()
{
    bOK = true;
    done(0);
}






void CreateLineEditDialog::valueChange()
{
    button->setText(text->text());
    button->resize(hspin->value(),vspin->value());
    button->move(xspin->value(),yspin->value());
}
