#ifndef LINEEDIT_H
#define LINEEDIT_H

#include <QtGui>


class LineEdit;

class LineEditSizer : public QWidget
{
    Q_OBJECT
public:
    LineEditSizer(LineEdit *lb, int t,QWidget *parent = 0);
    int typ;
    int x1, y1;
    int x4, y4;
    bool p;
    LineEdit *listbox;

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void paintEvent (QPaintEvent * event);
};




class LineEdit : public QLineEdit
{
    Q_OBJECT
public:
    LineEdit(QString t, QWidget *parent);
    QString name;
    int x;
    int y;
    int width;
    int height;
    bool password;
    bool number;

    void setSizer();

    QWidget *config;
    QWidget *window;

    QString onChange;

private:
    int x1, y1;
    int x4, y4;
    bool p;
    int typ;
    LineEditSizer *s1;
    LineEditSizer *s2;
    LineEditSizer *s3;
    LineEditSizer *s4;
    LineEditSizer *s5;
    LineEditSizer *s6;
    LineEditSizer *s7;
    LineEditSizer *s8;

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseDoubleClickEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *e);


private slots:
    void valueChange();
    void showConf();
};

#endif // LINEEDIT_H
