#include "gui_lineeditconfig.h"
#include <QtGui>

LineEditConfig::LineEditConfig() : QDialog()
{
    QVBoxLayout *vbox = new QVBoxLayout;

    QHBoxLayout *h3 = new QHBoxLayout;
    h3->addWidget(new QLabel("Beschriftung: "));
    text2 = new QLineEdit();
    connect(text2,SIGNAL(textChanged(QString)),this,SLOT(textChange()));
    h3->addWidget(text2);
    vbox->addLayout(h3);



    QHBoxLayout *h1 = new QHBoxLayout;
    h1->addWidget(new QLabel("Horizontal: "));
    hspin = new QSpinBox();
    hspin->setMinimum(0);

    hspin->setValue(80);
    hslider = new QSlider(Qt::Horizontal);
    hslider->setMinimum(0);

    hslider->setValue(80);
    connect(hslider,SIGNAL(valueChanged(int)),hspin,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),hslider,SLOT(setValue(int)));
    connect(hspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h1->addWidget(hslider);
    h1->addWidget(hspin);
    vbox->addLayout(h1);


    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addWidget(new QLabel("Vertical: "));
    vspin = new QSpinBox();
    vspin->setMinimum(0);

    vspin->setValue(30);
    vslider = new QSlider(Qt::Horizontal);
    vslider->setMinimum(0);

    vslider->setValue(30);
    connect(vslider,SIGNAL(valueChanged(int)),vspin,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),vslider,SLOT(setValue(int)));
    connect(vspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h2->addWidget(vslider);
    h2->addWidget(vspin);
    vbox->addLayout(h2);


    QHBoxLayout *h4 = new QHBoxLayout;
    h4->addWidget(new QLabel("X: "));
    xspin = new QSpinBox();
    xspin->setMinimum(0);

    xslider = new QSlider(Qt::Horizontal);
    xslider->setMinimum(0);

    connect(xslider,SIGNAL(valueChanged(int)),xspin,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),xslider,SLOT(setValue(int)));
    connect(xspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h4->addWidget(xslider);
    h4->addWidget(xspin);
    vbox->addLayout(h4);


    QHBoxLayout *h5 = new QHBoxLayout;
    h5->addWidget(new QLabel("Y: "));
    yspin = new QSpinBox();
    yspin->setMinimum(0);
    yslider = new QSlider(Qt::Horizontal);
    yslider->setMinimum(0);

    connect(yslider,SIGNAL(valueChanged(int)),yspin,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),yslider,SLOT(setValue(int)));
    connect(yspin,SIGNAL(valueChanged(int)),this,SLOT(valueChange()));
    h5->addWidget(yslider);
    h5->addWidget(yspin);
    vbox->addLayout(h5);


    QHBoxLayout *h6 = new QHBoxLayout;
    h6->addWidget(new QLabel("OnChange: "));
    text3 = new QLineEdit();
    connect(text3,SIGNAL(textChanged(QString)),this,SLOT(onChangeChange()));
    h6->addWidget(text3);
    vbox->addLayout(h6);

    pw = new QCheckBox("Passwort Feld");
    connect(pw,SIGNAL(clicked()),this,SLOT(valueChange()));
    vbox->addWidget(pw);
    number = new QCheckBox("Nur Zahlen erlauben");
    connect(number,SIGNAL(clicked()),this,SLOT(valueChange()));
    vbox->addWidget(number);

    QHBoxLayout *h7 = new QHBoxLayout;
    h7->addStretch();
    QPushButton *button = new QPushButton("OK");
    connect(button,SIGNAL(clicked()),this,SLOT(ok()));
    h7->addWidget(button);
    vbox->addLayout(h7);

    setLayout(vbox);
}








void LineEditConfig::valueChange()
{
    button->setText(text2->text());
    button->resize(hspin->value(),vspin->value());
    button->move(xspin->value(),yspin->value());
    button->password = pw->isChecked();
    button->number = number->isChecked();
}



void LineEditConfig::textChange()
{
    button->setText(text2->text());

}


void LineEditConfig::onChangeChange()
{
    button->onChange = text3->text();
}




void LineEditConfig::closeEvent(QCloseEvent *event)
{
    delete this;
}




void LineEditConfig::ok()
{
    closeEvent(new QCloseEvent());
}
