#ifndef GUI_LISTBOX_H
#define GUI_LISTBOX_H

#include <QtGui>

class Listbox;

class ListboxSizer : public QWidget
{
    Q_OBJECT
public:
    ListboxSizer(Listbox *lb, int t,QWidget *parent = 0);
    int typ;
    int x1, y1;
    int x4, y4;
    bool p;
    Listbox *listbox;

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void paintEvent (QPaintEvent * event);
};






class Listbox : public QListView
{
    Q_OBJECT
public:
    Listbox(QWidget *parent);
    QString name;
    int x;
    int y;
    int width;
    int height;
    void setOnClick(QString oc) {OnClick = oc;}
    QString getOnClick() {return OnClick;}
    void setSizer();

    QWidget *config;
    QWidget *window;

private:
    QString OnClick;
    int x1, y1;
    int x4, y4;
    bool p;
    int typ;
    ListboxSizer *s1;
    ListboxSizer *s2;
    ListboxSizer *s3;
    ListboxSizer *s4;
    ListboxSizer *s5;
    ListboxSizer *s6;
    ListboxSizer *s7;
    ListboxSizer *s8;

private slots:
    void valueChange();
    void showConf();

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseDoubleClickEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *e);
};





#endif // GUI_LISTBOX_H
