#include <QtGui>
#include <stdio.h>
#include "mainwindow.h"
#include "gui_mainwindow2.h"
#include "gui_window.h"
#include "gui_createbuttondialog.h"

#include "gui_config.h"

extern QWindowsStyle *winStyle;

MainWindow2::MainWindow2(MainWindow *main, int tabIndex, QWidget *parent)
    : QMainWindow(parent)
{
    win = new Window();
    this->main = main;

    if (main->getTab() == false)
    {
        connect(main->getBar(),SIGNAL(currentChanged(int)),main,SLOT(tabChange(int)));
        main->setTab(true);
    }
    int index = main->getBar()->addTab("Gui Designer");
    main->getTypMap()->insert(tabIndex, 3);
    main->getBar()->setTabData(index,QVariant(tabIndex));
    main->getBar()->setCurrentIndex(index);
    main->tabChange(index);
    area = new QMdiArea;
    main->setArea(area);
    main->getV()->addWidget(area);

    QVBoxLayout *vbox = new QVBoxLayout;
    QPushButton *window_button = new QPushButton(main->getSettings()->value("Lang/Designer_NewWindow").toString());
    vbox->addWidget(window_button);

    QPushButton *button_button = new QPushButton(main->getSettings()->value("Lang/Designer_NewButton").toString());
    vbox->addWidget(button_button);
    connect(button_button,SIGNAL(clicked()),this,SLOT(createButton()));

    QPushButton *button_check = new QPushButton(main->getSettings()->value("Lang/Designer_NewCheckbox").toString());
    vbox->addWidget(button_check);
    connect(button_check,SIGNAL(clicked()),this,SLOT(createCheckbox()));

    QPushButton *button_lineedit = new QPushButton(main->getSettings()->value("Lang/Designer_NewLineedit").toString());
    vbox->addWidget(button_lineedit);
    connect(button_lineedit,SIGNAL(clicked()),this,SLOT(createLineEdit()));

    QPushButton *button_multilineedit = new QPushButton(main->getSettings()->value("Lang/Designer_NewMultilineedit").toString());
    vbox->addWidget(button_multilineedit);
    connect(button_multilineedit,SIGNAL(clicked()),this,SLOT(createMultiLineEdit()));

    QPushButton *button_richedit = new QPushButton(main->getSettings()->value("Lang/Designer_NewRichedit").toString());
    vbox->addWidget(button_richedit);
    connect(button_richedit,SIGNAL(clicked()),this,SLOT(createRichEdit()));


    QPushButton *button_combobox = new QPushButton(main->getSettings()->value("Lang/Designer_NewCombobox").toString());
    vbox->addWidget(button_combobox);
    connect(button_combobox,SIGNAL(clicked()),this,SLOT(createComboBox()));

    QPushButton *button_listbox = new QPushButton(main->getSettings()->value("Lang/Designer_NewListbox").toString());
    vbox->addWidget(button_listbox);
    connect(button_listbox,SIGNAL(clicked()),this,SLOT(createListBox()));


    QWidget *widget = new QWidget;
    widget->setLayout(vbox);
    setCentralWidget(widget);

    id = 0;
    menu();

    QMdiSubWindow *sub = new QMdiSubWindow;
    sub->setWidget(this);
    area->addSubWindow(sub);

    QMdiSubWindow *sub2 = new QMdiSubWindow;
    sub2->setWidget(win);
    sub2->setStyle(winStyle);
    area->addSubWindow(sub2);
    sub2->resize(320,280);
}

MainWindow2::~MainWindow2()
{

}



MainWindow2::MainWindow2(QString file, MainWindow *main, QWidget *parent)
    : QMainWindow(parent)
{
    win = new Window();
    win->show();
    this->main = main;

    QVBoxLayout *vbox = new QVBoxLayout;
    QPushButton *window_button = new QPushButton(main->getSettings()->value("Lang/Designer_NewWindow").toString());
    vbox->addWidget(window_button);

    QPushButton *button_button = new QPushButton(main->getSettings()->value("Lang/Designer_NewButton").toString());
    vbox->addWidget(button_button);
    connect(button_button,SIGNAL(clicked()),this,SLOT(createButton()));

    QPushButton *button_check = new QPushButton(main->getSettings()->value("Lang/Designer_NewCheckbox").toString());
    vbox->addWidget(button_check);
    connect(button_check,SIGNAL(clicked()),this,SLOT(createCheckbox()));

    QPushButton *button_lineedit = new QPushButton(main->getSettings()->value("Lang/Designer_NewLineedit").toString());
    vbox->addWidget(button_lineedit);
    connect(button_lineedit,SIGNAL(clicked()),this,SLOT(createLineEdit()));

    QPushButton *button_multilineedit = new QPushButton(main->getSettings()->value("Lang/Designer_NewMultilineedit").toString());
    vbox->addWidget(button_multilineedit);
    connect(button_multilineedit,SIGNAL(clicked()),this,SLOT(createMultiLineEdit()));

    QPushButton *button_richedit = new QPushButton(main->getSettings()->value("Lang/Designer_NewRichedit").toString());
    vbox->addWidget(button_richedit);
    connect(button_richedit,SIGNAL(clicked()),this,SLOT(createRichEdit()));


    QPushButton *button_combobox = new QPushButton(main->getSettings()->value("Lang/Designer_NewCombobox").toString());
    vbox->addWidget(button_combobox);
    connect(button_combobox,SIGNAL(clicked()),this,SLOT(createComboBox()));

    QPushButton *button_listbox = new QPushButton(main->getSettings()->value("Lang/Designer_NewListbox").toString());
    vbox->addWidget(button_listbox);
    connect(button_listbox,SIGNAL(clicked()),this,SLOT(createListBox()));

    QWidget *widget = new QWidget;
    widget->setLayout(vbox);
    setCentralWidget(widget);

    id = 0;
    menu();


    QFile f(file);
    f.open(QIODevice::ReadOnly | QIODevice::Text);

    QString code = f.readAll();
    int s = 0;
    s = code.indexOf("function WinMain (",Qt::CaseInsensitive);
    int e = code.indexOf("end function",s,Qt::CaseInsensitive);
    code = code.mid(s,e-s);
    QStringList lines = code.split("\n");
    for (int i = 0;lines.count() > i;i++)
    {
        if (true == lines[i].contains("= Button(",Qt::CaseInsensitive))
        {
            QString label;
            QRegExp ex("\"");
            QRegExp ex2("\"\"");
            int start = 0;
            int start2;
            int end;
            int end2;
            for(;;)
            {
                start = ex.indexIn(lines[i],start);
                start2 = start;
                if (start != -1)
                {
                    for (;;)
                    {
                        end = ex.indexIn(lines[i],start2+1);
                        end2 = ex2.indexIn(lines[i],start2+1);

                        if (end2 != -1)
                        {
                            end = end2+1;
                            break;
                        }
                        if (lines[i].mid(end-1,1) == "\\")
                        {
                            start2 = end+1;
                            continue;
                        }
                        break;
                    }
                    if (end != -1)
                    {
                        label = lines[i].mid(start,end-start+1);
                        lines[i].remove(start,end-start+1);
                        start = start + (end-start+1);
                    }  else
                    {
                        break;
                    }
                }
                if (start == -1)
                {
                    break;
                }
            }
            s = lines[i].indexOf("= Button(",0,Qt::CaseInsensitive);
            s = s+9;
            e = lines[i].indexOf(")",s);
            QStringList list = lines[i].mid(s,e-s).split(",");
            if (list.count() > 3)
            {
                int x = QString(list[0]).toInt();
                int y = QString(list[1]).toInt();
                int w = QString(list[2]).toInt();
                int h = QString(list[3]).toInt();
                PushButton *button = new PushButton(label.mid(1,label.length()-2),win);
                button->resize(w,h);
                button->move(x,y);
                button->show();
                char buffer[255];
                sprintf(buffer,"%d",id);
                button->name = QString("Button").append(buffer);
                win->buttonList << button;
                id++;
            }
        }

        if (true == lines[i].contains("= Checkbox(",Qt::CaseInsensitive))
        {
            QString label;
            QRegExp ex("\"");
            QRegExp ex2("\"\"");
            int start = 0;
            int start2;
            int end;
            int end2;
            for(;;)
            {
                start = ex.indexIn(lines[i],start);
                start2 = start;
                if (start != -1)
                {
                    for (;;)
                    {
                        end = ex.indexIn(lines[i],start2+1);
                        end2 = ex2.indexIn(lines[i],start2+1);

                        if (end2 != -1)
                        {
                            end = end2+1;
                            break;
                        }
                        if (lines[i].mid(end-1,1) == "\\")
                        {
                            start2 = end+1;
                            continue;
                        }
                        break;
                    }
                    if (end != -1)
                    {
                        label = lines[i].mid(start,end-start+1);
                        lines[i].remove(start,end-start+1);
                        start = start + (end-start+1);
                    }  else
                    {
                        break;
                    }
                }
                if (start == -1)
                {
                    break;
                }
            }
            s = lines[i].indexOf("= Checkbox(",0,Qt::CaseInsensitive);
            s = s+11;
            e = lines[i].indexOf(")",s);
            QStringList list = lines[i].mid(s,e-s).split(",");
            if (list.count() > 3)
            {
                int x = QString(list[0]).toInt();
                int y = QString(list[1]).toInt();
                int w = QString(list[2]).toInt();
                int h = QString(list[3]).toInt();
                Checkbox *button = new Checkbox(label.mid(1,label.length()-2),win);
                button->resize(w,h);
                button->move(x,y);
                button->show();
                char buffer[255];
                sprintf(buffer,"%d",id);
                button->name = QString("Checkbox").append(buffer);
                win->checkList << button;
                id++;
            }
        }


        if (true == lines[i].contains("= Combobox(",Qt::CaseInsensitive))
        {

            s = lines[i].indexOf("= Combobox(",0,Qt::CaseInsensitive);
            s = s+11;
            e = lines[i].indexOf(")",s);
            QStringList list = lines[i].mid(s,e-s).split(",");
            if (list.count() > 3)
            {
                int x = QString(list[0]).toInt();
                int y = QString(list[1]).toInt();
                int w = QString(list[2]).toInt();
                int h = QString(list[3]).toInt();
                ComboBox *button = new ComboBox(win);
                button->resize(w,h);
                button->move(x,y);
                button->show();
                char buffer[255];
                sprintf(buffer,"%d",id);
                button->name = QString("Combobox").append(buffer);
                win->comboboxList << button;
                id++;
            }
        }
    }



}








void MainWindow2::closeEvent(QCloseEvent *event)
{
    event->ignore();

}










void MainWindow2::createButton()
{
    CreateButtonDialog *dialog = new CreateButtonDialog(1,win);
    QMdiSubWindow *sub = new QMdiSubWindow;
    sub->setWidget(dialog);
    area->addSubWindow(sub);
    int i = dialog->exec();
    delete dialog->button;
    if (i == 0 && dialog->bOK == true)
    {
        PushButton *button = new PushButton(dialog->text->text(),win);
        button->resize(dialog->hspin->value(),dialog->vspin->value());
        button->move(dialog->xspin->value(),dialog->yspin->value());
        button->show();
        button->name = dialog->name->text();
        win->buttonList << button;
        id++;
    }
    delete dialog;
    delete sub;
}










void MainWindow2::createCheckbox()
{
    CreateButtonDialog *dialog = new CreateButtonDialog(2,win);
    QMdiSubWindow *sub = new QMdiSubWindow;
    sub->setWidget(dialog);
    area->addSubWindow(sub);
    int i = dialog->exec();
    delete dialog->checkbox;
    if (i == 0 && dialog->bOK == true)
    {
        Checkbox *button = new Checkbox(dialog->text->text(),win);
        button->resize(dialog->hspin->value(),dialog->vspin->value());
        button->move(dialog->xspin->value(),dialog->yspin->value());
        button->show();
        char buffer[255];
        sprintf(buffer,"%d",win->checkList.count());
        button->name = QString("Check").append(buffer);
        win->checkList << button;
        id++;
    }
    delete dialog;
    delete sub;
}






void MainWindow2::createLineEdit()
{
    CreateButtonDialog *dialog = new CreateButtonDialog(4,win);
    QMdiSubWindow *sub = new QMdiSubWindow;
    sub->setWidget(dialog);
    area->addSubWindow(sub);
    int i = dialog->exec();
    delete dialog->edit;
    if (i == 0 && dialog->bOK == true)
    {
        LineEdit *button = new LineEdit(dialog->text->text(),win);
        button->resize(dialog->hspin->value(),dialog->vspin->value());
        button->move(dialog->xspin->value(),dialog->yspin->value());
        button->show();
        char buffer[255];
        sprintf(buffer,"%d",win->lineeditList.count());
        button->name = QString("LEdit").append(buffer);
        win->lineeditList << button;
        id++;
    }
    delete dialog;
    delete sub;
}




void MainWindow2::createMultiLineEdit()
{
    CreateButtonDialog *dialog = new CreateButtonDialog(5,win);
    QMdiSubWindow *sub = new QMdiSubWindow;
    sub->setWidget(dialog);
    area->addSubWindow(sub);
    int i = dialog->exec();
    delete dialog->textedit;
    if (i == 0 && dialog->bOK == true)
    {
        MultiLineEdit *button = new MultiLineEdit(dialog->text->text(),win);
        button->resize(dialog->hspin->value(),dialog->vspin->value());
        button->move(dialog->xspin->value(),dialog->yspin->value());
        button->show();
        char buffer[255];
        sprintf(buffer,"%d",win->multilineeditList.count());
        button->name = QString("MLEdit").append(buffer);
        win->multilineeditList << button;
        id++;
    }
    delete dialog;
    delete sub;
}




void MainWindow2::createRichEdit()
{
    CreateButtonDialog *dialog = new CreateButtonDialog(7,win);
    QMdiSubWindow *sub = new QMdiSubWindow;
    sub->setWidget(dialog);
    area->addSubWindow(sub);
    int i = dialog->exec();
    delete dialog->richedit;
    if (i == 0 && dialog->bOK == true)
    {
        RichEdit *button = new RichEdit(dialog->text->text(),win);
        button->resize(dialog->hspin->value(),dialog->vspin->value());
        button->move(dialog->xspin->value(),dialog->yspin->value());
        button->show();
        char buffer[255];
        sprintf(buffer,"%d",win->richeditList.count());
        button->name = QString("Rich").append(buffer);
        win->richeditList << button;
        id++;
    }
    delete dialog;
    delete sub;
}



void MainWindow2::createComboBox()
{
    CreateButtonDialog *dialog = new CreateButtonDialog(3,win);
    QMdiSubWindow *sub = new QMdiSubWindow;
    sub->setWidget(dialog);
    area->addSubWindow(sub);
    int i = dialog->exec();
    delete dialog->combo;
    if (i == 0 && dialog->bOK == true)
    {
        ComboBox *button = new ComboBox(win);
        button->resize(dialog->hspin->value(),dialog->vspin->value());
        button->move(dialog->xspin->value(),dialog->yspin->value());
        button->show();
        char buffer[255];
        sprintf(buffer,"%d",win->comboboxList.count());
        button->name = QString("Combobox").append(buffer);
        win->comboboxList << button;
        id++;
    }
    delete dialog;
    delete sub;
}




void MainWindow2::createListBox()
{
    CreateButtonDialog *dialog = new CreateButtonDialog(6,win);
    QMdiSubWindow *sub = new QMdiSubWindow;
    sub->setWidget(dialog);
    area->addSubWindow(sub);
    int i = dialog->exec();
    delete dialog->listbox;
    if (i == 0 && dialog->bOK == true)
    {
        Listbox *button = new Listbox(win);
        button->resize(dialog->hspin->value(),dialog->vspin->value());
        button->move(dialog->xspin->value(),dialog->yspin->value());
        button->show();
        char buffer[255];
        sprintf(buffer,"%d",win->listboxList.count());
        button->name = QString("List").append(buffer);
        win->listboxList << button;
        id++;
    }
    delete dialog;
    delete sub;
}




void MainWindow2::menu()
{
    QMenu *fileMenu = menuBar()->addMenu(tr("&Datei"));

    QAction *createAct = new QAction("Erzeugen",this);
    connect(createAct,SIGNAL(triggered()),this,SLOT(createCode()));
    fileMenu->addAction(createAct);
}










void MainWindow2::createCode()
{
    char winx[255];
    sprintf(winx,"%d",win->size().width());
    char winy[255];
    sprintf(winy,"%d",win->size().height());

    QString code;
    code = "#include once \"windows.bi\"\n"
           "#include once \"gui.bi\"\n";

           code.append("declare function WinMain ( byval hInstance as HINSTANCE,byval hPrevInstance as HINSTANCE, byval szCmdLine as string, byval iCmdShow as integer ) as integer\n"
           "end WinMain( GetModuleHandle( null ), null, Command( ), SW_NORMAL )\n\n");


    //Dekleration
    for (int i = 0;i < win->buttonList.count();i++)
    {
        code.append("dim shared ").append(win->buttonList[i]->name).append(" as Button\n");
    }
    for (int i = 0;i < win->checkList.count();i++)
    {
        code.append("dim shared ").append(win->checkList[i]->name).append(" as Checkbox\n");
    }
    for (int i = 0;i < win->lineeditList.count();i++)
    {
        code.append("dim shared ").append(win->lineeditList[i]->name).append(" as LineEdit\n");
    }
    for (int i = 0;i < win->multilineeditList.count();i++)
    {
        code.append("dim shared ").append(win->multilineeditList[i]->name).append(" as TextEdit\n");
    }
    for (int i = 0;i < win->richeditList.count();i++)
    {
        code.append("dim shared ").append(win->richeditList[i]->name).append(" as RichEdit\n");
    }
    for (int i = 0;i < win->comboboxList.count();i++)
    {
        code.append("dim shared ").append(win->comboboxList[i]->name).append(" as Combobox\n");
    }
    for (int i = 0;i < win->listboxList.count();i++)
    {
        code.append("dim shared ").append(win->listboxList[i]->name).append(" as Listbox\n");
    }





    //Funktionen
    if (win->onpaint != "")
    {
        code.append("\n'Diese Funktion wird aufgerufen wenn das Fenster gezeichnet werden soll.");
        code.append("\nsub ").append(win->onpaint).append(" ()\n  \nend sub\n\n\n");
    }
    if (win->onresize != "")
    {
        code.append("\n'Diese Funktion wird aufgerufen wenn die Gre des Fensters gendert wurde.");
        code.append("\nsub ").append(win->onresize).append(" ()\n  \nend sub\n\n\n");
    }
    if (win->onmove != "")
    {
        code.append("\n'Diese Funktion wird aufgerufen wenn die Position des Fensters gendert wurde.");
        code.append("\nsub ").append(win->onmove).append(" ()\n  \nend sub\n\n\n");
    }
    if (win->onclose != "")
    {
        code.append("\n'Diese Funktion wird aufgerufen wenn das Fenster geschlossen werden soll.");
        code.append("\nsub ").append(win->onclose).append(" ()\n  \nend sub\n\n\n");
    }
    for (int i = 0;i < win->buttonList.count();i++)
    {
        if (win->buttonList[i]->getOnClick() != "")
        {
            code.append("\n'Diese Funktion wird aufgerufen wenn der Button '").append(win->buttonList[i]->name).append("' angeklickt wurde.");
            code.append("\nsub ").append(win->buttonList[i]->getOnClick()).append(" ()\n  \nend sub\n\n\n");
        }
    }
    for (int i = 0;i < win->checkList.count();i++)
    {
        if (win->checkList[i]->getOnClick() != "")
        {
            code.append("\n'Diese Funktion wird aufgerufen wenn die Checkbox '").append(win->checkList[i]->name).append("' angeklickt wurde.");
            code.append("\nsub ").append(win->checkList[i]->getOnClick()).append(" ()\n  \nend sub\n\n\n");
        }
    }
    for (int i = 0;i < win->lineeditList.count();i++)
    {
        if (win->lineeditList[i]->onChange != "")
        {
            code.append("\n'Diese Funktion wird aufgerufen wenn der Text des Eingabefelds '").append(win->lineeditList[i]->name).append("' gendert wurde.");
            code.append("\nsub ").append(win->lineeditList[i]->onChange).append(" ()\n  \nend sub\n\n\n");
        }
    }
    for (int i = 0;i < win->multilineeditList.count();i++)
    {
        if (win->multilineeditList[i]->onChange != "")
        {
            code.append("\n'Diese Funktion wird aufgerufen wenn der Text des Eingabefelds '").append(win->multilineeditList[i]->name).append("' gendert wurde.");
            code.append("\nsub ").append(win->multilineeditList[i]->onChange).append(" ()\n  \nend sub\n\n\n");
        }
    }
    for (int i = 0;i < win->richeditList.count();i++)
    {
        if (win->richeditList[i]->onChange != "")
        {
            code.append("\n'Diese Funktion wird aufgerufen wenn der Text des Richedits '").append(win->richeditList[i]->name).append("' gendert wurde.");
            code.append("\nsub ").append(win->richeditList[i]->onChange).append(" ()\n  \nend sub\n\n\n");
        }
    }


           code.append("\n\nfunction WinMain ( byval hInstance as HINSTANCE, byval hPrevInstance as HINSTANCE, byval szCmdLine as string, byval iCmdShow as integer ) as integer\n"
           "    dim wMsg as MSG\n"
           "    dim wcls as WNDCLASS\n"

           "    with wcls\n"
           "        .style         = CS_HREDRAW or CS_VREDRAW\n"
           "        .lpfnWndProc   = @WndProc\n"
           "        .cbClsExtra    = 0\n"
           "        .cbWndExtra    = 0\n"
           "        .hInstance     = hInstance\n"
           "        .hIcon         = LoadIcon(NULL, IDI_APPLICATION)\n"
           "        .hCursor       = LoadCursor(NULL, IDC_ARROW)\n"
           "        .hbrBackground = CreateSolidBrush(GetSysColor(COLOR_BTNFACE))\n"
           "        .lpszMenuName  = NULL\n"
           "        .lpszClassName = @\"Designer\"\n"
           "    end with\n\n"

           "    if(RegisterClass(@wcls) = FALSE) then\n"
           "        MessageBox(null, \"Die Fensterklasse konnte nicht registriert werden.\", \"Fehler\", MB_ICONERROR)\n"
           "        return 1\n"
           "    end if\n\n"
           "    LoadLibrary(\"Riched20.dll\")\n"
           "    dim as Window hWnd = Window(CW_USEDEFAULT, CW_USEDEFAULT, ").append(winx).append(",").append(winy).append(", \"Titel\")\n\n");

    if (win->onpaint != "")
    {
        code.append("    hWnd.OnPaint = @").append(win->onpaint).append("\n");
    }
    if (win->onresize != "")
    {
        code.append("    hWnd.OnResize = @").append(win->onresize).append("\n");
    }
    if (win->onmove != "")
    {
        code.append("    hWnd.OnMove = @").append(win->onmove).append("\n");
    }
    if (win->onclose != "")
    {
        code.append("    hWnd.OnClose = @").append(win->onclose).append("\n");
    }
    //Definition
    for (int i = 0;i < win->buttonList.count();i++)
    {
        char x[255];
        sprintf(x,"%d",win->buttonList[i]->pos().x());
        char y[255];
        sprintf(y,"%d",win->buttonList[i]->pos().y());
        char w[255];
        sprintf(w,"%d",win->buttonList[i]->size().width());
        char h[255];
        sprintf(h,"%d",win->buttonList[i]->size().height());
        QString label = win->buttonList[i]->text();
        label.replace("\"",QString("\\").append("\""));
        label.replace("\\","\\");
        code.append("    ").append(win->buttonList[i]->name).append(" = Button(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("\"").append(label).append("\",").append("hWnd)").append("\n");
        if (win->buttonList[i]->getOnClick() != "")
        {
            code.append("    ").append(win->buttonList[i]->name).append(".OnClick = @").append(win->buttonList[i]->getOnClick()).append("\n");
        }
    }

    for (int i = 0;i < win->checkList.count();i++)
    {
        char x[255];
        sprintf(x,"%d",win->checkList[i]->pos().x());
        char y[255];
        sprintf(y,"%d",win->checkList[i]->pos().y());
        char w[255];
        sprintf(w,"%d",win->checkList[i]->size().width());
        char h[255];
        sprintf(h,"%d",win->checkList[i]->size().height());
        code.append("    ").append(win->checkList[i]->name).append(" = Checkbox(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("\"").append(win->checkList[i]->text()).append("\",").append("hWnd)").append("\n");
        if (win->checkList[i]->getOnClick() != "")
        {
            code.append("    ").append(win->checkList[i]->name).append(".OnClick = @").append(win->checkList[i]->getOnClick()).append("\n");
        }
    }

    for (int i = 0;i < win->lineeditList.count();i++)
    {
        char x[255];
        sprintf(x,"%d",win->lineeditList[i]->pos().x());
        char y[255];
        sprintf(y,"%d",win->lineeditList[i]->pos().y());
        char w[255];
        sprintf(w,"%d",win->lineeditList[i]->size().width());
        char h[255];
        sprintf(h,"%d",win->lineeditList[i]->size().height());
        if (win->lineeditList[i]->password == false && win->lineeditList[i]->number == false)
        {
            code.append("    ").append(win->lineeditList[i]->name).append(" = LineEdit(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("\"").append(win->lineeditList[i]->text()).append("\",").append("hWnd)").append("\n");
        } else
        {
            QStringList extra;
            if (win->lineeditList[i]->password)
            {
                extra << "ES_PASSWORD";
            }
            if (win->lineeditList[i]->number)
            {
                extra << "ES_NUMBER";
            }
            code.append("    ").append(win->lineeditList[i]->name).append(" = LineEdit(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("\"").append(win->lineeditList[i]->text()).append("\",").append("hWnd,").append(extra.join(" or ")).append(")\n");
        }
        if (win->lineeditList[i]->onChange != "")
        {
            code.append("    ").append(win->lineeditList[i]->name).append(".OnChange = @").append(win->lineeditList[i]->onChange).append("\n");
        }
    }

    for (int i = 0;i < win->multilineeditList.count();i++)
    {
        char x[255];
        sprintf(x,"%d",win->multilineeditList[i]->pos().x());
        char y[255];
        sprintf(y,"%d",win->multilineeditList[i]->pos().y());
        char w[255];
        sprintf(w,"%d",win->multilineeditList[i]->size().width());
        char h[255];
        sprintf(h,"%d",win->multilineeditList[i]->size().height());
        if (win->multilineeditList[i]->password == false && win->multilineeditList[i]->number == false)
        {
            code.append("    ").append(win->multilineeditList[i]->name).append(" = TextEdit(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("\"").append(win->multilineeditList[i]->toPlainText()).append("\",").append("hWnd)").append("\n");
        } else
        {
            QStringList extra;
            if (win->multilineeditList[i]->password)
            {
                extra << "ES_PASSWORD";
            }
            if (win->multilineeditList[i]->number)
            {
                extra << "ES_NUMBER";
            }
            code.append("    ").append(win->multilineeditList[i]->name).append(" = TextEdit(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("\"").append(win->multilineeditList[i]->toPlainText()).append("\",").append("hWnd,").append(extra.join(" or ")).append(")\n");
        }
        if (win->multilineeditList[i]->onChange != "")
        {
            code.append("    ").append(win->multilineeditList[i]->name).append(".OnChange = @").append(win->multilineeditList[i]->onChange).append("\n");
        }
    }

    for (int i = 0;i < win->comboboxList.count();i++)
    {
        char x[255];
        sprintf(x,"%d",win->comboboxList[i]->pos().x());
        char y[255];
        sprintf(y,"%d",win->comboboxList[i]->pos().y());
        char w[255];
        sprintf(w,"%d",win->comboboxList[i]->size().width());
        char h[255];
        sprintf(h,"%d",win->comboboxList[i]->size().height());
        code.append("    ").append(win->comboboxList[i]->name).append(" = Combobox(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("hWnd)").append("\n");
        if (win->comboboxList[i]->getOnClick() != "")
        {
        }
    }

    for (int i = 0;i < win->listboxList.count();i++)
    {
        char x[255];
        sprintf(x,"%d",win->listboxList[i]->pos().x());
        char y[255];
        sprintf(y,"%d",win->listboxList[i]->pos().y());
        char w[255];
        sprintf(w,"%d",win->listboxList[i]->size().width());
        char h[255];
        sprintf(h,"%d",win->listboxList[i]->size().height());
        code.append("    ").append(win->listboxList[i]->name).append(" = Listbox(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("hWnd)").append("\n");

    }

    for (int i = 0;i < win->richeditList.count();i++)
    {
        char x[255];
        sprintf(x,"%d",win->richeditList[i]->pos().x());
        char y[255];
        sprintf(y,"%d",win->richeditList[i]->pos().y());
        char w[255];
        sprintf(w,"%d",win->richeditList[i]->size().width());
        char h[255];
        sprintf(h,"%d",win->richeditList[i]->size().height());
        if (win->richeditList[i]->password == false && win->richeditList[i]->number == false)
        {
            code.append("    ").append(win->richeditList[i]->name).append(" = RichEdit(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("\"").append(win->richeditList[i]->toPlainText()).append("\",").append("hWnd)").append("\n");
        } else
        {
            QStringList extra;
            if (win->richeditList[i]->password)
            {
                extra << "ES_PASSWORD";
            }
            if (win->richeditList[i]->number)
            {
                extra << "ES_NUMBER";
            }
            code.append("    ").append(win->richeditList[i]->name).append(" = RichEdit(").append(x).append(",").append(y).append(",").append(w).append(",").append(h).append(",").append("\"").append(win->richeditList[i]->toPlainText()).append("\",").append("hWnd,").append(extra.join(" or ")).append(")\n");
        }
        if (win->richeditList[i]->onChange != "")
        {
            code.append("    ").append(win->richeditList[i]->name).append(".OnChange = @").append(win->richeditList[i]->onChange).append("\n");
        }
    }


           code.append("    ShowWindow(hWnd.hwnd, iCmdShow)\n"
           "    UpdateWindow(hWnd.hwnd)\n"

           "    while( GetMessage(@wMsg, NULL, 0, 0) <> FALSE)\n"
           "        TranslateMessage(@wMsg)\n"
           "        DispatchMessage(@wMsg)\n"
           "    wend\n\n"

           "    return wMsg.wParam\n"

           "end function\n");

    QStringList path;
    path = main->getManager()->projektPath.split("/");
    path.removeLast();
    QString p = path.join("/");
    QFile file(QString(p).append("/gui.bas"));
    file.open(QIODevice::WriteOnly | QIODevice::Text);
    file.write(code.toAscii());

    file.waitForBytesWritten(-1);
    main->getManager()->addSource("gui.bas",QString(p).append("/gui.bas"));
}
