#ifndef GUI_MULTILINEEDIT_H
#define GUI_MULTILINEEDIT_H
#include <QtGui>



class MultiLineEdit;

class MultiLineEditSizer : public QWidget
{
    Q_OBJECT
public:
    MultiLineEditSizer(MultiLineEdit *lb, int t,QWidget *parent = 0);
    int typ;
    int x1, y1;
    int x4, y4;
    bool p;
    MultiLineEdit *listbox;

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void paintEvent (QPaintEvent * event);
};




class MultiLineEdit : public QTextEdit
{
    Q_OBJECT
public:
    MultiLineEdit(QString t, QWidget *parent);
    QString name;
    int x;
    int y;
    int width;
    int height;
    bool password;
    bool number;


    QWidget *config;
    QWidget *window;
    void setSizer();

    QString onChange;

private:
    int x1, y1;
    int x4, y4;
    bool p;
    int typ;
    MultiLineEditSizer *s1;
    MultiLineEditSizer *s2;
    MultiLineEditSizer *s3;
    MultiLineEditSizer *s4;
    MultiLineEditSizer *s5;
    MultiLineEditSizer *s6;
    MultiLineEditSizer *s7;
    MultiLineEditSizer *s8;


protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseDoubleClickEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *e);


private slots:
    void valueChange();
    void showConf();
};

#endif // GUI_MULTILINEEDIT_H
