#ifndef PUSHBUTTON_H
#define PUSHBUTTON_H

#include <QtGui>
#include <QPushButton>


class PushButton;

class ButtonSizer : public QWidget
{
    Q_OBJECT
public:
    ButtonSizer(PushButton *lb, int t,QWidget *parent = 0);
    int typ;
    int x1, y1;
    int x4, y4;
    bool p;
    PushButton *listbox;

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void paintEvent (QPaintEvent * event);
};


class PushButton : public QPushButton
{
    Q_OBJECT
public:
    PushButton(QString t, QWidget *parent);
    QString name;
    int x;
    int y;
    int width;
    int height;
    void setOnClick(QString oc) {OnClick = oc;}
    QString getOnClick() {return OnClick;}
    void setSizer();

    QWidget *config;
    QWidget *window;

private:
    QString OnClick;
    int x1, y1;
    int x4, y4;
    bool p;
    int typ;
    ButtonSizer *s1;
    ButtonSizer *s2;
    ButtonSizer *s3;
    ButtonSizer *s4;
    ButtonSizer *s5;
    ButtonSizer *s6;
    ButtonSizer *s7;
    ButtonSizer *s8;

private slots:
    void valueChange();
    void showConf();

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseDoubleClickEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *e);
};

#endif // PUSHBUTTON_H
