#include "gui_richedit.h"
#include "QtGui"
#include "gui_config.h"

extern QWindowsStyle *winStyle;

RichEdit::RichEdit(QString t, QWidget *parent) : QTextEdit(t,parent)
{
    window = parent;
    password = false;
    number = false;
    setStyle(winStyle);
    p = false;
    typ = 0;
    setMouseTracking(true);
    s1 = new RichEditSizer(this,1,this);
    s2 = new RichEditSizer(this,2,this);
    s3 = new RichEditSizer(this,3,this);
    s4 = new RichEditSizer(this,4,this);
    s5 = new RichEditSizer(this,5,this);
    s6 = new RichEditSizer(this,6,this);
    s7 = new RichEditSizer(this,7,this);
    s8 = new RichEditSizer(this,8,this);
}






void RichEdit::valueChange()
{

}


void RichEdit::mousePressEvent(QMouseEvent *e)
{
    p = true;
    x1 = e->pos().x();
    y1 = e->pos().y();
    x4 = x1;
    y4 = y1;
}






void RichEdit::mouseDoubleClickEvent(QMouseEvent *e)
{
    showConf();
}






void RichEdit::mouseReleaseEvent(QMouseEvent *e)
{
    p = false;
}







void RichEdit::mouseMoveEvent(QMouseEvent *e)
{
    if (p == true)
    {
        if (typ == 0)
        {
            move(pos().x()+e->pos().x()-x1,pos().y()+e->pos().y()-y1);
        }
    }
    x4 = e->pos().x();
    y4 = e->pos().y();


}







void RichEdit::resizeEvent(QResizeEvent *e)
{
    s1->move(0,0);
    s2->move(size().width()/2-3,0);
    s3->move(size().width()-6,0);
    s4->move(0,size().height()/2-3);
    s5->move(size().width()-6,size().height()/2-3);
    s6->move(0,size().height()-6);
    s7->move(size().width()/2-3,size().height()-6);
    s8->move(size().width()-6,size().height()-6);
}







void RichEdit::setSizer()
{
    s1->move(0,0);
    s2->move(size().width()/2-3,0);
    s3->move(size().width()-6,0);
    s4->move(0,size().height()/2-3);
    s5->move(size().width()-6,size().height()/2-3);
    s6->move(0,size().height()-6);
    s7->move(size().width()/2-3,size().height()-6);
    s8->move(size().width()-6,size().height()-6);
}



void RichEdit::showConf()
{
    int x = pos().x(),y = pos().y(),h = size().width(),v = size().height();

    Config *config = new Config(7);
    config->richedit = this;
    config->text2->setText(toPlainText());
    config->text3->setText(onChange);

    config->vslider->setMaximum(window->size().height());
    config->vspin->setMaximum(window->size().height());
    config->vslider->setValue(v);

    config->hslider->setMaximum(window->size().width());
    config->hspin->setMaximum(window->size().width());
    config->hslider->setValue(h);

    config->xslider->setMaximum(window->size().width()-1);
    config->xspin->setMaximum(window->size().width()-1);
    config->xslider->setValue(x);

    config->yslider->setMaximum(window->size().height()-1);
    config->yspin->setMaximum(window->size().height()-1);
    config->yslider->setValue(y);

    resize(h,v);
    move(x,y);
    config->show();
}






RichEditSizer::RichEditSizer(RichEdit *lb, int t, QWidget *widget) : QWidget(widget)
{
    typ = t;
    listbox = lb;
    if (t == 4 || t == 5)
    {
        setCursor(QCursor(Qt::SizeHorCursor));
    } else if (t == 2 || t == 7)
    {
        setCursor(QCursor(Qt::SizeVerCursor));
    } else if (t == 1 || t == 8)
    {
        setCursor(QCursor(Qt::SizeFDiagCursor));
    } else if (t == 3 || t == 6)
    {
        setCursor(QCursor(Qt::SizeBDiagCursor));
    }

    if (typ == 1)
    {
        this->resize(6,6);
        this->move(0,0);
    } else if (typ == 2)
    {
        this->resize(6,6);
        this->move(lb->size().width()/2-3,0);
    } else if (typ == 3)
    {
        this->resize(6,6);
        this->move(lb->size().width()-6,0);
    } else if (typ == 4)
    {
        this->resize(6,6);
        this->move(0,lb->size().height()/2-3);
    } else if (typ == 5)
    {
        this->resize(6,6);
        this->move(lb->size().width()-6,lb->size().height()/2-3);
    } else if (typ == 6)
    {
        this->resize(6,6);
        this->move(0,lb->size().height()-6);
    } else if (typ == 7)
    {
        this->resize(6,6);
        this->move(lb->size().width()/2-3,lb->size().height()-6);
    } else if (typ == 8)
    {
        this->resize(6,6);
        this->move(lb->size().width()-6,lb->size().height()-6);
    }
}





void RichEditSizer::mousePressEvent(QMouseEvent *e)
{
    p = true;
    x1 = e->pos().x();
    y1 = e->pos().y();
    x4 = x1;
    y4 = y1;
}







void RichEditSizer::mouseReleaseEvent(QMouseEvent *e)
{
    p = false;
}







void RichEditSizer::mouseMoveEvent(QMouseEvent *e)
{
    if (p == true)
    {
        move(pos().x()+e->pos().x()-x1,pos().y()+e->pos().y()-y1);
        if (typ == 1)
        {
            QRect r = listbox->geometry();
            r.setX(listbox->pos().x()+pos().x());
            r.setY(listbox->pos().y()+pos().y());
            listbox->setGeometry(r);
        } else if (typ == 2)
        {
            QRect r = listbox->geometry();
            r.setY(listbox->pos().y()+pos().y());
            listbox->setGeometry(r);
        } else if (typ == 3)
        {
            QRect r = listbox->geometry();
            r.setY(listbox->pos().y()+pos().y());
            r.setWidth(size().width()+pos().x());
            listbox->setGeometry(r);
        } else if (typ == 4)
        {
            QRect r = listbox->geometry();
            r.setX(listbox->pos().x()+pos().x());
            listbox->setGeometry(r);
        } else if (typ == 5)
        {
            QRect r = listbox->geometry();
            r.setWidth(size().width()+pos().x());
            listbox->setGeometry(r);
        } else if (typ == 6)
        {
            QRect r = listbox->geometry();
            r.setX(listbox->pos().x()+pos().x());
            r.setHeight(size().height()+pos().y());
            listbox->setGeometry(r);
        } else if (typ == 7)
        {
            QRect r = listbox->geometry();
            r.setHeight(size().height()+pos().y());
            listbox->setGeometry(r);
        } else if (typ == 8)
        {
            QRect r = listbox->geometry();
            r.setWidth(size().width()+pos().x());
            r.setHeight(size().height()+pos().y());
            listbox->setGeometry(r);
        }
        listbox->setSizer();

        x4 = listbox->pos().x()+e->pos().x();
        y4 = listbox->pos().x()+e->pos().y();
    }


}





void RichEditSizer::paintEvent ( QPaintEvent * event )
{
    QPainter painter(this);
    painter.setPen(Qt::black);
    painter.setBrush(Qt::black);
    painter.drawRect(rect());

}
