#ifndef GUI_RICHEDIT_H
#define GUI_RICHEDIT_H

#include <QtGui>

class RichEdit;

class RichEditSizer : public QWidget
{
    Q_OBJECT
public:
    RichEditSizer(RichEdit *lb, int t,QWidget *parent = 0);
    int typ;
    int x1, y1;
    int x4, y4;
    bool p;
    RichEdit *listbox;

protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void paintEvent (QPaintEvent * event);
};




class RichEdit : public QTextEdit
{
    Q_OBJECT
public:
    RichEdit(QString t, QWidget *parent);
    QString name;
    int x;
    int y;
    int width;
    int height;
    bool password;
    bool number;
    void setSizer();


    QWidget *config;
    QWidget *window;

    QString onChange;


private:
    int x1, y1;
    int x4, y4;
    bool p;
    int typ;
    RichEditSizer *s1;
    RichEditSizer *s2;
    RichEditSizer *s3;
    RichEditSizer *s4;
    RichEditSizer *s5;
    RichEditSizer *s6;
    RichEditSizer *s7;
    RichEditSizer *s8;


protected:
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
    void mouseDoubleClickEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *e);


private slots:
    void valueChange();
    void showConf();
};

#endif // GUI_RICHEDIT_H
