#include <QtGui>
#include "gui_config.h"
#include "gui_window.h"

extern QWindowsStyle *winStyle;

Window::Window()
        : QWidget(0)
{
    setStyle(winStyle);
    setMouseTracking(true);
    resize(320,280);
}




void Window::closeEvent(QCloseEvent *event)
{
    event->ignore();
}




void Window::mouseDoubleClickEvent(QMouseEvent *e)
{
    showConf();
}




void Window::showConf()
{
    int x = pos().x(),y = pos().y(),h = size().width(),v = size().height();

    Config *config = new Config(0);
    config->window = this;
    config->text2->setText(this->windowTitle());
    config->text3->setText(onpaint);
    config->text4->setText(onresize);
    config->text5->setText(onmove);
    config->text6->setText(onclose);

    config->vslider->setMaximum(3000);
    config->vspin->setMaximum(3000);
    config->vslider->setValue(v);

    config->hslider->setMaximum(3000);
    config->hspin->setMaximum(3000);
    config->hslider->setValue(h);

    config->xslider->setMaximum(3000-1);
    config->xspin->setMaximum(3000-1);
    config->xslider->setValue(x);

    config->yslider->setMaximum(3000-1);
    config->yspin->setMaximum(3000-1);
    config->yslider->setValue(y);

    resize(h,v);
    move(x,y);
    config->show();
}
