#ifndef WINDOW_H
#define WINDOW_H

#include <QWidget>
#include "gui_pushbutton.h"
#include "gui_checkbox.h"
#include "gui_lineedit.h"
#include "gui_multilineedit.h"
#include "gui_combobox.h"
#include "gui_listbox.h"
#include "gui_richedit.h"

class PushButton;
class Checkbox;
class LineEdit;

class Window : public QWidget
{
public:
    Window();
    QList<PushButton*> buttonList;
    QList<Checkbox*> checkList;
    QList<LineEdit*> lineeditList;
    QList<MultiLineEdit*> multilineeditList;
    QList<ComboBox*> comboboxList;
    QList<Listbox*> listboxList;
    QList<RichEdit*> richeditList;
    QString onresize;
    QString onmove;
    QString onpaint;
    QString onclose;

private:
    void mouseDoubleClickEvent(QMouseEvent *e);
    void showConf();

protected:
    void closeEvent(QCloseEvent *event);

};

#endif // WINDOW_H
