//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "webview.h"
#include <stdio.h>
#include <Windows.h>
#include "highlighter.h"
#include "mainwindow.h"
#include "compiler.h"
#include "manager.h"
#include "projectdialog.h"
#include "textedit.h"
#include "settingsdialog.h"
#include "projectconfigdialog.h"
#include "nopastedialog.h"
#include "nopasteeditdialog.h"
#include "gui_mainwindow2.h"

QFont fontEdit;
MainWindow2 *gui;





MainWindow::MainWindow(QSettings *s, QWidget *parent, Qt::WindowFlags flags)
        : QMainWindow(parent,flags)
{
    settings = s;
    fontEdit.setFamily(settings->value("Edit/Font").toString());
    fontEdit.setPointSize(settings->value("Edit/PointSize").toInt());
    resize(1024,768);
    tabIndex = 0;
    text = 0;
    web = 0;
    mdiarea = 0;
    bTab = false;
    bProject = false;

    bar = new QTabBar;
    bar->setExpanding(false);
    bar->setMovable(true);
    bar->setTabsClosable(true);
    connect(bar,SIGNAL(tabCloseRequested(int)),this,SLOT(tabClose(int)));

    v = new QVBoxLayout;
    v->addWidget(bar);

    QWidget *w = new QWidget;
    v->setSpacing(0);
    v->setContentsMargins(0,0,0,0);
    w->setLayout(v);
    setCentralWidget(w);
    w->show();




    manager = new Manager(this);
    compiler = new Compiler(this);
    search = new SearchWidget(this);
    replace = new ReplaceWidget(this);






    statusBar();
    createActions();
    createToolBar();
    createMenus();
    
    QFile file(settings->value("GUI/layout").toString());
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
        return;

    QTextStream in(&file);
    QByteArray array;
    array = file.readAll();
    if(!restoreState(array,0))
    {
        QMessageBox msgBox;
        msgBox.setText(settings->value("Lang/Dock_Widget_Error","Der Status der Teilfenster konnte nicht wiederhergestellt werden.").toString());
        msgBox.exec();
    }

}










void MainWindow::createActions()
{

    //Datei

    newAct = new QAction(QIcon("16x16/actions/document-new.png"),settings->value("Lang/Menu_New","&Neue Datei...").toString(), this);
    newAct->setShortcuts(QKeySequence::New);
    newAct->setStatusTip(settings->value("Lang/Menu_New_Status").toString());
    connect(newAct, SIGNAL(triggered()), this, SLOT(newFile()));

    openAct = new QAction(QIcon("16x16/actions/document-open.png"),settings->value("Lang/Menu_Open").toString(), this);
    openAct->setShortcuts(QKeySequence::Open);
    openAct->setStatusTip(settings->value("Lang/Menu_Open_Status").toString());
    connect(openAct, SIGNAL(triggered()), this, SLOT(openFile()));

    newproAct = new QAction(QIcon("16x16/actions/document-new.png"),settings->value("Lang/Menu_NewProject").toString(), this);
    newproAct->setStatusTip(settings->value("Lang/Menu_NewProject_Status").toString());
    connect(newproAct, SIGNAL(triggered()), this, SLOT(newProject()));

    openproAct = new QAction(QIcon("16x16/actions/document-open.png"),settings->value("Lang/Menu_OpenProject").toString(), this);
    openproAct->setStatusTip(settings->value("Lang/Menu_OpenProject_Status").toString());
    connect(openproAct, SIGNAL(triggered()), this, SLOT(openProject()));

    saveAct = new QAction(QIcon("16x16/devices/media-floppy.png"),settings->value("Lang/Menu_Save","&Speichern").toString(), this);
    saveAct->setShortcuts(QKeySequence::Save);
    saveAct->setStatusTip(settings->value("Lang/Menu_Save_Status").toString());
    saveAct->setEnabled(false);
    connect(saveAct, SIGNAL(triggered()), this, SLOT(save()));

    saveasAct = new QAction(settings->value("Lang/Menu_SaveAs").toString(), this);
    saveasAct->setShortcuts(QKeySequence::SaveAs);
    saveasAct->setStatusTip(settings->value("Lang/Menu_SaveAs_Status").toString());
    saveasAct->setEnabled(false);
    connect(saveasAct, SIGNAL(triggered()), this, SLOT(saveas()));

    saveallAct = new QAction(settings->value("Lang/Menu_SaveAll").toString(), this);
    saveallAct->setStatusTip(settings->value("Lang/Menu_SaveAll_Status").toString());
    saveallAct->setEnabled(false);
    connect(saveallAct, SIGNAL(triggered()), this, SLOT(saveAll()));

    exportHTMLAct = new QAction(settings->value("Lang/Menu_ExportHTML").toString(), this);
    exportHTMLAct->setStatusTip(settings->value("Lang/Menu_ExportHTML_Status").toString());
    exportHTMLAct->setEnabled(false);
    connect(exportHTMLAct, SIGNAL(triggered()), this, SLOT(exportHTML()));

    exitAct = new QAction(settings->value("Lang/Menu_Exit").toString(), this);
    exitAct->setShortcut(QString("Ctrl+Q"));
    exitAct->setStatusTip(settings->value("Lang/Menu_Exit_Status").toString());
    connect(exitAct, SIGNAL(triggered()), this, SLOT(exit()));







    //Bearbeiten

    undoAct = new QAction(QIcon("16x16/actions/edit-undo.png"),settings->value("Lang/Menu_Undo").toString(), this);
    undoAct->setShortcuts(QKeySequence::Undo);
    undoAct->setEnabled(false);
    undoAct->setStatusTip(settings->value("Lang/Menu_Undo_Status").toString());


    redoAct = new QAction(QIcon("16x16/actions/edit-redo.png"),settings->value("Lang/Menu_Redo").toString(), this);
    redoAct->setShortcuts(QKeySequence::Redo);
    redoAct->setEnabled(false);
    redoAct->setStatusTip(settings->value("Lang/Menu_Redo_Status").toString());


    cutAct = new QAction(QIcon("16x16/actions/edit-cut.png"),settings->value("Lang/Menu_Cut").toString(), this);
    cutAct->setShortcuts(QKeySequence::Cut);
    cutAct->setEnabled(false);
    cutAct->setStatusTip(settings->value("Lang/Menu_Cut_Status").toString());


    copyAct = new QAction(QIcon("16x16/actions/edit-copy.png"),settings->value("Lang/Menu_Copy").toString(), this);
    copyAct->setShortcuts(QKeySequence::Copy);
    copyAct->setEnabled(false);
    copyAct->setStatusTip(settings->value("Lang/Menu_Copy_Status").toString());


    pasteAct = new QAction(QIcon("16x16/actions/edit-paste.png"),settings->value("Lang/Menu_Paste").toString(), this);
    pasteAct->setShortcuts(QKeySequence::Paste);
    pasteAct->setEnabled(false);
    pasteAct->setStatusTip(settings->value("Lang/Menu_Paste_Status").toString());


    selectallAct = new QAction(QIcon("16x16/actions/edit-select-all.png"),settings->value("Lang/Menu_SelectAll").toString(), this);
    selectallAct->setShortcuts(QKeySequence::SelectAll);
    selectallAct->setEnabled(false);
    selectallAct->setStatusTip(settings->value("Lang/Menu_SelectAll_Status").toString());


    searchAct = new QAction(QIcon("16x16/actions/edit-find.png"),settings->value("Lang/Menu_Find").toString(), this);
    searchAct->setShortcut(QKeySequence::Find);
    searchAct->setStatusTip(settings->value("Lang/Menu_Find_Status").toString());
    searchAct->setEnabled(false);
    connect(searchAct, SIGNAL(triggered()), this, SLOT(searchText()));


    replaceAct = new QAction(settings->value("Lang/Menu_Replace").toString(), this);
    replaceAct->setShortcut(QString("Ctrl+R"));
    replaceAct->setStatusTip(settings->value("Lang/Menu_Replace_Status").toString());
    replaceAct->setEnabled(false);
    connect(replaceAct, SIGNAL(triggered()), this, SLOT(replaceText()));


    gotoAct = new QAction(settings->value("Lang/Menu_Goto").toString(), this);
    gotoAct->setStatusTip(settings->value("Lang/Menu_Goto_Status").toString());
    gotoAct->setEnabled(false);
    connect(gotoAct, SIGNAL(triggered()), this, SLOT(gotoLine()));


    //Erstellen

    erstellenAct = new QAction(QIcon("16x16/emblems/emblem-system.png"),settings->value("Lang/Menu_Compile").toString(), this);
    erstellenAct->setShortcut(tr("Ctrl+F5"));
    erstellenAct->setStatusTip(settings->value("Lang/Menu_Compile_Status").toString());
    erstellenAct->setEnabled(false);
    connect(erstellenAct, SIGNAL(triggered()), compiler, SLOT(erstellen()));

    erstellenausAct = new QAction(QIcon("16x16/categories/applications-system.png"),settings->value("Lang/Menu_CompileRun").toString(), this);
    erstellenausAct->setShortcut(tr("F5"));
    erstellenausAct->setStatusTip(settings->value("Lang/Menu_CompileRun_Status").toString());
    erstellenausAct->setEnabled(false);
    connect(erstellenausAct, SIGNAL(triggered()), compiler, SLOT(erstellenaus()));

    quickrunAct = new QAction(QIcon("16x16/categories/applications-other.png"),settings->value("Lang/Menu_QR").toString(), this);
    quickrunAct->setShortcut(tr("F9"));
    quickrunAct->setStatusTip(settings->value("Lang/Menu_QR_Status").toString());
    quickrunAct->setEnabled(false);
    //connect(quickrunAct, SIGNAL(triggered()), compiler, SLOT(quickRun()));

    stopAct = new QAction(QIcon("16x16/actions/process-stop.png"), tr("Stop"), this);
    stopAct->setStatusTip(tr("Das Programm stopen."));
    stopAct->setEnabled(false);
    connect(stopAct, SIGNAL(triggered()), compiler, SLOT(stopRun()));

    typeAct = new QAction(settings->value("Lang/Menu_AddType").toString(), this);
    typeAct->setStatusTip(settings->value("Lang/Menu_AddType_Status").toString());
    typeAct->setEnabled(false);
    connect(typeAct, SIGNAL(triggered()), manager, SLOT(addType()));

    guiAct = new QAction(settings->value("Lang/Menu_Gui_Designer").toString(), this);
    guiAct->setStatusTip(settings->value("Lang/Menu_Gui_Designer_Status").toString());
    guiAct->setEnabled(false);
    connect(guiAct, SIGNAL(triggered()), this, SLOT(guiDesigner()));

    proconfigAct = new QAction(settings->value("Lang/Menu_Project_Conf").toString(), this);
    proconfigAct->setStatusTip(settings->value("Lang/Menu_Project_Conf_Status").toString());
    proconfigAct->setEnabled(false);
    connect(proconfigAct, SIGNAL(triggered()), this, SLOT(proconfigDialog()));


    // Extras

    configAct = new QAction(settings->value("Lang/Menu_Conf").toString(), this);
    configAct->setStatusTip(settings->value("Lang/Menu_Conf_Status").toString());
    connect(configAct, SIGNAL(triggered()), this, SLOT(configDialog()));


    NoPasteAct = new QAction(settings->value("Lang/Menu_NoPaste").toString(), this);
    NoPasteAct->setStatusTip(settings->value("Lang/Menu_NoPaste_Status").toString());
    connect(NoPasteAct, SIGNAL(triggered()), this, SLOT(NoPasteDialogSlot()));

    NoPasteEditAct = new QAction(settings->value("Lang/Menu_NoPaste_2").toString(), this);
    NoPasteEditAct->setStatusTip(settings->value("Lang/Menu_NoPaste_2_Status").toString());
    connect(NoPasteEditAct, SIGNAL(triggered()), this, SLOT(NoPasteEditDialogSlot()));







    // Hilfe

    fbrefAct = new QAction(settings->value("Lang/Menu_FBRef").toString(), this);
    fbrefAct->setStatusTip(settings->value("Lang/Menu_FBRef_Status").toString());
    connect(fbrefAct, SIGNAL(triggered()), this, SLOT(fbref()));

    ircAct = new QAction(settings->value("Lang/Menu_IRC").toString(), this);
    ircAct->setStatusTip(settings->value("Lang/Menu_IRC_Status").toString());
    connect(ircAct, SIGNAL(triggered()), this, SLOT(irc()));

    aboutQTAct = new QAction(settings->value("Lang/Menu_AboutQt").toString(), this);
    aboutQTAct->setStatusTip(settings->value("Lang/Menu_AboutQt_Status").toString());
    connect(aboutQTAct, SIGNAL(triggered()), this, SLOT(aboutQT()));

    aboutAct = new QAction(QIcon("16x16/apps/help-browser.png"),settings->value("Lang/Menu_About").toString(), this);
    aboutAct->setStatusTip(settings->value("Lang/Menu_About_Status").toString());
    connect(aboutAct, SIGNAL(triggered()), this, SLOT(about()));


    //Toolbar Actions
    newAct2 = new QAction(QIcon("22x22/actions/document-new.png"),settings->value("Lang/Menu_New").toString(), this);
    newAct2->setStatusTip(settings->value("Lang/Menu_New_Status").toString());
    newAct2->setEnabled(false);
    connect(newAct2, SIGNAL(triggered()), this, SLOT(newFile()));

    openAct2 = new QAction(QIcon("22x22/actions/document-open.png"),settings->value("Lang/Menu_Open").toString(), this);
    openAct2->setStatusTip(settings->value("Lang/Menu_Open_Status").toString());
    openAct2->setEnabled(false);
    connect(openAct2, SIGNAL(triggered()), this, SLOT(openFile()));

    saveAct2 = new QAction(QIcon("22x22/devices/media-floppy.png"),settings->value("Lang/Menu_Save","&Speichern").toString(), this);
    saveAct2->setStatusTip(settings->value("Lang/Menu_Save_Status").toString());
    saveAct2->setEnabled(false);
    connect(saveAct2, SIGNAL(triggered()), this, SLOT(save()));

    undoAct2 = new QAction(QIcon("22x22/actions/edit-undo.png"),settings->value("Lang/Menu_Undo").toString(), this);
    undoAct2->setEnabled(false);
    undoAct2->setStatusTip(settings->value("Lang/Menu_Undo_Status").toString());

    redoAct2 = new QAction(QIcon("22x22/actions/edit-redo.png"),settings->value("Lang/Menu_Redo").toString(), this);
    redoAct2->setEnabled(false);
    redoAct2->setStatusTip(settings->value("Lang/Menu_Redo_Status").toString());


    cutAct2 = new QAction(QIcon("22x22/actions/edit-cut.png"),settings->value("Lang/Menu_Cut").toString(), this);
    cutAct2->setEnabled(false);
    cutAct2->setStatusTip(settings->value("Lang/Menu_Cut_Status").toString());


    copyAct2 = new QAction(QIcon("22x22/actions/edit-copy.png"),settings->value("Lang/Menu_Copy").toString(), this);
    copyAct2->setEnabled(false);
    copyAct2->setStatusTip(settings->value("Lang/Menu_Copy_Status").toString());


    pasteAct2 = new QAction(QIcon("22x22/actions/edit-paste.png"),settings->value("Lang/Menu_Paste").toString(), this);
    pasteAct2->setEnabled(false);
    pasteAct2->setStatusTip(settings->value("Lang/Menu_Paste_Status").toString());


    erstellenAct2 = new QAction(QIcon("22x22/emblems/emblem-system.png"),settings->value("Lang/Menu_Compile").toString(), this);
    erstellenAct2->setStatusTip(settings->value("Lang/Menu_Compile_Status").toString());
    erstellenAct2->setEnabled(false);
    connect(erstellenAct2, SIGNAL(triggered()), compiler, SLOT(erstellen()));


    erstellenausAct2 = new QAction(QIcon("22x22/categories/applications-system.png"),settings->value("Lang/Menu_CompileRun").toString(), this);
    erstellenausAct2->setStatusTip(settings->value("Lang/Menu_CompileRun_Status").toString());
    erstellenausAct2->setEnabled(false);
    connect(erstellenausAct2, SIGNAL(triggered()), compiler, SLOT(erstellenaus()));
}










void MainWindow::createMenus()
{
    menuBar()->clear();
    fileMenu = menuBar()->addMenu(settings->value("Lang/Menu_File").toString());
    fileMenu->addAction(newproAct);
    fileMenu->addAction(openproAct);
    fileMenu->addSeparator();
    if (bProject == false)
    {
        fileMenu->addAction(newAct);
        fileMenu->addAction(openAct);
        newAct->setText(settings->value("Lang/Menu_New").toString());
        openAct->setText(settings->value("Lang/Menu_Open2").toString());
    }
    fileMenu->addSeparator();
    fileMenu->addAction(saveAct);
    fileMenu->addAction(saveasAct);
    fileMenu->addAction(saveallAct);
    fileMenu->addSeparator();
    fileMenu->addAction(exportHTMLAct);
    fileMenu->addSeparator();
    fileMenu->addAction(exitAct);

    editMenu = menuBar()->addMenu(settings->value("Lang/Menu_Edit").toString());
    editMenu->addAction(undoAct);
    editMenu->addAction(redoAct);
    editMenu->addSeparator();
    editMenu->addAction(cutAct);
    editMenu->addAction(copyAct);
    editMenu->addAction(pasteAct);
    editMenu->addSeparator();
    editMenu->addAction(selectallAct);
    editMenu->addSeparator();
    editMenu->addAction(searchAct);
    editMenu->addAction(replaceAct);
    editMenu->addAction(gotoAct);

    viewMenu = createPopupMenu();
    viewMenu->setTitle(settings->value("Lang/Menu_View").toString());
    menuBar()->addMenu(viewMenu);

    if (bProject == true)
    {
        erstellenMenu = menuBar()->addMenu(settings->value("Lang/Menu_Project").toString());
        erstellenMenu->addAction(erstellenAct);
        erstellenMenu->addAction(erstellenausAct);
        erstellenMenu->addAction(quickrunAct);
        //erstellenMenu->addSeparator();
        //erstellenMenu->addAction(stopAct);
        erstellenMenu->addSeparator();
        erstellenMenu->addAction(newAct);
        erstellenMenu->addAction(openAct);
        erstellenMenu->addSeparator();
        erstellenMenu->addAction(typeAct);
        erstellenMenu->addSeparator();
        erstellenMenu->addAction(guiAct);
        erstellenMenu->addSeparator();
        erstellenMenu->addAction(proconfigAct);

        erstellenAct->setText(settings->value("Lang/Menu_Compile").toString());
        erstellenausAct->setText(settings->value("Lang/Menu_CompileRun").toString());
        newAct->setText(settings->value("Lang/Menu_New").toString());
        openAct->setText(settings->value("Lang/Menu_Open").toString());
        disconnect(erstellenAct, SIGNAL(triggered()), 0,0);
        disconnect(erstellenausAct, SIGNAL(triggered()), 0,0);
        disconnect(erstellenAct2, SIGNAL(triggered()), 0,0);
        disconnect(erstellenausAct2, SIGNAL(triggered()), 0,0);
        connect(erstellenAct,SIGNAL(triggered()),compiler,SLOT(erstellen()));
        connect(erstellenAct2,SIGNAL(triggered()),compiler,SLOT(erstellen()));
        connect(erstellenausAct,SIGNAL(triggered()),compiler,SLOT(erstellenaus()));
        connect(erstellenausAct2,SIGNAL(triggered()),compiler,SLOT(erstellenaus()));
    } else
    {
        erstellenMenu = menuBar()->addMenu(settings->value("Lang/Menu_Source").toString());
        erstellenMenu->addAction(erstellenAct);
        erstellenMenu->addAction(erstellenausAct);
        erstellenMenu->addAction(quickrunAct);
        //erstellenMenu->addSeparator();
        //erstellenMenu->addAction(stopAct);

        erstellenAct->setText(settings->value("Lang/Menu_Compile").toString());
        erstellenausAct->setText(settings->value("Lang/Menu_CompileRun").toString());
        disconnect(erstellenAct, SIGNAL(triggered()), 0,0);
        disconnect(erstellenausAct, SIGNAL(triggered()), 0,0);
        disconnect(erstellenAct2, SIGNAL(triggered()), 0,0);
        disconnect(erstellenausAct2, SIGNAL(triggered()), 0,0);
        connect(erstellenAct,SIGNAL(triggered()),compiler,SLOT(compile_file()));
        connect(erstellenAct2,SIGNAL(triggered()),compiler,SLOT(compile_file()));
        connect(erstellenausAct,SIGNAL(triggered()),compiler,SLOT(compilerun_file()));
        connect(erstellenausAct2,SIGNAL(triggered()),compiler,SLOT(compilerun_file()));
    }

    extraMenu = menuBar()->addMenu(settings->value("Lang/Menu_Extra").toString());
    extraMenu->addAction(NoPasteAct);
    extraMenu->addAction(NoPasteEditAct);
    extraMenu->addSeparator();
    extraMenu->addAction(configAct);

    helpMenu = menuBar()->addMenu(settings->value("Lang/Menu_Help").toString());
    helpMenu->addAction(fbrefAct);
    //helpMenu->addAction(ircAct);
    helpMenu->addSeparator();
    helpMenu->addAction(aboutQTAct);
    helpMenu->addAction(aboutAct);
}










void MainWindow::createToolBar()
{
    ToolBar = addToolBar(tr("Toolbar"));
    ToolBar->addAction(newAct2);
    ToolBar->addAction(openAct2);
    ToolBar->addAction(saveAct2);
    ToolBar->addSeparator();
    ToolBar->addAction(undoAct2);
    ToolBar->addAction(redoAct2);
    ToolBar->addSeparator();
    ToolBar->addAction(cutAct2);
    ToolBar->addAction(copyAct2);
    ToolBar->addAction(pasteAct2);
    ToolBar->addSeparator();
    ToolBar->addAction(erstellenAct2);
    ToolBar->addAction(erstellenausAct2);
    ToolBar->setObjectName("ToolBar");
}










void MainWindow::newFile()
{
    QString fileName = QFileDialog::getSaveFileName(this, settings->value("Lang/File_Dialog_Titel").toString(),"", settings->value("Lang/File_Dialog_Types").toString(),&QString(),QFileDialog::DontResolveSymlinks | QFileDialog::ShowDirsOnly);
    if (fileName.compare("") > 0)
    {
        if (text != 0)
        {
            text->hide();
            disconnect(undoAct, SIGNAL(triggered()), 0,0);
            disconnect(redoAct, SIGNAL(triggered()), 0,0);
            disconnect(cutAct, SIGNAL(triggered()), 0,0);
            disconnect(copyAct, SIGNAL(triggered()), 0,0);
            disconnect(pasteAct, SIGNAL(triggered()), 0,0);
            disconnect(selectallAct, SIGNAL(triggered()), 0,0);

            disconnect(undoAct2, SIGNAL(triggered()), 0,0);
            disconnect(redoAct2, SIGNAL(triggered()), 0,0);
            disconnect(cutAct2, SIGNAL(triggered()), 0,0);
            disconnect(copyAct2, SIGNAL(triggered()), 0,0);
            disconnect(pasteAct2, SIGNAL(triggered()), 0,0);

        }
        tabIndex++;
        QString filePath = fileName;

        QVariant d;
        QString p;
        int index = -1;
        for (int i = 0;i < bar->count();i++)
        {
            d = bar->tabData(i);
            p = pathMap.value(d.toInt(),0);
            if (p == filePath)
            {
                index = i;
            }
        }
        if (index == -1)
        {
            pathMap.insert(tabIndex,fileName);
            fileName = fileName.section("/",-1);
            manager->addSource(fileName,filePath);

            new TextEdit(this,fileName,tabIndex);

            undoAct->setEnabled(false);
            redoAct->setEnabled(false);
            undoAct2->setEnabled(false);
            redoAct2->setEnabled(false);
            manager->updateProject(compiler);
        } else
        {
            bar->setCurrentIndex(index);
            tabChange(index);
        }
    }
}










void MainWindow::newFile(QString fileName)
{
    if (text != 0)
    {
        text->hide();
        disconnect(undoAct, SIGNAL(triggered()), 0,0);
        disconnect(redoAct, SIGNAL(triggered()), 0,0);
        disconnect(cutAct, SIGNAL(triggered()), 0,0);
        disconnect(copyAct, SIGNAL(triggered()), 0,0);
        disconnect(pasteAct, SIGNAL(triggered()), 0,0);
        disconnect(selectallAct, SIGNAL(triggered()), 0,0);
        disconnect(undoAct2, SIGNAL(triggered()), 0,0);
        disconnect(redoAct2, SIGNAL(triggered()), 0,0);
        disconnect(cutAct2, SIGNAL(triggered()), 0,0);
        disconnect(copyAct2, SIGNAL(triggered()), 0,0);
        disconnect(pasteAct2, SIGNAL(triggered()), 0,0);

    }
    tabIndex++;
    QString filePath = fileName;

    QVariant d;
    QString p;
    int index = -1;
    for (int i = 0;i < bar->count();i++)
    {
        d = bar->tabData(i);
        p = pathMap.value(d.toInt(),0);
        if (p == filePath)
        {
            index = i;
        }
    }
    if (index == -1)
    {
        pathMap.insert(tabIndex,fileName);
        fileName = fileName.section("/",-1);
        manager->addSource(fileName,filePath);

        new TextEdit(this,fileName,tabIndex);

        undoAct->setEnabled(false);
        redoAct->setEnabled(false);
        undoAct2->setEnabled(false);
        redoAct2->setEnabled(false);
    } else
    {
        bar->setCurrentIndex(index);
        tabChange(index);
    }
    manager->updateProject(compiler);
}












void MainWindow::setConnections(QTextEdit *edit)
{
    connect(undoAct, SIGNAL(triggered()), edit, SLOT(undo()));
    connect(redoAct, SIGNAL(triggered()), edit, SLOT(redo()));
    connect(cutAct, SIGNAL(triggered()), edit, SLOT(cut()));
    connect(copyAct, SIGNAL(triggered()), edit, SLOT(copy()));
    connect(pasteAct, SIGNAL(triggered()), edit, SLOT(paste()));
    connect(selectallAct, SIGNAL(triggered()), edit, SLOT(selectAll()));
    connect(edit, SIGNAL(undoAvailable(bool)), this, SLOT(undoOK(bool)));
    connect(edit, SIGNAL(redoAvailable(bool)), this, SLOT(redoOK(bool)));

    connect(undoAct2, SIGNAL(triggered()), edit, SLOT(undo()));
    connect(redoAct2, SIGNAL(triggered()), edit, SLOT(redo()));
    connect(cutAct2, SIGNAL(triggered()), edit, SLOT(cut()));
    connect(copyAct2, SIGNAL(triggered()), edit, SLOT(copy()));
    connect(pasteAct2, SIGNAL(triggered()), edit, SLOT(paste()));
}










void MainWindow::tabChange(int i)
{
    if (web != 0)
    {
        web->hide();
    }
    if (text != 0)
    {
        text->hide();
        disconnect(text->text2, SIGNAL(undoAvailable(bool)), 0,0);
        disconnect(text->text2, SIGNAL(redoAvailable(bool)), 0,0);
    }
    if (mdiarea != 0)
    {
        mdiarea->hide();
    }
    QVariant d = bar->tabData(i);
    int typ = typMap.value(d.toInt(),0);
    if (typ == 1)
    {
        disconnect(undoAct, SIGNAL(triggered()), 0,0);
        disconnect(redoAct, SIGNAL(triggered()), 0,0);
        disconnect(cutAct, SIGNAL(triggered()), 0,0);
        disconnect(copyAct, SIGNAL(triggered()), 0,0);
        disconnect(pasteAct, SIGNAL(triggered()), 0,0);
        disconnect(selectallAct, SIGNAL(triggered()), 0,0);

        disconnect(undoAct2, SIGNAL(triggered()), 0,0);
        disconnect(redoAct2, SIGNAL(triggered()), 0,0);
        disconnect(cutAct2, SIGNAL(triggered()), 0,0);
        disconnect(copyAct2, SIGNAL(triggered()), 0,0);
        disconnect(pasteAct2, SIGNAL(triggered()), 0,0);


        QVariant d = bar->tabData(i);
        text = map.value(d.toInt(),0);
        if (text != 0)
        {
            setConnections(text->text2);
            text->show();
            if ((text->text2->document())->isUndoAvailable() == true)
            {
                undoAct->setEnabled(true);
                undoAct2->setEnabled(true);
            } else
            {
                undoAct->setEnabled(false);
                undoAct2->setEnabled(false);
            }

            if ((text->text2->document())->isRedoAvailable() == true)
            {
                redoAct->setEnabled(true);
                redoAct2->setEnabled(true);
            } else
            {
                redoAct->setEnabled(false);
                redoAct2->setEnabled(false);
            }
            if (bProject == false)
            {
                erstellenAct->setEnabled(true);
                erstellenAct2->setEnabled(true);
                erstellenausAct->setEnabled(true);
                erstellenausAct2->setEnabled(true);
                newAct2->setEnabled(true);
                openAct2->setEnabled(true);
                stopAct->setEnabled(true);
            }

            saveAct->setEnabled(true);
            saveasAct->setEnabled(true);
            saveallAct->setEnabled(true);
            exportHTMLAct->setEnabled(true);
            cutAct->setEnabled(true);
            copyAct->setEnabled(true);
            pasteAct->setEnabled(true);
            selectallAct->setEnabled(true);
            searchAct->setEnabled(true);
            replaceAct->setEnabled(true);
            gotoAct->setEnabled(true);

            saveAct2->setEnabled(true);
            cutAct2->setEnabled(true);
            copyAct2->setEnabled(true);
            pasteAct2->setEnabled(true);
        }
    } else if (typ == 2)
    {
        QVariant d = bar->tabData(i);
        web = webMap.value(d.toInt(),0);
        if (web != 0)
        {
            web->show();
            saveAct->setEnabled(false);
            saveasAct->setEnabled(false);
            saveallAct->setEnabled(false);
            exportHTMLAct->setEnabled(false);
            cutAct->setEnabled(false);
            copyAct->setEnabled(false);
            pasteAct->setEnabled(false);
            selectallAct->setEnabled(false);
            searchAct->setEnabled(false);
            replaceAct->setEnabled(false);
            gotoAct->setEnabled(false);
            undoAct->setEnabled(false);
            redoAct->setEnabled(false);

            saveAct2->setEnabled(false);
            cutAct2->setEnabled(false);
            copyAct2->setEnabled(false);
            pasteAct2->setEnabled(false);
            undoAct2->setEnabled(false);
            redoAct2->setEnabled(false);
        }
    } else if (typ == 3)
    {
        if (mdiarea != 0)
        {
            mdiarea->show();
            saveAct->setEnabled(false);
            saveasAct->setEnabled(false);
            saveallAct->setEnabled(false);
            exportHTMLAct->setEnabled(false);
            cutAct->setEnabled(false);
            copyAct->setEnabled(false);
            pasteAct->setEnabled(false);
            selectallAct->setEnabled(false);
            searchAct->setEnabled(false);
            replaceAct->setEnabled(false);
            gotoAct->setEnabled(false);
            undoAct->setEnabled(false);
            redoAct->setEnabled(false);

            saveAct2->setEnabled(false);
            cutAct2->setEnabled(false);
            copyAct2->setEnabled(false);
            pasteAct2->setEnabled(false);
            undoAct2->setEnabled(false);
            redoAct2->setEnabled(false);
        }
    }
}










void MainWindow::tabClose(int i)
{

    QVariant d = bar->tabData(i);
    int typ = typMap.value(d.toInt(),0);
    if (typ == 1)
    {
        disconnect(undoAct, SIGNAL(triggered()), 0,0);
        disconnect(redoAct, SIGNAL(triggered()), 0,0);
        disconnect(cutAct, SIGNAL(triggered()), 0,0);
        disconnect(copyAct, SIGNAL(triggered()), 0,0);
        disconnect(pasteAct, SIGNAL(triggered()), 0,0);
        disconnect(selectallAct, SIGNAL(triggered()), 0,0);
        disconnect(text->text2, SIGNAL(undoAvailable(bool)), 0,0);
        disconnect(text->text2, SIGNAL(redoAvailable(bool)), 0,0);

        disconnect(undoAct2, SIGNAL(triggered()), 0,0);
        disconnect(redoAct2, SIGNAL(triggered()), 0,0);
        disconnect(cutAct2, SIGNAL(triggered()), 0,0);
        disconnect(copyAct2, SIGNAL(triggered()), 0,0);
        disconnect(pasteAct2, SIGNAL(triggered()), 0,0);


        if (bProject == false)
        {
            erstellenAct->setEnabled(false);
            erstellenAct2->setEnabled(false);
            erstellenausAct->setEnabled(false);
            erstellenausAct2->setEnabled(false);
            newAct2->setEnabled(false);
            openAct2->setEnabled(false);
            stopAct->setEnabled(false);
        }

        saveAct->setEnabled(false);
        saveasAct->setEnabled(false);
        saveallAct->setEnabled(false);
        exportHTMLAct->setEnabled(false);
        cutAct->setEnabled(false);
        copyAct->setEnabled(false);
        pasteAct->setEnabled(false);
        selectallAct->setEnabled(false);
        searchAct->setEnabled(false);
        replaceAct->setEnabled(false);
        gotoAct->setEnabled(false);
        undoAct->setEnabled(false);
        redoAct->setEnabled(false);

        saveAct2->setEnabled(false);
        cutAct2->setEnabled(false);
        copyAct2->setEnabled(false);
        pasteAct2->setEnabled(false);
        undoAct2->setEnabled(false);
        redoAct2->setEnabled(false);

        QVariant d = bar->tabData(i);
        text = map.value(d.toInt(),0);
        if (text != 0)
        {
            v->removeWidget(text);
            text->hide();
            text->deleteLater();
            text = 0;
        }
        bar->removeTab(i);
    } else if (typ == 2)
    {
        web->hide();
        web->deleteLater();
        web = 0;
        bar->removeTab(i);
    } else if (typ == 3)
    {
        mdiarea->hide();
        mdiarea->deleteLater();
        mdiarea = 0;
        bar->removeTab(i);
    }
}










void MainWindow::save()
{
    int i = bar->currentIndex();
    QVariant d = bar->tabData(i);
    QString name = pathMap.value(d.toInt(),0);
    QFile file(name);
    if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
        return;

    QTextStream out(&file);
    out << (text->text2->document())->toPlainText();

    QString tabtext = bar->tabText(bar->currentIndex());
    QStringList tabtextlist = tabtext.split(" ");
    if (tabtextlist.last() == "(*)" || tabtextlist.last() == "(*)")
    {
        tabtext.remove(-4,4);
        bar->setTabText(bar->currentIndex(),tabtext);
    }
}










void MainWindow::openFile()
{
    QString fileName = QFileDialog::getOpenFileName(this, settings->value("Lang/File_OpenDialog_Titel").toString(),"",settings->value("Lang/File_Dialog_Types").toString());
    if (fileName.compare("") > 0)
    {
        if (text != 0)
        {
            text->hide();
            disconnect(undoAct, SIGNAL(triggered()), 0,0);
            disconnect(redoAct, SIGNAL(triggered()), 0,0);
            disconnect(cutAct, SIGNAL(triggered()), 0,0);
            disconnect(copyAct, SIGNAL(triggered()), 0,0);
            disconnect(pasteAct, SIGNAL(triggered()), 0,0);
            disconnect(selectallAct, SIGNAL(triggered()), 0,0);

            disconnect(undoAct2, SIGNAL(triggered()), 0,0);
            disconnect(redoAct2, SIGNAL(triggered()), 0,0);
            disconnect(cutAct2, SIGNAL(triggered()), 0,0);
            disconnect(copyAct2, SIGNAL(triggered()), 0,0);
            disconnect(pasteAct2, SIGNAL(triggered()), 0,0);

        }
        tabIndex++;
        QString filePath = fileName;

        QVariant d;
        QString p;
        int index = -1;
        for (int i = 0;i < bar->count();i++)
        {
            d = bar->tabData(i);
            p = pathMap.value(d.toInt(),0);
            if (p == filePath)
            {
                index = i;
            }
        }
        if (index == -1)
        {
            pathMap.insert(tabIndex,fileName);

            fileName = fileName.section("/",-1);
            if (bProject == true)
            {
                manager->addSource(fileName,filePath);
            }

            new TextEdit(this,fileName,tabIndex);




            QFile file(filePath);
            if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
            return;

            QTextStream in(&file);
            QString basText;
            basText = in.readAll();
            text->text2->setText(basText);

            QString tabtext = bar->tabText(bar->currentIndex());
            tabtext.remove(-4,4);
            bar->setTabText(bar->currentIndex(),tabtext);


            undoAct->setEnabled(false);
            redoAct->setEnabled(false);
            undoAct2->setEnabled(false);
            redoAct2->setEnabled(false);
        } else
        {
            bar->setCurrentIndex(index);
            tabChange(index);
        }

        if (bProject == true)
        {
            manager->updateProject(compiler);
        }
    }
}










void MainWindow::openFile2(QString path)
{
    if (text != 0)
    {
        text->hide();
        disconnect(undoAct, SIGNAL(triggered()), 0,0);
        disconnect(redoAct, SIGNAL(triggered()), 0,0);
        disconnect(cutAct, SIGNAL(triggered()), 0,0);
        disconnect(copyAct, SIGNAL(triggered()), 0,0);
        disconnect(pasteAct, SIGNAL(triggered()), 0,0);
        disconnect(selectallAct, SIGNAL(triggered()), 0,0);

        disconnect(undoAct2, SIGNAL(triggered()), 0,0);
        disconnect(redoAct2, SIGNAL(triggered()), 0,0);
        disconnect(cutAct2, SIGNAL(triggered()), 0,0);
        disconnect(copyAct2, SIGNAL(triggered()), 0,0);
        disconnect(pasteAct2, SIGNAL(triggered()), 0,0);

    }
    tabIndex++;

    QVariant d;
    QString p;
    int index = -1;
    for (int i = 0;i < bar->count();i++)
    {
        d = bar->tabData(i);
        p = pathMap.value(d.toInt(),0);
        if (p == path)
        {
            index = i;
        }
    }
    if (index == -1)
    {
        pathMap.insert(tabIndex,path);
        QString fileName = path.section("/",-1);

        new TextEdit(this,fileName,tabIndex);


        QFile file(path);
        if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
            return;

        QTextStream in(&file);
        QString basText;
        basText = in.readAll();
        text->text2->setText(basText);

        QString tabtext = bar->tabText(bar->currentIndex());
        tabtext.remove(-4,4);
        bar->setTabText(bar->currentIndex(),tabtext);

        undoAct->setEnabled(false);
        redoAct->setEnabled(false);
        undoAct2->setEnabled(false);
        redoAct2->setEnabled(false);
    } else
    {
        bar->setCurrentIndex(index);
        tabChange(index);
    }
    manager->updateProject(compiler);
}










void MainWindow::undoOK(bool a)
{
    if (a == false)
    {
        undoAct->setEnabled(false);
        undoAct2->setEnabled(false);
    } else
    {
        undoAct->setEnabled(true);
        undoAct2->setEnabled(true);
    }
}










void MainWindow::redoOK(bool a)
{
    if (a == false)
    {
        redoAct->setEnabled(false);
        redoAct2->setEnabled(false);
    } else
    {
        redoAct->setEnabled(true);
        redoAct2->setEnabled(true);
    }
}










void MainWindow::exportHTML()
{
    QString fileName = QFileDialog::getSaveFileName(this, settings->value("Lang/File_Dialog_Titel").toString(),"C:/", settings->value("Lang/File_Dialog_HTML").toString());
    if (fileName.compare("") > 0)
    {
        QFile file(fileName);
        if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
            return;
        QTextStream out(&file);
        out << text->text2->toHtml();
    }
}















void MainWindow::closeEvent(QCloseEvent *event)
{

    QFile file(settings->value("GUI/layout").toString());
    if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
        return;

    QTextStream out(&file);
    out << saveState(0);


}










void MainWindow::openProject()
{
    if (bProject == true)
    {
        manager->closeProject();
    }
    QString filePath;
    QString fileName = QFileDialog::getOpenFileName(this, settings->value("Lang/File_OpenProject_Titel").toString(),"",settings->value("Lang/File_Project_Types").toString());
    if (fileName.compare("") > 0)
    {
        manager->projektPath = fileName;
        QFile file(fileName);
        if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
            return;

        QTextStream in(&file);
        QString string;
        string = in.readAll();
        QStringList list = string.split(";");

        compiler->setName(list[0]);
        list.removeFirst();
        compiler->setArch(list[0].toInt());
        list.removeFirst();
        compiler->setAssembler(list[0].toInt());
        list.removeFirst();
        compiler->setCompile(list[0].toInt());
        list.removeFirst();
        compiler->setConsole(list[0].toInt());
        list.removeFirst();
        compiler->setDebug(list[0].toInt());
        list.removeFirst();
        compiler->setFehler(list[0].toInt());
        list.removeFirst();
        compiler->setFpu(list[0].toInt());
        list.removeFirst();
        compiler->setObject(list[0].toInt());
        list.removeFirst();
        compiler->setProfile(list[0].toInt());
        list.removeFirst();
        compiler->setStack(list[0].toInt());
        list.removeFirst();
        compiler->setThread(list[0].toInt());
        list.removeFirst();
        compiler->setTyp(list[0].toInt());
        list.removeFirst();
        compiler->setVer(list[0].toInt());
        list.removeFirst();
        compiler->setZusatz(list[0]);
        list.removeFirst();


        int c = list.count();
        QString name;
        QString path;
        for (int i = 0;;i++)
        {
            path = list[i];
            name = path.section("/",-1);
            manager->addSource(name,path);
            if (i == c-1)
            {
                break;
            }
        }
        manager->getTreeWidget()->expandAll();
        newAct->setEnabled(true);
        openAct->setEnabled(true);
        newAct2->setEnabled(true);
        openAct2->setEnabled(true);
        erstellenAct->setEnabled(true);
        erstellenausAct->setEnabled(true);
        erstellenAct2->setEnabled(true);
        erstellenausAct2->setEnabled(true);
        typeAct->setEnabled(true);
        guiAct->setEnabled(true);
        proconfigAct->setEnabled(true);
        bProject = true;
        this->setWindowTitle("");
        createMenus();
    }
}










void MainWindow::newProject()
{
    if (bProject == true)
    {
        manager->closeProject();
    }
    ProjectDialog *dialog = new ProjectDialog;
    int i = dialog->exec();
    if (i == 0 && dialog->bOK == true)
    {
        manager->projektPath = (dialog->path->text()).append("/").append(dialog->projectName->text()).append(".fbpro");
        QFile file(manager->projektPath);
        file.open(QIODevice::WriteOnly);
        newAct->setEnabled(true);
        openAct->setEnabled(true);
        newAct2->setEnabled(true);
        openAct2->setEnabled(true);
        erstellenAct->setEnabled(true);
        erstellenausAct->setEnabled(true);
        erstellenAct2->setEnabled(true);
        erstellenausAct2->setEnabled(true);
        typeAct->setEnabled(true);
        guiAct->setEnabled(true);
        proconfigAct->setEnabled(true);
        manager->getTreeWidget()->expandAll();
        bProject = true;
        createMenus();
        manager->updateProject(compiler);
    }
    delete dialog;
}










void MainWindow::searchText()
{
    search->search->show();
    search->activateWindow();
}










void MainWindow::replaceText()
{
    replace->replace->show();
    replace->activateWindow();
}










void MainWindow::configDialog()
{
    SettingsDialog *dialog = new SettingsDialog(0,0,this);
    int i = dialog->exec();
    if (i == 0 && dialog->bOK == true)
    {
        settings->setValue("Compiler/Path",dialog->getPath()->text());
        settings->setValue("GUI/style",dialog->getStyle()->itemText(dialog->getStyle()->currentIndex()));
        settings->setValue("Edit/Font",dialog->getFontBox()->itemText(dialog->getFontBox()->currentIndex()));
        settings->sync();
    }
    delete dialog;
}











void MainWindow::proconfigDialog()
{
    ProjectConfigDialog *dialog = new ProjectConfigDialog(compiler);
    int i = dialog->exec();
    if (i == 0 && dialog->bOK == true)
    {
        compiler->setStack(dialog->stack->value());
        compiler->setArch(dialog->arch->currentIndex()+1);
        compiler->setAssembler(dialog->asmfile->isChecked());
        compiler->setObject(dialog->object->isChecked());
        compiler->setDebug(dialog->debug->isChecked());
        compiler->setThread(dialog->thread->isChecked());
        compiler->setProfile(dialog->profile->isChecked());
        compiler->setCompile(dialog->compile->currentIndex()+1);
        compiler->setTyp(dialog->typ->currentIndex()+1);
        compiler->setFehler(dialog->fehler->currentIndex());
        compiler->setVer(dialog->ver->currentIndex()+1);
        compiler->setName(dialog->name->text());
        if (dialog->fpu->currentIndex() == 1)
        {
            compiler->setFpu(false);
        } else
        {
            compiler->setFpu(true);
        }
        if (dialog->console->currentIndex() == 1)
        {
            compiler->setConsole(false);
        } else
        {
            compiler->setConsole(true);
        }
        compiler->setZusatz(dialog->zusatz->text());
        manager->updateProject(compiler);
    }
    delete dialog;
}










void MainWindow::NoPasteDialogSlot()
{
    NoPasteDialog *dialog = new NoPasteDialog(this);
    int i = dialog->exec();
    if (i == 0 && dialog->bOK == true)
    {

    } else
    {
        dialog->deleteLater();

    }
}










void MainWindow::NoPasteEditDialogSlot()
{
    NoPasteEditDialog *dialog = new NoPasteEditDialog(this);
    int i = dialog->exec();
    if (i == 0 && dialog->bOK == true)
    {

    } else
    {
        dialog->deleteLater();

    }
}










void MainWindow::saveAll()
{
    for (int i = 0;i < bar->count();i++)
    {
        QVariant d = bar->tabData(i);
        QString name = pathMap.value(d.toInt(),0);
        QFile file(name);
        if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
            return;

        QTextStream out(&file);
        out << (map.value(d.toInt(),0)->text2->document())->toPlainText();

        QString tabtext = bar->tabText(i);
        QStringList tabtextlist = tabtext.split(" ");
        if (tabtextlist.last() == "(*)" || tabtextlist.last() == "(*)")
        {
            tabtext.remove(-4,4);
            bar->setTabText(i,tabtext);
        }
    }
}










void MainWindow::guiDesigner()
{
    bool b = false;
    for (int i = 0;i < bar->count();i++)
    {
        if (bar->tabText(i) == "Gui Designer")
        {
            b = true;
        }
    }
    if (b == false)
    {
        tabIndex++;
        gui = new MainWindow2(this,tabIndex);
    }

}







void MainWindow::fbref()
{
    tabIndex++;
    new WebView(this,tabIndex);
}







void MainWindow::irc()
{
    tabIndex++;
    new WebView(this,tabIndex,"");
}
