//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QApplication>
#include <QMainWindow>
#include <QMessageBox>
#include <QTextEdit>
#include <QTabBar>
#include <QVBoxLayout>
#include <QListWidget>
#include <QCheckBox>
#include <QPushButton>
#include <QSettings>
#include <QMdiArea>
#include "compiler.h"
#include "manager.h"
#include "searchwidget.h"
#include "replacewidget.h"
#include "textedit.h"
#include "webview.h"



class Compiler;
class Manager;
class SearchWidget;
class ReplaceWidget;
class TextEdit;
class WebView;

class MainWindow : public QMainWindow
{
    Q_OBJECT
public:
    MainWindow(QSettings *s, QWidget *parent = 0, Qt::WindowFlags flags = 0);
    TextEdit *getText() {return text;}
    WebView *getWeb() { return web;}
    Manager *getManager() { return manager; }
    void setText(TextEdit *edit) { text = edit; }
    void setWeb(WebView *w) { web = w; }
    QMap<int,QString> *getPathMap() { return &pathMap; }
    QMap<int,TextEdit*> *getMap() { return &map; }
    QMap<int,int> *getTypMap() { return &typMap; }
    QMap<int,WebView*> *getWebMap() { return &webMap; }
    QTabBar *getBar() { return bar; }
    bool getProject() { return bProject; }
    bool getTab() { return bTab; }
    void setTab(bool b) { bTab = b; }
    QVBoxLayout *getV() { return v; }
    void setConnections(QTextEdit *edit);
    void setSettings(QSettings *s) {settings = s;}
    QSettings *getSettings() {return settings;}
    Compiler *getCompiler() { return compiler;}
    QAction *getErstellenAct() {return erstellenAct;}
    QAction *getErstellenausAct() {return erstellenausAct;}
    QAction *getErstellenAct2() {return erstellenAct2;}
    QAction *getErstellenausAct2() {return erstellenausAct2;}
    QAction *getStopAct() {return stopAct;}
    QMdiArea *getArea() { return mdiarea; }
    void setArea(QMdiArea *area) {mdiarea = area;}

private:
    void createActions();
    void createMenus();
    void createToolBar();

    
    QMap<int,TextEdit*> map;
    QMap<int,WebView*> webMap;
    QMap<int,QString> pathMap;
    QMap<int, int> typMap;

    int tabIndex;
    Compiler *compiler;
    Manager *manager;
    SearchWidget *search;
    ReplaceWidget *replace;
    QSettings *settings;

    QTabBar *bar;
    QVBoxLayout *v;
    QListWidget *view;
    TextEdit *text;
    WebView *web;
    QMdiArea *mdiarea;


    QMenu *fileMenu;
    QAction *newAct;
    QAction *openAct;
    QAction *newproAct;
    QAction *openproAct;
    QAction *saveAct;
    QAction *saveasAct;
    QAction *saveallAct;
    QAction *exportHTMLAct;
    QAction *exitAct;

    QMenu *editMenu;
    QAction *undoAct;
    QAction *redoAct;
    QAction *cutAct;
    QAction *copyAct;
    QAction *pasteAct;
    QAction *selectallAct;
    QAction *searchAct;
    QAction *replaceAct;
    QAction *gotoAct;

    QAction *newAct2;
    QAction *openAct2;
    QAction *saveAct2;
    QAction *undoAct2;
    QAction *redoAct2;
    QAction *cutAct2;
    QAction *copyAct2;
    QAction *pasteAct2;
    QAction *erstellenAct2;
    QAction *erstellenausAct2;

    QMenu *erstellenMenu;
    QAction *erstellenAct;
    QAction *erstellenausAct;
    QAction *quickrunAct;
    QAction *stopAct;
    QAction *ausfuehrenAct;
    QAction *typeAct;
    QAction *guiAct;
    QAction *proconfigAct;

    QMenu *extraMenu;
    QAction *configAct;
    QAction *NoPasteAct;
    QAction *NoPasteEditAct;

    QMenu *helpMenu;
    QAction *aboutAct;
    QAction *aboutQTAct;
    QAction *fbrefAct;
    QAction *ircAct;

    QMenu *viewMenu;

    QToolBar *ToolBar;

    bool bTab;
    bool bProject;

    int indexMain;

    QMessageBox *box;

public slots:
    void newFile();
    void newFile(QString fileName);
    void openFile();
    void openFile2(QString path);
    void newProject();
    void openProject();
    void save();
    void saveAs(){}
    void saveAll();
    void exportHTML();
    void exit(){ QApplication::exit(0); }

    void searchText();
    void replaceText();
    void gotoLine(){}

    void about() { box->about(this,"Noch namenlose IDE","IDE zur Bearbeitung von FreeBASIC Quelltexten.Hier kommt noch etwas mehr Text :)."); }
    void aboutQT() { box->aboutQt(this); }

    void tabChange(int i);
    void tabClose(int i);

    void undoOK(bool a);
    void redoOK(bool a);

    void configDialog();
    void proconfigDialog();

    void NoPasteDialogSlot();
    void NoPasteEditDialogSlot();

    void guiDesigner();
    void fbref();
    void irc();
protected:
    void closeEvent(QCloseEvent *event);

};

#endif // MAINWINDOW_H
