//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "manager.h"
#include "typedialog.h"


//Manager Klasse, zeigt die Dateien im Projekt an

Manager::Manager(MainWindow *main, QWidget *parent)
        : QWidget(parent)
{
    QWidget *widget = new QWidget;
    QVBoxLayout *v = new QVBoxLayout;
    v->setContentsMargins(0,0,0,0);
    widget->setLayout(v);


    parentWindow = main;
    QDockWidget *dockWidget = new QDockWidget(main->getSettings()->value("Lang/ProjectManager_Titel").toString(), main);
    dockWidget->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea);


    treeWidget = new TreeWidget();
    treeWidget->setSortingEnabled(true);
    treeWidget->setAnimated(true);

    QTreeWidgetItem *project = new QTreeWidgetItem(treeWidget);
    project->setText(0, main->getSettings()->value("Lang/ProjectManager_Project").toString());
    header = new QTreeWidgetItem(project);
    header->setText(0, main->getSettings()->value("Lang/ProjectManager_Header").toString());
    source = new QTreeWidgetItem(project);
    source->setText(0, main->getSettings()->value("Lang/ProjectManager_Source").toString());

    treeWidget->sortItems(0,Qt::AscendingOrder);
    v->addWidget(treeWidget);
    dockWidget->setWidget(widget);
    dockWidget->setObjectName("ProjectDock");
    main->addDockWidget(Qt::LeftDockWidgetArea, dockWidget);

    connect(treeWidget,SIGNAL(doubleClicked(QModelIndex)),this,SLOT(openFile(QModelIndex)));

    treeWidget->menu = new QMenu;
    treeWidget->removeAct = new QAction(main->getSettings()->value("Lang/ProjectManager_Remove").toString(), parentWindow);
    treeWidget->removeAct->setStatusTip(main->getSettings()->value("Lang/ProjectManager_Remove_Status").toString());
    //connect(deleteAct, SIGNAL(triggered()), compiler, SLOT(erstellen()));
    treeWidget->deleteAct = new QAction(QIcon("16x16/actions/edit-delete.png"),main->getSettings()->value("Lang/ProjectManager_Delete").toString(), parentWindow);
    treeWidget->deleteAct->setStatusTip(main->getSettings()->value("Lang/ProjectManager_Delete_Status").toString());
    //connect(deleteAct, SIGNAL(triggered()), compiler, SLOT(erstellen()));

    treeWidget->menu->addAction(treeWidget->removeAct);
    treeWidget->menu->addAction(treeWidget->deleteAct);


    listWidget = new QListWidget;
    listWidget->hide();
    listWidget->setSortingEnabled(true);
    v->addWidget(listWidget);
    connect(listWidget,SIGNAL(itemDoubleClicked(QListWidgetItem*)),this,SLOT(gotoFunc(QListWidgetItem*)));

    listWidget2 = new QListWidget;
    listWidget2->hide();
    listWidget2->setSortingEnabled(true);
    v->addWidget(listWidget2);
    connect(listWidget2,SIGNAL(itemDoubleClicked(QListWidgetItem*)),this,SLOT(gotoFunc(QListWidgetItem*)));

    QTabBar *bar = new QTabBar;
    bar->setShape(QTabBar::RoundedSouth);
    bar->setExpanding(false);
    bar->addTab("Project");
    bar->addTab("Funktionen");
    bar->addTab("Subs");
    connect(bar,SIGNAL(currentChanged(int)),this,SLOT(tabChange(int)));
    v->addWidget(bar);
}









//Fgt eine Datei hinzu
void Manager::addSource(QString string, QString path)
{
    QString f = fileList.join("\b");
    f.replace("//","/");
    QStringList fl = f.split("\b");
    if (fl.contains(path,Qt::CaseSensitive) == true)
    {
        return;
    }
    QString typ = string.section(".",-1);
    if (typ.compare("bas") == 0)
    {
        QTreeWidgetItem *item = new QTreeWidgetItem(source);
        item->setText(0,string);
        item->setData(0,Qt::UserRole,QVariant(path));
        basFileList << path;
    } else if (typ.compare("bi") == 0)
    {
        QTreeWidgetItem *item = new QTreeWidgetItem(header);
        item->setText(0,string);
        item->setData(0,Qt::UserRole,QVariant(path));
    }
    fileList << path;

    QFile file(path);
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
    return;

    QTextStream in(&file);
    QString basText;
    basText = in.readAll();

    QStringList lines = basText.split("\n");


    QStringList subs;
    for (int i = 0;lines.count() > i;i++)
    {
        QStringList l = lines[i].split(" ");
        l.removeAll("");
        if(l.count() >= 2)
        {
            if (l.first().compare("sub",Qt::CaseInsensitive) == 0)
            {
                QListWidgetItem *item = new QListWidgetItem(lines[i]);
                funcItem *fi = new funcItem;
                fi->file = path;
                fi->line = i;
                fi->text = lines[i];
                item->setData(Qt::UserRole,QVariant((int)fi));
                listWidget2->addItem(item);
            }
        }
    }

    QStringList funcs;
    for (int i = 0;lines.count() > i;i++)
    {
        QStringList l = lines[i].split(" ");
        l.removeAll("");
        if(l.count() >= 2)
        {
            if (l.first().compare("function",Qt::CaseInsensitive) == 0)
            {
                funcs << lines[i];
                QListWidgetItem *item = new QListWidgetItem(lines[i]);
                funcItem *fi = new funcItem;
                fi->file = path;
                fi->line = i;
                fi->text = lines[i];
                item->setData(Qt::UserRole,QVariant((int)fi));
                listWidget->addItem(item);
            }
        }
    }


}









//ffnet eine Datei die schon im Projekt ist.
void Manager::openFile(QModelIndex index)
{
    QString string = (index.data(Qt::UserRole)).toString();
    if (string.isEmpty() == false)
    {
        parentWindow->openFile2(string);
    }
}








//Fgt einen Type mit bas und bi Datei hinzu.
void Manager::addType()
{
    TypeDialog *dialog = new TypeDialog;
    QString string;
    string = this->projektPath;
    int l = string.lastIndexOf("/");
    string = string.mid(0,l);
    dialog->path->setText(string);
    int i = dialog->exec();
    if (i == 0 && dialog->bOK == true)
    {
        parentWindow->newFile((dialog->path->text()).append("/").append(dialog->name->text()).append(".bas"));
        parentWindow->getText()->text2->setText(QString("#include \"").append(QString(dialog->name->text()).append(".bi")).append("\"\n\n\n").append("constructor ").append(dialog->name->text()).append("()\n    \nend constructor\n\n\ndestructor ").append(dialog->name->text()).append("()\n    \nend destructor\n"));
        parentWindow->newFile((dialog->path->text()).append("/").append(dialog->name->text()).append(".bi"));
        parentWindow->getText()->text2->setText(QString("type ").append(dialog->name->text()).append("\n    declare constructor()\n    declare destructor()\nend type"));
    }
    delete dialog;
}









//Rumt den Manager auf und macht ihn bereit fr ein anderes Projekt
void Manager::closeProject()
{
    treeWidget->clear();
    QTreeWidgetItem *project = new QTreeWidgetItem(treeWidget);
    project->setText(0, parentWindow->getSettings()->value("Lang/ProjectManager_Project").toString());
    header = new QTreeWidgetItem(project);
    header->setText(0, parentWindow->getSettings()->value("Lang/ProjectManager_Header").toString());
    source = new QTreeWidgetItem(project);
    source->setText(0, parentWindow->getSettings()->value("Lang/ProjectManager_Source").toString());

    treeWidget->sortItems(0,Qt::AscendingOrder);

    basFileList.clear();
    fileList.clear();
}








//Context Men, beide Eintrge sind noch nicht verbaut.
void TreeWidget::contextMenuEvent ( QContextMenuEvent * event )
{
    if (itemAt(event->pos()) != 0)
    {
        menu->exec(event->globalPos());
    }
}










//Erneuert die Projekt Datei, wird nach dem Projekt Einstellungen Dialog aufgerufen oder wenn eine Datei zum Projekt hinzugefgt wird.
void Manager::updateProject(Compiler *compiler)
{
    QFile file2(projektPath);
    if (!file2.open(QIODevice::WriteOnly | QIODevice::Text))
        return;

    QTextStream out2(&file2);
    out2 << compiler->getName() << ";";
    out2 << compiler->getArch() << ";";
    out2 << compiler->getAssembler() << ";";
    out2 << compiler->getCompile() << ";";
    out2 << compiler->getConsole() << ";";
    out2 << compiler->getDebug() << ";";
    out2 << compiler->getFehler() << ";";
    out2 << compiler->getFpu() << ";";
    out2 << compiler->getObject() << ";";
    out2 << compiler->getProfile() << ";";
    out2 << compiler->getStack() << ";";
    out2 << compiler->getThread() << ";";
    out2 << compiler->getTyp() << ";";
    out2 << compiler->getVer() << ";";
    out2 << compiler->getZusatz() << ";";
    out2 << getFileList().join(";");
}









void Manager::tabChange(int index)
{
    if (index == 0)
    {
        listWidget->hide();
        listWidget2->hide();
        treeWidget->show();
    } else if (index == 1)
    {
        listWidget->show();
        listWidget2->hide();
        treeWidget->hide();
    } else if (index == 2)
    {
        listWidget->hide();
        listWidget2->show();
        treeWidget->hide();
    }
}







void Manager::gotoFunc(QListWidgetItem *item)
{
    funcItem *fi = (funcItem*)item->data(Qt::UserRole).toInt();
    parentWindow->openFile2(fi->file);
    QTextCursor cur(parentWindow->getText()->text2->document());
    cur.movePosition(QTextCursor::Down,QTextCursor::MoveAnchor,fi->line);
    cur.movePosition(QTextCursor::StartOfLine);
    parentWindow->getText()->text2->setTextCursor(cur);
    parentWindow->getText()->text2->setFocus();
}
