//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#ifndef MANAGER_H
#define MANAGER_H

#include <QWidget>
#include <QTreeWidgetItem>
#include <QMap>
#include <QStringList>
#include "mainwindow.h"
#include "compiler.h"

class MainWindow;
class Compiler;

class funcItem
{
public:
    QString text;
    QString file;
    int line;
};



class TreeWidget : public QTreeWidget
{
public:
    QMenu *menu;
    QAction *deleteAct;
    QAction *removeAct;
protected:
    void contextMenuEvent ( QContextMenuEvent * event );
};


class Manager : public QWidget
{
    Q_OBJECT
public:
    Manager(MainWindow *main, QWidget *parent = 0);
    void addSource(QString string,QString path);
    QStringList getFileList() { return fileList; }
    QStringList getBasFileList() { return basFileList; }
    TreeWidget *getTreeWidget() { return treeWidget; }
    QListWidget *getListWidget() { return listWidget; }
    QListWidget *getListWidget2() { return listWidget2; }
    QTreeWidgetItem *getSource() { return source; }
    QTreeWidgetItem *getHeader() { return header; }
    QString projektPath;

private:
    TreeWidget *treeWidget;
    QTreeWidgetItem *source;
    QTreeWidgetItem *header;
    QMap<QString,QString> map;
    QStringList fileList;
    QStringList basFileList;
    QListWidget *listWidget;
    QListWidget *listWidget2;
    MainWindow *parentWindow;

public slots:
    void addType();
    void updateProject(Compiler *compiler);
    void closeProject();

private slots:
    void openFile(QModelIndex index);
    void tabChange(int index);
    void gotoFunc(QListWidgetItem *item);
};

#endif // MANAGER_H
