#include <QtGui>
#include <QtNetwork>
#include "nopastedialog.h"
#include "highlighter.h"

NoPasteDialog::NoPasteDialog(MainWindow *main)
        : QDialog()
{
    window = main;
    http = 0;
    http2 = 0;
    httpFile = 0;
    this->resize(800,600);
    QVBoxLayout *box = new QVBoxLayout;
    box->addWidget(new QLabel(main->getSettings()->value("Lang/NoPaste_User").toString()));
    name = new QLineEdit();
    name->setText(main->getSettings()->value("NoPaste/User","").toString());
    box->addWidget(name);
    pw = new QLineEdit();
    box->addWidget(new QLabel(main->getSettings()->value("Lang/NoPaste_Password").toString()));
    pw->setText(main->getSettings()->value("NoPaste/PW","").toString());
    box->addWidget(pw);
    box->addSpacing(20);
    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addWidget(new QLabel("Titel: "));
    titeledit = new QLineEdit;
    h2->addWidget(titeledit);
    box->addLayout(h2);
    text = new QTextEdit();

    Highlighter *highlight = new Highlighter(text->document(),text);
    box->addWidget(text);

    QPushButton *about = new QPushButton(main->getSettings()->value("Lang/NoPaste_About").toString());
    connect(about,SIGNAL(clicked()),this,SLOT(aboutNoPaste()));
    QPushButton *ok = new QPushButton(main->getSettings()->value("Lang/Button_OK").toString());
    connect(ok,SIGNAL(clicked()),this,SLOT(OK()));
    QPushButton *cancle = new QPushButton(main->getSettings()->value("Lang/Button_Cancle").toString());
    connect(cancle,SIGNAL(clicked()),this,SLOT(cancle()));

    QHBoxLayout *h = new QHBoxLayout;
    h->addWidget(about);
    h->addStretch();
    h->addWidget(ok);
    h->addWidget(cancle);
    box->addLayout(h);
    setLayout (box);







}







void NoPasteDialog::OK()
{
    QMessageBox box;
    if (name->text().isEmpty() == true)
    {
        box.setText(window->getSettings()->value("Lang/NoPaste_Error_User").toString());
        box.exec();
        return;
    }
    if (pw->text().isEmpty() == true)
    {
        box.setText(window->getSettings()->value("Lang/NoPaste_Error_Password").toString());
        box.exec();
        return;
    }
    if (titeledit->text().isEmpty() == true)
    {
        box.setText(window->getSettings()->value("Lang/NoPaste_Error_Titel").toString());
        box.exec();
        return;
    }

    QString post2("pw=");
    post2.append(pw->text());
    QByteArray datas2 = QString(post2).toAscii();

    if (http2 != 0)
    {
        delete http2;
    }
    http2 = new QHttp("www.freebasic-portal.de");
    QHttpRequestHeader request2("POST",QString("/md5calc.php"));
    request2.setValue("Host", "www.freebasic-portal.de");
    request2.setValue("Content-Type", "application/x-www-form-urlencoded");


    http2->request(request2,datas2);
    connect(http2,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(getHash()));





}










void NoPasteDialog::cancle()
{
    this->done(1);
}










void NoPasteDialog::readyToRead()
{
    QString string = http->readAll();
    QStringList list = string.split(" ");
    list.removeAll("");
    list.removeAll("\n");
    if (list.count() == 2)
    {
        QMessageBox::information(this,window->getSettings()->value("Lang/NoPaste_Success_Titel").toString(),QString(window->getSettings()->value("Lang/NoPaste_Success_Text1").toString()).append(list[1]).append(window->getSettings()->value("Lang/NoPaste_Success_Text2").toString()));
        bOK = true;
        this->done(0);
        window->getSettings()->setValue("NoPaste/User",name->text());
        window->getSettings()->setValue("NoPaste/PW",pw->text());
    } else
    {
        QMessageBox::critical(this,window->getSettings()->value("Lang/Error_Titel").toString(),string);
    }
}






void NoPasteDialog::getHash()
{
    QString password = http2->readAll();
    QByteArray sbt = titeledit->text().toAscii();
    QTextCodec *codec = QTextCodec::codecForName("Windows-1252");
    QString st = codec->toUnicode(sbt);
    QString src = st;
    QString post("Titel=");
    post.append(src);
    sbt = text->toPlainText().toAscii();
    codec = QTextCodec::codecForName("Windows-1252");
    st = codec->toUnicode(sbt);
    src = st;
    post.append("&Quelltext=");
    src.replace("%","%25");
    post.append(src);
    QByteArray datas = QString(post).toAscii();


    http = new QHttp("www.freebasic-portal.de");
    QHttpRequestHeader request("POST",QString("/porticula.php?action=newcode&username=").append(name->text()).append("&pwhash=").append(password));
    request.setValue("Host", "www.freebasic-portal.de");
    request.setValue("Content-Type", "application/x-www-form-urlencoded");




    http->request(request,datas);


    connect(http,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(readyToRead()));

}










void NoPasteDialog::aboutNoPaste()
{
    if (httpFile != 0)
    {
        delete httpFile;
    }
    httpFile = new QHttp("www.freebasic-portal.de");
    QHttpRequestHeader request("GET",QString("/porticula.php?action=info"));
    request.setValue("Host", "www.freebasic-portal.de");
    request.setValue("User-Agent", "IDE");

    httpFile->request(request);


    connect(httpFile,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(readAbout()));
}









void NoPasteDialog::readAbout()
{
    QMessageBox::about(this,window->getSettings()->value("Lang/NoPaste_About").toString(),httpFile->readAll());
}
