#include <QtGui>
#include <QtNetwork>
#include "nopasteeditdialog.h"
#include "highlighter.h"


NoPasteEditDialog::NoPasteEditDialog(MainWindow *main)
        : QDialog()
{
    window = main;
    http2 = 0;
    httpList = 0;
    httpFile = 0;
    this->resize(800,600);
    QVBoxLayout *box = new QVBoxLayout;
    box->addWidget(new QLabel(window->getSettings()->value("Lang/NoPaste_User").toString()));
    name = new QLineEdit();
    name->setText(main->getSettings()->value("NoPaste/User","").toString());
    box->addWidget(name);
    pw = new QLineEdit();
    pw->setText(main->getSettings()->value("NoPaste/PW","").toString());
    box->addWidget(new QLabel(window->getSettings()->value("Lang/NoPaste_Password").toString()));
    box->addWidget(pw);



    QHBoxLayout *h3 = new QHBoxLayout;
    listBox = new QComboBox;
    h3->addWidget(new QLabel(window->getSettings()->value("Lang/NoPaste_Load").toString()));
    h3->addWidget(listBox,1);
    QPushButton *open = new QPushButton(window->getSettings()->value("Lang/NoPaste_Open").toString());
    connect(open,SIGNAL(clicked()),this,SLOT(openFile()));
    h3->addWidget(open);
    QPushButton *remove = new QPushButton(window->getSettings()->value("Lang/NoPaste_Delete").toString());
    connect(remove,SIGNAL(clicked()),this,SLOT(removeFile()));
    h3->addWidget(remove);
    QPushButton *load = new QPushButton(window->getSettings()->value("Lang/NoPaste_Load_Button").toString());
    connect(load,SIGNAL(clicked()),this,SLOT(loadList()));
    h3->addWidget(load);
    h3->addStretch();
    box->addLayout(h3);

    box->addSpacing(20);
    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addWidget(new QLabel(window->getSettings()->value("Lang/NoPaste_Titel").toString()));
    titeledit = new QLineEdit;
    h2->addWidget(titeledit);
    box->addLayout(h2);
    text = new QTextEdit();

    Highlighter *highlight = new Highlighter(text->document(),text);
    box->addWidget(text);

    QPushButton *about = new QPushButton(window->getSettings()->value("Lang/NoPaste_About").toString());
    connect(about,SIGNAL(clicked()),this,SLOT(aboutNoPaste()));
    QPushButton *ok = new QPushButton(window->getSettings()->value("Lang/Button_OK").toString());
    connect(ok,SIGNAL(clicked()),this,SLOT(OK()));
    QPushButton *cancle = new QPushButton(window->getSettings()->value("Lang/Button_Cancle").toString());
    connect(cancle,SIGNAL(clicked()),this,SLOT(cancle()));

    QHBoxLayout *h = new QHBoxLayout;
    h->addWidget(about);
    h->addStretch();
    h->addWidget(ok);
    h->addWidget(cancle);
    box->addLayout(h);
    setLayout (box);






}







void NoPasteEditDialog::OK()
{
    QMessageBox box;
    if (name->text().isEmpty() == true)
    {
        box.setText(window->getSettings()->value("Lang/NoPaste_Error_User").toString());
        box.exec();
        return;
    }
    if (pw->text().isEmpty() == true)
    {
        box.setText(window->getSettings()->value("Lang/NoPaste_Error_Password").toString());
        box.exec();
        return;
    }
    if (titeledit->text().isEmpty() == true)
    {
        box.setText(window->getSettings()->value("Lang/NoPaste_Error_Titel").toString());
        box.exec();
        return;
    }

    QString post2("pw=");
    post2.append(pw->text());
    QByteArray datas2 = QString(post2).toAscii();


    if (http2 != 0)
    {
        delete http2;
    }
    http2 = new QHttp("www.freebasic-portal.de");
    QHttpRequestHeader request2("POST",QString("/md5calc.php"));
    request2.setValue("Host", "www.freebasic-portal.de");
    request2.setValue("Content-Type", "application/x-www-form-urlencoded");


    http2->request(request2,datas2);
    connect(http2,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(getHash()));





}










void NoPasteEditDialog::cancle()
{
    this->done(1);
}










void NoPasteEditDialog::readyToRead()
{
    QString string = http->readAll();
    QStringList list = string.split(" ");
    list.removeAll("");
    list.removeAll("\n");
    bOK = true;
    this->done(0);

}






void NoPasteEditDialog::getHash()
{
    QString password = http2->readAll();
    QByteArray sbt = titeledit->text().toAscii();
    QTextCodec *codec = QTextCodec::codecForName("Windows-1252");
    QString st = codec->toUnicode(sbt);
    QString src = st;
    QString post("Titel=");
    post.append(src);
    sbt = text->toPlainText().toAscii();
    codec = QTextCodec::codecForName("Windows-1252");
    st = codec->toUnicode(sbt);
    src = st;
    post.append("&Quelltext=");
    post.append(src);
    QByteArray datas = QString(post).toAscii();


    http = new QHttp("www.freebasic-portal.de");
    QString idstring = listBox->itemText(listBox->currentIndex());
    QStringList idlist = idstring.split(";");
    QHttpRequestHeader request("POST",QString("/porticula.php?action=savecode&id=").append(idlist.first()).append("&username=").append(name->text()).append("&pwhash=").append(password));
    request.setValue("Host", "www.freebasic-portal.de");
    request.setValue("Content-Type", "application/x-www-form-urlencoded");




    http->request(request,datas);


    connect(http,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(readyToRead()));

}









void NoPasteEditDialog::getHash2()
{
    QString password = http2->readAll();
    QByteArray sbt = text->toPlainText().toAscii();
    QTextCodec *codec = QTextCodec::codecForName("Windows-1252");
    QString st = codec->toUnicode(sbt);
    QString src = st;
    QString post("Titel=IDE&Quelltext=");
    post.append(src);
    QByteArray datas = QString(post).toAscii();


    if (httpList != 0)
    {
        delete httpList;
    }
    httpList = new QHttp("www.freebasic-portal.de");
    QHttpRequestHeader request("GET",QString("/porticula.php?action=list&username=").append(name->text()).append("&pwhash=").append(password));
    request.setValue("Host", "www.freebasic-portal.de");

    httpList->request(request,datas);


    connect(httpList,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(readList()));
}









void NoPasteEditDialog::getHash3()
{
    QString password = http2->readAll();
    QByteArray sbt = text->toPlainText().toAscii();
    QTextCodec *codec = QTextCodec::codecForName("Windows-1252");
    QString st = codec->toUnicode(sbt);
    QString src = st;
    QString post("Titel=IDE&Quelltext=");
    post.append(src);
    QByteArray datas = QString(post).toAscii();


    if (httpFile != 0)
    {
        delete httpFile;
    }
    httpFile = new QHttp("www.freebasic-portal.de");
    QString idstring = listBox->itemText(listBox->currentIndex());
    QStringList idlist = idstring.split(";");
    QHttpRequestHeader request("GET",QString("/porticula.php?action=readcode&id=").append(idlist.first()).append("&username=").append(name->text()).append("&pwhash=").append(password));
    request.setValue("Host", "www.freebasic-portal.de");

    httpFile->request(request,datas);


    connect(httpFile,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(readFile()));

}










void NoPasteEditDialog::getHash4()
{
    QMessageBox box;
    box.setText(window->getSettings()->value("Lang/NoPaste_Delete_Text").toString());
    box.setStandardButtons(QMessageBox::No | QMessageBox::Yes);
    box.setIcon(QMessageBox::Question);
    if (box.exec() == QMessageBox::No)
    {
        return;
    }
    QString password = http2->readAll();
    QByteArray sbt = text->toPlainText().toAscii();
    QTextCodec *codec = QTextCodec::codecForName("Windows-1252");
    QString st = codec->toUnicode(sbt);
    QString src = st;
    QString post("Titel=IDE&Quelltext=");
    post.append(src);
    QByteArray datas = QString(post).toAscii();


    if (httpFile != 0)
    {
        delete httpFile;
    }
    httpFile = new QHttp("www.freebasic-portal.de");
    QString idstring = listBox->itemText(listBox->currentIndex());
    QStringList idlist = idstring.split(";");
    QHttpRequestHeader request("GET",QString("/porticula.php?action=delete&id=").append(idlist.first()).append("&username=").append(name->text()).append("&pwhash=").append(password));
    request.setValue("Host", "www.freebasic-portal.de");

    httpFile->request(request,datas);


    connect(httpFile,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(deleteFile()));

}










void NoPasteEditDialog::readList()
{
    listBox->clear();
    QString string = httpList->readAll();
    QStringList list = string.split(QChar(10));
    list.removeAll("");
    listBox->addItems(list);
}









void NoPasteEditDialog::loadList()
{
    QString post2("pw=");
    post2.append(pw->text());
    QByteArray datas2 = QString(post2).toAscii();

    if (http2 != 0)
    {
        delete http2;
    }
    http2 = new QHttp("www.freebasic-portal.de");
    QHttpRequestHeader request2("POST",QString("/md5calc.php"));
    request2.setValue("Host", "www.freebasic-portal.de");
    request2.setValue("Content-Type", "application/x-www-form-urlencoded");


    http2->request(request2,datas2);
    connect(http2,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(getHash2()));
}









void NoPasteEditDialog::openFile()
{
    QString post2("pw=");
    post2.append(pw->text());
    QByteArray datas2 = QString(post2).toAscii();

    if (http2 != 0)
    {
        delete http2;
    }
    http2 = new QHttp("www.freebasic-portal.de");
    QHttpRequestHeader request2("POST",QString("/md5calc.php"));
    request2.setValue("Host", "www.freebasic-portal.de");
    request2.setValue("Content-Type", "application/x-www-form-urlencoded");


    http2->request(request2,datas2);
    connect(http2,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(getHash3()));
}









void NoPasteEditDialog::readFile()
{
    QString datas(httpFile->readAll());
    datas.replace("+"," ");
    datas.replace("%21","!");
    datas.replace("%2A","*");
    datas.replace("%22","\"");
    datas.replace("%27","'");
    datas.replace("%28","(");
    datas.replace("%29",")");
    datas.replace("%3B",";");
    datas.replace("%3A",":");
    datas.replace("%40","@");
    datas.replace("%26","&");
    datas.replace("%3D","=");
    datas.replace("%2B","+");
    datas.replace("%24","$");
    datas.replace("%2C",",");
    datas.replace("%2F","/");
    datas.replace("%3F","?");
    datas.replace("%25","%");
    datas.replace("%23","#");
    datas.replace("%5B","[");
    datas.replace("%5D","]");

    datas.replace("%3C","<");
    datas.replace("%3E",">");
    datas.replace("%7E","~");
    datas.replace("%2E",".");
    datas.replace("%7B","{");
    datas.replace("%7D","}");
    datas.replace("%7C","|");
    datas.replace("%5C","\\");
    datas.replace("%2D","-");
    datas.replace("%60","`");
    datas.replace("%5F","_");
    datas.replace("%5E","^");

    datas.replace("%F6","");
    datas.replace("%E4","");
    datas.replace("%FC","");
    datas.replace("%DF","");
    datas.replace("%0A","\n");
    datas.replace("%DC","");
    datas.replace("%C4","");
    datas.replace("%D6","");
    datas.replace("%09","   ");


    QStringList list = datas.split(QChar(10));
    if (list.count() >= 4)
    {
        list.removeFirst();
        list.removeFirst();
        titeledit->setText(list.first());
        list.removeFirst();
        text->setPlainText(list.join(QChar(10)));
    }
    window->getSettings()->setValue("NoPaste/User",name->text());
    window->getSettings()->setValue("NoPaste/PW",pw->text());

}











void NoPasteEditDialog::removeFile()
{
    QString post2("pw=");
    post2.append(pw->text());
    QByteArray datas2 = QString(post2).toAscii();

    if (http2 != 0)
    {
        delete http2;
    }
    http2 = new QHttp("www.freebasic-portal.de");
    QHttpRequestHeader request2("POST",QString("/md5calc.php"));
    request2.setValue("Host", "www.freebasic-portal.de");
    request2.setValue("Content-Type", "application/x-www-form-urlencoded");


    http2->request(request2,datas2);
    connect(http2,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(getHash4()));
}











void NoPasteEditDialog::deleteFile()
{
    QString string = http2->readAll();
    if (string == "SUCCESS" || string == "")
    {
        QMessageBox::information(this,window->getSettings()->value("Lang/NoPaste_Success").toString(),window->getSettings()->value("Lang/NoPaste_Success_Delete").toString());
    } else
    {
        QMessageBox::critical(this,window->getSettings()->value("Lang/Error_Titel").toString(),string);
    }
}










void NoPasteEditDialog::aboutNoPaste()
{
    if (httpFile != 0)
    {
        delete httpFile;
    }
    httpFile = new QHttp("www.freebasic-portal.de");
    QString idstring = listBox->itemText(listBox->currentIndex());
    QStringList idlist = idstring.split(";");
    QHttpRequestHeader request("GET",QString("/porticula.php?action=info"));
    request.setValue("Host", "www.freebasic-portal.de");
    request.setValue("User-Agent", "IDE");

    httpFile->request(request);


    connect(httpFile,SIGNAL(readyRead(QHttpResponseHeader)),this,SLOT(readAbout()));
}









void NoPasteEditDialog::readAbout()
{
    QMessageBox::about(this,window->getSettings()->value("Lang/NoPaste_About").toString(),httpFile->readAll());
}
