//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "compiler.h"
#include "projectconfigdialog.h"


//Dialog fr Projekt Einstellungen

ProjectConfigDialog::ProjectConfigDialog(Compiler *compiler)
        : QDialog()
{
    bOK = false;
    compiler2 = compiler;
    this->resize(400,450);
    QVBoxLayout *vbox = new QVBoxLayout;

    QHBoxLayout *hbox = new QHBoxLayout;
    name = new QLineEdit;
    name->setText(compiler->getName());
    hbox->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Out").toString()));
    hbox->addWidget(name);
    vbox->addLayout(hbox);

    QHBoxLayout *hbox1 = new QHBoxLayout;
    console = new QComboBox;
    console->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Console").toString());
    console->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Gui").toString());
    console->setCurrentIndex(!compiler->getConsole());
    hbox1->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_UI").toString()));
    hbox1->addStretch();
    hbox1->addWidget(console);
    vbox->addLayout(hbox1);

    QHBoxLayout *hbox8 = new QHBoxLayout;
    ver = new QComboBox;
    ver->addItem("fb");
    ver->addItem("qb");
    ver->addItem("deprecated");
    ver->addItem("fblite");
    ver->setCurrentIndex(compiler->getVer()-1);
    hbox8->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Version").toString()));
    hbox8->addStretch();
    hbox8->addWidget(ver);
    vbox->addLayout(hbox8);

    QHBoxLayout *hbox2 = new QHBoxLayout;
    arch = new QComboBox;
    QStringList list;
    list << "386" << "486" << "586" << "686";
    arch->addItems(list);
    arch->setCurrentIndex(compiler->getArch()-1);
    hbox2->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Arch").toString()));
    hbox2->addStretch();
    hbox2->addWidget(arch);
    vbox->addLayout(hbox2);

    QHBoxLayout *hbox3 = new QHBoxLayout;
    fpu = new QComboBox;
    fpu->addItem("FPU");
    fpu->addItem("SSE");
    fpu->setCurrentIndex(!compiler->getFpu());
    hbox3->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Float").toString()));
    hbox3->addStretch();
    hbox3->addWidget(fpu);
    vbox->addLayout(hbox3);

    QHBoxLayout *hbox4 = new QHBoxLayout;
    compile = new QComboBox;
    compile->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Mode_A").toString());
    compile->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Mode_C").toString());
    compile->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Mode_L").toString());
    compile->setCurrentIndex(compiler->getCompile()-1);
    hbox4->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Mode").toString()));
    hbox4->addStretch();
    hbox4->addWidget(compile);
    vbox->addLayout(hbox4);

    QHBoxLayout *hbox5 = new QHBoxLayout;
    typ = new QComboBox;
    typ->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Exe").toString());
    typ->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Dll").toString());
    typ->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Lib").toString());
    typ->setCurrentIndex(compiler->getTyp()-1);
    hbox5->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Typ").toString()));
    hbox5->addStretch();
    hbox5->addWidget(typ);
    vbox->addLayout(hbox5);

    QHBoxLayout *hbox6 = new QHBoxLayout;
    fehler = new QComboBox;
    fehler->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Error_Off").toString());
    fehler->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Error_Normal").toString());
    fehler->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Error_Advance").toString());
    fehler->addItem(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Error_Extra").toString());
    fehler->setCurrentIndex(compiler->getFehler());
    hbox6->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Error").toString()));
    hbox6->addStretch();
    hbox6->addWidget(fehler);
    vbox->addLayout(hbox6);

    QHBoxLayout *hbox7 = new QHBoxLayout;
    stack = new QSpinBox;
    stack->setMinimum(0);
    stack->setMaximum(8388608);
    stack->setValue(compiler->getStack());
    hbox7->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Stack").toString()));
    hbox7->addStretch();
    hbox7->addWidget(stack);
    hbox7->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Stack_KB").toString()));
    vbox->addLayout(hbox7);

    object = new QCheckBox(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_ONotDelete").toString());
    object->setChecked(compiler->getObject());
    vbox->addWidget(object);

    asmfile = new QCheckBox(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_ANotDelete").toString());
    asmfile->setChecked(compiler->getAssembler());
    vbox->addWidget(asmfile);

    debug = new QCheckBox(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Debug").toString());
    debug->setChecked(compiler->getDebug());
    vbox->addWidget(debug);

    thread = new QCheckBox(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Thread").toString());
    thread->setChecked(compiler->getThread());
    vbox->addWidget(thread);

    profile = new QCheckBox(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Prof").toString());
    profile->setChecked(compiler->getProfile());
    vbox->addWidget(profile);

    QHBoxLayout *hbox9 = new QHBoxLayout;
    zusatz = new QLineEdit;
    zusatz->setText(compiler->getZusatz());
    hbox9->addWidget(new QLabel(compiler->getParentWindow()->getSettings()->value("Lang/Project_Config_Parameter").toString()));
    hbox9->addWidget(zusatz);
    vbox->addLayout(hbox9);


    //Vorschau Feld
    view = new QTextEdit;
    view->zoomOut(1);
    view->setReadOnly(true);
    vbox->addWidget(view);
    setLayout(vbox);


    vbox->addStretch();
    QHBoxLayout *h = new QHBoxLayout;
    QPushButton *okbutton = new QPushButton(compiler->getParentWindow()->getSettings()->value("Lang/Button_OK").toString());
    QPushButton *canclebutton = new QPushButton(compiler->getParentWindow()->getSettings()->value("Lang/Button_Cancle").toString());
    h->addStretch();
    h->addWidget(okbutton);
    h->addWidget(canclebutton);
    vbox->addLayout(h);




    connect(okbutton,SIGNAL(clicked()),this,SLOT(ok()));
    connect(canclebutton,SIGNAL(clicked()),this,SLOT(cancle()));

    //Verbindet jede Aktion im Dialog mit der Vorschau
    connect(console,SIGNAL(currentIndexChanged(int)),this,SLOT(updateView()));
    connect(ver,SIGNAL(currentIndexChanged(int)),this,SLOT(updateView()));
    connect(arch,SIGNAL(currentIndexChanged(int)),this,SLOT(updateView()));
    connect(fpu,SIGNAL(currentIndexChanged(int)),this,SLOT(updateView()));
    connect(compile,SIGNAL(currentIndexChanged(int)),this,SLOT(updateView()));
    connect(typ,SIGNAL(currentIndexChanged(int)),this,SLOT(updateView()));
    connect(fehler,SIGNAL(currentIndexChanged(int)),this,SLOT(updateView()));
    connect(stack,SIGNAL(valueChanged(int)),this,SLOT(updateView()));
    connect(object,SIGNAL(stateChanged(int)),this,SLOT(updateView()));
    connect(thread,SIGNAL(stateChanged(int)),this,SLOT(updateView()));
    connect(debug,SIGNAL(stateChanged(int)),this,SLOT(updateView()));
    connect(asmfile,SIGNAL(stateChanged(int)),this,SLOT(updateView()));
    connect(profile,SIGNAL(stateChanged(int)),this,SLOT(updateView()));
    connect(zusatz,SIGNAL(textChanged(QString)),this,SLOT(updateView()));
    connect(name,SIGNAL(textChanged(QString)),this,SLOT(updateView()));
    updateView();
}










void ProjectConfigDialog::ok()
{
    QMessageBox box;
    if (name->text().isEmpty() == true)
    {
        box.setText(compiler2->getParentWindow()->getSettings()->value("Lang/Project_Config_ErrorText").toString());
        box.exec();
        return;
    }
    bOK = true;
    this->done(0);
}










void ProjectConfigDialog::cancle()
{
    this->done(1);
}








//Aktuallisiert die Vorschau
void ProjectConfigDialog::updateView()
{
    QString string = compiler2->getFB();

    string.append(" -b \"");
    string.append(compiler2->getParentWindow()->getManager()->getBasFileList().join("\" -b \""));


    QString fileName = name->text();

    fileName.append(".exe");

    string.append("\" -x ").append("\"").append(fileName).append("\"");
    string.append(" -v -maxerr inf");


    char buffer[255];
    itoa(stack->value(),buffer,10);
    string.append(" -t ").append(buffer);


    if (ver->currentIndex()+1 == 1)
    {
        string.append(" -lang fb");
    } else if(ver->currentIndex()+1 == 2)
    {
        string.append(" -lang qb");
    } else if(ver->currentIndex()+1 == 3)
    {
        string.append(" -lang deprecated");
    } else if(ver->currentIndex()+1 == 4)
    {
        string.append(" -lang fblite");
    }


    if (arch->currentIndex()+1 == 1)
    {
        string.append(" -arch 386");
    } else if(arch->currentIndex()+1 == 2)
    {
        string.append(" -arch 486");
    } else if(arch->currentIndex()+1 == 3)
    {
        string.append(" -arch 586");
    } else if(arch->currentIndex()+1 == 4)
    {
        string.append(" -arch 686");
    }


    if (fpu->currentIndex() == 1)
    {
        string.append(" -fpu SSE");
    } else
    {
        string.append(" -fpu FPU");
    }


    if(fehler->currentIndex() == 1)
    {
        string.append(" -e");
    } else if(fehler->currentIndex() == 2)
    {
        string.append(" -ex");
    } else if(fehler->currentIndex() == 3)
    {
        string.append(" -exx");
    }


    if (debug->isChecked() == true)
    {
        string.append(" -g");
    }


    if (thread->isChecked() == true)
    {
        string.append(" -mt");
    }


    if (profile->isChecked() == true)
    {
        string.append(" -profile");
    }


    if (console->currentIndex() == 1)
    {
        string.append(" -s gui");
    }


    if (asmfile->isChecked() == true)
    {
        string.append(" -R");
    }


    if (object->isChecked() == true)
    {
        string.append(" -C");
    }


    if(typ->currentIndex()+1 == 2)
    {
        string.append(" -dylib");
    } else if(typ->currentIndex()+1 == 3)
    {
        string.append(" -lib");
    }


    if (compile->currentIndex()+1 == 1)
    {
        string.append(" -r");
    } else if(compile->currentIndex()+1 == 2)
    {
        string.append(" -c");
    }

    string.append(" -noerrline");

    string.append(" ").append(zusatz->text());
    string.remove(QRegExp("[\n]"));
    view->setPlainText(string);
}
