//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "replacewidget.h"

ReplaceWidget::ReplaceWidget(MainWindow *main, QWidget *parent)
        : QWidget(parent)
{
    parentWindow = main;
    replace = new QDockWidget(parentWindow->getSettings()->value("Lang/Replace_Titel").toString(), main);
    replace->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea | Qt::TopDockWidgetArea);
    replace->setObjectName("replaceDock");

    QVBoxLayout *replaceBox = new QVBoxLayout();
    replaceEdit = new QLineEdit();
    replaceEdit2 = new QLineEdit();
    replaceBox->addWidget(replaceEdit,Qt::AlignTop);
    replaceBox->addWidget(replaceEdit2,Qt::AlignTop);
    replaceCase = new QCheckBox(parentWindow->getSettings()->value("Lang/Search_CaseSensitiv").toString());
    replaceWhole = new QCheckBox(parentWindow->getSettings()->value("Lang/Search_Whole_Words").toString());
    replaceBack = new QCheckBox(parentWindow->getSettings()->value("Lang/Search_Back").toString());
    replaceButton = new QPushButton(parentWindow->getSettings()->value("Lang/Replace_Titel").toString());
    replaceButton2 = new QPushButton(parentWindow->getSettings()->value("Lang/Replace_All").toString());
    connect(replaceButton,SIGNAL(clicked()),this,SLOT(replaceText()));
    connect(replaceButton2,SIGNAL(clicked()),this,SLOT(replaceAllText()));
    replaceBox->addWidget(replaceCase);
    replaceBox->addWidget(replaceWhole);
    replaceBox->addWidget(replaceBack);
    replaceBox->addWidget(replaceButton);
    replaceBox->addWidget(replaceButton2);
    replaceBox->addStretch();
    this->setLayout(replaceBox);

    replace->setWidget(this);
    main->addDockWidget(Qt::LeftDockWidgetArea, replace);
}










void ReplaceWidget::replaceText()
{
    if (parentWindow->getBar()->count() < 1)
    {
        QMessageBox box;
        box.setText(parentWindow->getSettings()->value("Lang/Search_Error").toString());
        box.exec();
        return;
    }
    if (parentWindow->getText() != 0)
    {
        QTextCursor cursor = parentWindow->getText()->text2->textCursor();
        QTextDocument::FindFlags option = 0;
        if (replaceCase->checkState() == Qt::Checked)
        {
            option = option | QTextDocument::FindCaseSensitively;
        }
        if (replaceWhole->checkState() == Qt::Checked)
        {
            option = option | QTextDocument::FindWholeWords;
        }
        if (replaceBack->checkState() == Qt::Checked)
        {
            option = option | QTextDocument::FindBackward;
        }
        cursor = (parentWindow->getText()->text2->document())->find(replaceEdit->text(),cursor,option);
        if (cursor.isNull() == false)
        {
            cursor.insertText(replaceEdit2->text());
            parentWindow->getText()->text2->setTextCursor(cursor);
        }
        parentWindow->getText()->setFocus(Qt::BacktabFocusReason);
    }
}










void ReplaceWidget::replaceAllText()
{
    if (parentWindow->getBar()->count() < 1)
    {
        QMessageBox box;
        box.setText(parentWindow->getSettings()->value("Lang/Search_Error").toString());
        box.exec();
        return;
    }
    if (parentWindow->getText() != 0)
    {
        for (;;)
        {
            QTextCursor cursor = parentWindow->getText()->text2->textCursor();
            QTextDocument::FindFlags option = 0;
            if (replaceCase->checkState() == Qt::Checked)
            {
                option = option | QTextDocument::FindCaseSensitively;
            }
            if (replaceWhole->checkState() == Qt::Checked)
            {
                option = option | QTextDocument::FindWholeWords;
            }
            if (replaceBack->checkState() == Qt::Checked)
            {
                option = option | QTextDocument::FindBackward;
            }
            cursor = (parentWindow->getText()->text2->document())->find(replaceEdit->text(),cursor,option);
            if (cursor.isNull() == false)
            {
                cursor.insertText(replaceEdit2->text());
                parentWindow->getText()->text2->setTextCursor(cursor);
                continue;
            }
            break;
        }
        parentWindow->getText()->activateWindow();
    }
}
