//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "searchwidget.h"

SearchWidget::SearchWidget(MainWindow *main, QWidget *parent)
        : QWidget(parent)
{
    parentWindow = main;
    search = new QDockWidget(parentWindow->getSettings()->value("Lang/Search_Titel").toString(), main);
    search->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea | Qt::TopDockWidgetArea);
    search->setObjectName("searchDock");

    QVBoxLayout *searchBox = new QVBoxLayout();
    searchEdit = new QLineEdit();
    searchBox->addWidget(searchEdit,Qt::AlignTop);
    searchCase = new QCheckBox(parentWindow->getSettings()->value("Lang/Search_CaseSensitiv").toString());
    searchWhole = new QCheckBox(parentWindow->getSettings()->value("Lang/Search_Whole_Words").toString());
    searchBack = new QCheckBox(parentWindow->getSettings()->value("Lang/Search_Back").toString());
    searchButton = new QPushButton(parentWindow->getSettings()->value("Lang/Search_Titel").toString());
    main->connect(searchButton,SIGNAL(clicked()),this,SLOT(searchText()));
    searchBox->addWidget(searchCase);
    searchBox->addWidget(searchWhole);
    searchBox->addWidget(searchBack);
    searchBox->addWidget(searchButton);
    searchBox->addStretch();
    this->setLayout(searchBox);

    search->setWidget(this);
    main->addDockWidget(Qt::LeftDockWidgetArea, search);
}










void SearchWidget::searchText()
{
    if (parentWindow->getBar()->count() < 1)
    {
        QMessageBox box;
        box.setText(parentWindow->getSettings()->value("Lang/Search_Error").toString());
        box.exec();
        return;
    }
    if (parentWindow->getText() != 0)
    {
        QTextCursor cursor = parentWindow->getText()->text2->textCursor();
        QTextDocument::FindFlags option = 0;
        if (searchCase->checkState() == Qt::Checked)
        {
            option = option | QTextDocument::FindCaseSensitively;
        }
        if (searchWhole->checkState() == Qt::Checked)
        {
            option = option | QTextDocument::FindWholeWords;
        }
        if (searchBack->checkState() == Qt::Checked)
        {
            option = option | QTextDocument::FindBackward;
        }
        cursor = (parentWindow->getText()->text2->document())->find(searchEdit->text(),cursor,option);
        if (cursor.isNull() == false)
        {
            parentWindow->getText()->text2->setTextCursor(cursor);
        }
        parentWindow->getText()->activateWindow();

    }
}
