//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "manager.h"
#include "highlighter.h"
#include "textedit.h"
#include "linenumber.h"

extern QFont fontEdit;

TextEdit::TextEdit(MainWindow *main, QString file, int tabIndex, QWidget *parent)
        : QWidget(parent)
{
    parentWindow = main;

    text2 = new Text();
    text2->edit = this;

    main->setText(this);
    text2->setFontFamily(main->getSettings()->value("Edit/Font").toString());
    text2->setFontPointSize(main->getSettings()->value("Edit/PointSize").toInt());
    text2->zoomIn(2);
    connect(text2->document(),SIGNAL(contentsChange(int,int,int)),text2,SLOT(textChange(int, int, int)));

    text2->setFont(fontEdit);
    fontEdit = text2->font();
    main->getV()->addWidget(this);
    index = main->getBar()->addTab(file);
    text2->setLineWrapMode(QTextEdit::NoWrap);
    text2->highlighter = new Highlighter(text2->document(),text2);


    main->getMap()->insert(tabIndex, this);
    main->getTypMap()->insert(tabIndex, 1);
    main->getBar()->setTabData(index,QVariant(tabIndex));

    main->setConnections(text2);
    if (main->getTab() == false)
    {
        connect(main->getBar(),SIGNAL(currentChanged(int)),main,SLOT(tabChange(int)));
        main->setTab(true);
    }
    main->getBar()->setCurrentIndex(index);
    main->tabChange(index);

    h = new QHBoxLayout;
    h->setSpacing(0);
    h->setContentsMargins(0,0,0,0);
    lineNumber = new LineNumber(main);
    QAbstractSlider *slider = lineNumber->verticalScrollBar();
    QAbstractSlider *slider2 = text2->verticalScrollBar();
    connect(slider2,SIGNAL(valueChanged(int)),slider,SLOT(setValue(int)));

    h->addWidget(lineNumber);
    h->addWidget(text2);
    setLayout(h);

    connect(text2->document(),SIGNAL(contentsChanged()),this,SLOT(textChange()));
    connect(slider,SIGNAL(valueChanged(int)),this,SLOT(lineScroll(int)));
    setToolTip("");



    text2->keyWord << "\\bif\\b" << "\\bthen\\b" << "\\belse\\b"
                    << "\\bdo\\b" << "\\bloop\\b" << "\\buntil\\b"
                    << "\\bwhile\\b" << "\\bdim\\b" << "\\bas\\b"
                    << "\\btype\\b" << "\\bselect\\b" << "\\bcase\\b"
                    << "\\bend\\b" << "\\belseif\\b" << "\\bfunction\\b"
                    << "\\bsub\\b" << "\\bgoto\\b" << "\\bgosub\\b"
                    << "\\breturn\\b" << "\\bwend\\b" << "\\basm\\b"
                    << "\\bconst\\b" << "\\bunion\\b" << "\\benum\\b"
                    << "\\bshared\\b" << "\\bstatic\\b" << "\\bunsigned\\b"
                    << "\\bvar\\b" << "\\bdeclare\\b" << "\\bbyref\\b"
                    << "\\bbyval\\b" << "\\bconstructor\\b" << "\\bdestructor\\b"
                    << "\\bfor\\b" << "\\bnext\\b" << "\\bwith\\b" << "\\bscope\\b"
                    << "\\bnamespace\\b" << "\\bcontinue\\b" << "\\bexit\\b" << ",";

}














TextEdit::~TextEdit()
{
    for (int i = 0;i<lineNumber->list.count();i++)
    {
        lineNumber->vBox->removeWidget(lineNumber->list[i]);
        lineNumber->list[i]->deleteLater();
    }
    lineNumber->vBox->deleteLater();
    h->removeWidget(text2);
    text2->document()->deleteLater();
    text2->deleteLater();
    h->deleteLater();
}















void TextEdit::textChange()
{
    QTextCursor cur = text2->textCursor();
    cur.movePosition(QTextCursor::StartOfLine);
    cur.movePosition(QTextCursor::EndOfLine,QTextCursor::KeepAnchor);
    QString string;
    string = cur.selectedText();
    QTextCursor cur2 = text2->textCursor();


    if (text2->document()->lineCount()+1 != lineNumber->iLines)
    {
        int curLine = 1;
        for (int i = 0;true == cur2.movePosition(QTextCursor::Up);i++)
        {
            curLine++;
        }
        char buffer[255];
        sprintf(buffer,"%d",curLine);

        QVariant d = parentWindow->getBar()->tabData(parentWindow->getBar()->currentIndex());
        QString p = parentWindow->getPathMap()->value(d.toInt(),0);
        QList<QListWidgetItem*> itemList;
        int count = parentWindow->getManager()->getListWidget()->count();
        for (int i = 0;i < count;i++)
        {
            QListWidgetItem *item = parentWindow->getManager()->getListWidget()->item(i);
            funcItem *fi = (funcItem*)item->data(Qt::UserRole).toInt();
            if (fi->file == p && fi->line > curLine-3)
            {
                itemList << item;
            }
        }
        for (int i = 0;i < itemList.count();i++)
        {
            QListWidgetItem *item;
            item = itemList[i];
            funcItem *fi = (funcItem*)item->data(Qt::UserRole).toInt();
            int line = fi->line;
            QString text = fi->text;
            delete item;
            funcItem *fi2 = new funcItem;
            QListWidgetItem *item2 = new QListWidgetItem;
            fi2->file = p;
            if (lineNumber->iLines > 1)
            {
                fi2->line = line + ((text2->document()->lineCount()+1) - lineNumber->iLines);
            } else
            {
                fi2->line = line;
            }
            fi2->text = text;
            item2->setText(text);
            item2->setData(Qt::UserRole,QVariant((int)fi2));
            parentWindow->getManager()->getListWidget()->addItem(item2);
        }
        itemList.clear();
        count = parentWindow->getManager()->getListWidget2()->count();
        for (int i = 0;i < count;i++)
        {
            QListWidgetItem *item = parentWindow->getManager()->getListWidget2()->item(i);
            funcItem *fi = (funcItem*)item->data(Qt::UserRole).toInt();
            if (fi->file == p && fi->line > curLine-3)
            {
                itemList << item;
            }
        }
        for (int i = 0;i < itemList.count();i++)
        {
            QListWidgetItem *item;
            item = itemList[i];
            funcItem *fi = (funcItem*)item->data(Qt::UserRole).toInt();
            int line = fi->line;
            QString text = fi->text;
            delete item;
            funcItem *fi2 = new funcItem;
            QListWidgetItem *item2 = new QListWidgetItem;
            fi2->file = p;
            if (lineNumber->iLines > 1)
            {
                fi2->line = line + ((text2->document()->lineCount()+1) - lineNumber->iLines);
            } else
            {
                fi2->line = line;
            }
            fi2->text = text;
            item2->setText(text);
            item2->setData(Qt::UserRole,QVariant((int)fi2));
            parentWindow->getManager()->getListWidget2()->addItem(item2);
        }


    }
    lineNumber->lines(text2);
    QAbstractSlider *slider2 = text2->verticalScrollBar();

    QAbstractSlider *slider = lineNumber->verticalScrollBar();
    slider->setValue(slider2->value());
}








void TextEdit::lineScroll(int value)
{
    lineNumber->verticalScrollBar()->setValue(text2->verticalScrollBar()->value());
}











bool Text::event(QEvent *event)
{
    if (event->type() == QEvent::ToolTip)
    {
        setToolTip("");
        QTextCursor cur;
        cur = cursorForPosition(((QHelpEvent*)event)->pos());
        cur.movePosition(QTextCursor::StartOfWord);
        cur.movePosition(QTextCursor::EndOfWord,QTextCursor::KeepAnchor);

        if (keyWord.contains(cur.selectedText(),Qt::CaseInsensitive) == true)
        {
            return QTextEdit::event(event);
        }
        QString string2 = cur.selectedText();
        string2.remove(QRegExp("\\b[0-9]+\\b"));
        if (string2.isEmpty() == true)
        {
            return QTextEdit::event(event);
        }
        QTextCursor cur2;
        QTextCursor cur3;
        QString string;
        QStringList list;
        QStringList list2;
        QStringList list3;
        bool f = false;
        cur2 = document()->find(cur.selectedText());
        for (;;)
        {
            if (cur2.isNull() == true)
            {
                break;
            }
            cur2.movePosition(QTextCursor::StartOfLine);
            cur2.movePosition(QTextCursor::EndOfLine,QTextCursor::KeepAnchor);
            string = cur2.selectedText();
            if (string.contains("dim",Qt::CaseInsensitive) == true && string.contains("as",Qt::CaseInsensitive) == true)
            {
                

                list3 = string.split(QChar(' '));
                list.clear();
                for (int i = 0;i < list3.count();i++)
                {
                    if (list3[i].isEmpty() == false)
                    {
                        list << list3[i];
                    }
                }
                string = list.join(" ");


                if (string.contains("dim",Qt::CaseInsensitive) == true && string.contains("as",Qt::CaseInsensitive) == true && string.contains(cur.selectedText(),Qt::CaseInsensitive) == true)
                {
                    setToolTip(string);
                    f = true;
                }

            }
            cur2 = document()->find(cur.selectedText(),cur2);
        }
        if (f == false)
        {
            setToolTip(cur2.selectedText());
        }

    }
    return QTextEdit::event(event);

}










void Text::insertFromMimeData ( const QMimeData * source )
{
    if (source->hasText() == true)
    {
        this->insertPlainText(source->text().toAscii());
    }
}







void Text::textChange(int position, int charsRemoved, int charsAdded)
{
    QString tabtext = edit->getParentWindow()->getBar()->tabText(edit->getParentWindow()->getBar()->currentIndex());
    QStringList tabtextlist = tabtext.split(" ");
    if (tabtextlist.last() != "(*)" && tabtextlist.last() != "(*)")
    {
        edit->getParentWindow()->getBar()->setTabText(edit->getParentWindow()->getBar()->currentIndex(),edit->getParentWindow()->getBar()->tabText(edit->getParentWindow()->getBar()->currentIndex()).append(" (*)"));
    }
    QString string;
    QStringList list;
    QStringList list2;
    QStringList list3;
    QTextCursor cur2 = this->textCursor();
    QTextCursor cur = this->textCursor();
    cur.movePosition(QTextCursor::StartOfLine,QTextCursor::KeepAnchor);

    if (charsRemoved < 1 && cur.selectedText().isEmpty() == true && this->document()->isRedoAvailable() == false)
    {
        cur.movePosition(QTextCursor::Left);
        cur.movePosition(QTextCursor::StartOfLine,QTextCursor::KeepAnchor);

        /*if (cur.selectedText().isEmpty() == false)
        {
            string = cur.selectedText();
            list3 = string.split(" ");
            list3.replaceInStrings(QRegExp("\".*\""),"");

            for (int i = 0;i < list3.count();i++)
            {
                if (list3[i].isEmpty() == true || list3[i] == " ")
                {
                    list3.removeAt(i);
                }
            }
            list3.removeAll(" ");
            list3.removeAll("");
            string = list3.join(" ");








            if (string.compare("end if",Qt::CaseInsensitive) == 0)
            {

                int space = 0;
                list3.clear();
                string = cur.selectedText();
                list3 = string.split(" ");
                list3.replaceInStrings(QRegExp("\".*\""),"");

                for (int i = 0;i < list3.count();i++)
                {
                    if (list3[i].isEmpty() == true || list3[i] == " ")
                    {
                        space++;
                        continue;
                    }
                    break;
                }
                list3.clear();

                space = space - 4;
                for (int i = 0;i < space;i++)
                {
                    list3 << " ";
                }

                cur.removeSelectedText();
                QString text;
                text = list3.join("");
                text.append("end if    ");
                cur.insertText(text);
                cur.insertText("");
            }



            if (string.compare("end sub",Qt::CaseInsensitive) == 0)
            {

                int space = 0;
                list3.clear();
                string = cur.selectedText();
                list3 = string.split(" ");
                list3.replaceInStrings(QRegExp("\".*\""),"");

                for (int i = 0;i < list3.count();i++)
                {
                    if (list3[i].isEmpty() == true || list3[i] == " ")
                    {
                        space++;
                        continue;
                    }
                    break;
                }
                list3.clear();

                space = space - 4;
                for (int i = 0;i < space;i++)
                {
                    list3 << " ";
                }

                cur.removeSelectedText();
                QString text;
                text = list3.join("");
                text.append("end sub    ");
                cur.insertText(text);
                cur.insertText("");
            }









            if (string.compare("end function",Qt::CaseInsensitive) == 0)
            {

                int space = 0;
                list3.clear();
                string = cur.selectedText();
                list3 = string.split(" ");
                list3.replaceInStrings(QRegExp("\".*\""),"");

                for (int i = 0;i < list3.count();i++)
                {
                    if (list3[i].isEmpty() == true || list3[i] == " ")
                    {
                        space++;
                        continue;
                    }
                    break;
                }
                list3.clear();

                space = space - 4;
                for (int i = 0;i < space;i++)
                {
                    list3 << " ";
                }

                cur.removeSelectedText();
                QString text;
                text = list3.join("");
                text.append("end function    ");
                cur.insertText(text);
                cur.insertText("");
            }



            if (string.compare("end type",Qt::CaseInsensitive) == 0)
            {

                int space = 0;
                list3.clear();
                string = cur.selectedText();
                list3 = string.split(" ");
                list3.replaceInStrings(QRegExp("\".*\""),"");

                for (int i = 0;i < list3.count();i++)
                {
                    if (list3[i].isEmpty() == true || list3[i] == " ")
                    {
                        space++;
                        continue;
                    }
                    break;
                }
                list3.clear();

                space = space - 4;
                for (int i = 0;i < space;i++)
                {
                    list3 << " ";
                }
                cur.beginEditBlock();
                cur.removeSelectedText();
                QString text;
                text = list3.join("");
                text.append("end type        ");
                cur.insertText(text);

                cur.endEditBlock();

            }
        }*/

        string.clear();
        cur = this->textCursor();
        cur.movePosition(QTextCursor::StartOfLine,QTextCursor::KeepAnchor);
        cur.movePosition(QTextCursor::Left);
        cur.movePosition(QTextCursor::StartOfLine,QTextCursor::KeepAnchor);
        QStringList list3;
        QStringList list4;

        if (cur.selectedText().isEmpty() == false)
        {
            string = cur.selectedText();
            list = string.split(" ");
            int space = 0;
            for (int i = 0;i < list.count();i++)
            {
                if (list[i].isEmpty() == true)
                {
                    space++;
                } else
                {
                    break;
                }
            }

            space--;
            
            list.clear();
            for (int i = 0;i < space;i++)
            {
                list << " ";
            }

            list2 = cur.selectedText().split(" ");
            list2.replaceInStrings(QRegExp("\".*\""),"");
            list4 = list2;
            for (int i = 0;i < list2.count();i++)
            {
                if (list2[i].isEmpty() == true)
                {
                    list2.removeAt(i);
                }
            }
            list2.removeAll(" ");
            list2.removeAll("");
            list3 = list;


            bool goUp = false;
            //Leerzeichen hinzufgen.
            if (list2.isEmpty() == false)
            {
                if (list2.last().compare("then",Qt::CaseInsensitive) == 0 || list2.first().compare("function",Qt::CaseInsensitive) == 0 || list2.first().compare("sub",Qt::CaseInsensitive) == 0 || list2.first().compare("do",Qt::CaseInsensitive) == 0 || list2.first().compare("while",Qt::CaseInsensitive) == 0 || list2.first().compare("type",Qt::CaseInsensitive) == 0 || list2.first().compare("for",Qt::CaseInsensitive) == 0 || list2.first().compare("constructor",Qt::CaseInsensitive) == 0 || list2.first().compare("destructor",Qt::CaseInsensitive) == 0 || list2.first().compare("with",Qt::CaseInsensitive) == 0)
                {
                    //Soviele wie Eingestellt ist.
                    for (int i = 0;i < edit->getParentWindow()->getSettings()->value("Einruecken/space").toInt();i++)
                    {
                        list << " ";
                    }
                }



                if (list2.last() != "" && list.count() > 0 && (list2.last().compare("then",Qt::CaseInsensitive) != 0 && list2.first().compare("function",Qt::CaseInsensitive) != 0 && list2.first().compare("sub",Qt::CaseInsensitive) != 0 && list2.first().compare("do",Qt::CaseInsensitive) != 0) && list2.first().compare("while",Qt::CaseInsensitive) != 0 && list2.first().compare("type",Qt::CaseInsensitive) != 0 && list2.first().compare("for",Qt::CaseInsensitive) != 0 && list2.first().compare("constructor",Qt::CaseInsensitive) != 0 && list2.first().compare("destructor",Qt::CaseInsensitive) != 0 && list2.first().compare("with",Qt::CaseInsensitive) != 0)
                {
                    list << " ";
                }




                //Autovervollstndigung: do...loop, if...end if, for...next, while...wend, sub...end sub, function...end function, type...end type, destructor...end destructor, constructor...end constructor
                //TODO: Gro und kleinschreibung.
                QString appendString;
                if (edit->getParentWindow()->getSettings()->value("Autocomplete/if_bool").toBool() == true && list2.last().compare("then",Qt::CaseInsensitive) == 0)
                {
                    appendString = "end if";
                    if (list2.first().compare("IF",Qt::CaseSensitive) == 0)
                    {
                        appendString = "END IF";
                    } else if (list2.first().compare("If",Qt::CaseSensitive) == 0)
                    {
                        appendString = "End If";
                    }
                    if (list4.first().compare("if",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (edit->getParentWindow()->getSettings()->value("Autocomplete/function_bool").toBool() == true && list2.first().compare("function",Qt::CaseInsensitive) == 0)
                {
                    appendString = "end function";
                    if (list2.first().mid(0,2).compare("FU",Qt::CaseSensitive) == 0)
                    {
                        appendString = "END FUNCTION";
                    } else if (list2.first().mid(0,2).compare("Fu",Qt::CaseSensitive) == 0)
                    {
                        appendString = "End Function";
                    }
                    if (list4.first().compare("function",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (edit->getParentWindow()->getSettings()->value("Autocomplete/sub_bool").toBool() == true && list2.first().compare("sub",Qt::CaseInsensitive) == 0)
                {
                    appendString = "end sub";
                    if (list2.first().mid(0,2).compare("SU",Qt::CaseSensitive) == 0)
                    {
                        appendString = "END SUB";
                    } else if (list2.first().mid(0,2).compare("Su",Qt::CaseSensitive) == 0)
                    {
                        appendString = "End Sub";
                    }
                    if (list4.first().compare("sub",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (edit->getParentWindow()->getSettings()->value("Autocomplete/do_bool").toBool() == true && list2.first().compare("do",Qt::CaseInsensitive) == 0)
                {
                    appendString = "loop";
                    if (list2.first().mid(0,2).compare("DO",Qt::CaseSensitive) == 0)
                    {
                        appendString = "LOOP";
                    } else if (list2.first().mid(0,2).compare("Do",Qt::CaseSensitive) == 0)
                    {
                        appendString = "Loop";
                    }
                    if (list4.first().compare("do",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (edit->getParentWindow()->getSettings()->value("Autocomplete/while_bool").toBool() == true && list2.first().compare("while",Qt::CaseInsensitive) == 0)
                {
                    appendString = "wend";
                    if (list2.first().mid(0,2).compare("WH",Qt::CaseSensitive) == 0)
                    {
                        appendString = "WEND";
                    } else if (list2.first().mid(0,2).compare("Wh",Qt::CaseSensitive) == 0)
                    {
                        appendString = "Wend";
                    }
                    if (list4.first().compare("while",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (edit->getParentWindow()->getSettings()->value("Autocomplete/for_bool").toBool() == true && list2.first().compare("for",Qt::CaseInsensitive) == 0)
                {
                    appendString = "next";
                    if (list2.first().mid(0,2).compare("FO",Qt::CaseSensitive) == 0)
                    {
                        appendString = "NEXT";
                    } else if (list2.first().mid(0,2).compare("Fo",Qt::CaseSensitive) == 0)
                    {
                        appendString = "Next";
                    }
                    if (list4.first().compare("for",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (edit->getParentWindow()->getSettings()->value("Autocomplete/type_bool").toBool() == true && list2.first().compare("type",Qt::CaseInsensitive) == 0)
                {
                    appendString = "end type";
                    if (list2.first().mid(0,2).compare("TY",Qt::CaseSensitive) == 0)
                    {
                        appendString = "END TYPE";
                    } else if (list2.first().mid(0,2).compare("Ty",Qt::CaseSensitive) == 0)
                    {
                        appendString = "End Type";
                    }
                    if (list4.first().compare("type",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (edit->getParentWindow()->getSettings()->value("Autocomplete/constructor_bool").toBool() == true && list2.first().compare("constructor",Qt::CaseInsensitive) == 0)
                {
                    appendString = "end constructor";
                    if (list2.first().mid(0,2).compare("CO",Qt::CaseSensitive) == 0)
                    {
                        appendString = "END CONSTRUCTOR";
                    } else if (list2.first().mid(0,2).compare("Co",Qt::CaseSensitive) == 0)
                    {
                        appendString = "End Constructor";
                    }
                    if (list4.first().compare("constructor",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (edit->getParentWindow()->getSettings()->value("Autocomplete/destructor_bool").toBool() == true && list2.first().compare("destructor",Qt::CaseInsensitive) == 0)
                {
                    appendString = "end destructor";
                    if (list2.first().mid(0,2).compare("DE",Qt::CaseSensitive) == 0)
                    {
                        appendString = "END DESTRUCTOR";
                    } else if (list2.first().mid(0,2).compare("De",Qt::CaseSensitive) == 0)
                    {
                        appendString = "End Destructor";
                    }
                    if (list4.first().compare("destructor",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                } else if (list2.first().compare("with",Qt::CaseInsensitive) == 0)
                {
                    appendString = "end with";
                    if (list2.first().mid(0,2).compare("WI",Qt::CaseSensitive) == 0)
                    {
                        appendString = "END WITH";
                    } else if (list2.first().mid(0,2).compare("Wi",Qt::CaseSensitive) == 0)
                    {
                        appendString = "End With";
                    }
                    if (list4.first().compare("with",Qt::CaseInsensitive) == 0)
                    {
                        list << "\n" << list3 << appendString;
                    } else
                    {
                        list << " " << "\n" << list3 << " " << appendString;
                    }
                    goUp = true;
                }
            }
            cur2.insertText(list.join(""));       //Ergebniss der riesen if-Abfrage einsetzen
            if (goUp == true)
            {
                cur = this->textCursor();
                cur.movePosition(QTextCursor::Up);
                this->setTextCursor(cur);
                edit->getLineNumber()->lines(this);   //Zeilenzhler erneuern
            }

        }
    }
}










void Text::index()
{
    QStringList lines = toPlainText().split("\n");
    bool del = false;
    for (int i = 0;lines.count() > i;i++)
    {
        if (lines[i] == "")
        {
            continue;
        }
        if (del == true)
        {
            QString s = lines[i];
            s.replace(" ","");
            lines.removeAt(i);
            if (s.compare("endtype",Qt::CaseInsensitive) == 0)
            {

                del = false;
            }
            i--;
            continue;
        }
        QStringList l = lines[i].split(" ");
        l.removeAll("");
        if (l.first().compare("type",Qt::CaseInsensitive) == 0)
        {
            del = true;
            lines.removeAt(i);
            i--;
            continue;
        }

    }

    QStringList subs;
    for (int i = 0;lines.count() > i;i++)
    {
        QStringList l = lines[i].split(" ");
        l.removeAll("");
        if(l.count() >= 2)
        {
            if (l.first().compare("declare",Qt::CaseInsensitive) == 0 && l[1].compare("sub",Qt::CaseInsensitive) == 0)
            {
                subs << lines[i];
            }
        }
    }

    QStringList funcs;
    for (int i = 0;lines.count() > i;i++)
    {
        QStringList l = lines[i].split(" ");
        l.removeAll("");
        if(l.count() >= 2)
        {
            if (l.first().compare("declare",Qt::CaseInsensitive) == 0 && l[1].compare("function",Qt::CaseInsensitive) == 0)
            {
                funcs << lines[i];
            }
        }
    }


    for (int i = 0;funcs.count() > i;i++)
    {
        QString f = funcs[i];

        
        QRegExp ex("\"");
        QRegExp ex2("\"\"");
        int start = 0;
        int start2;
        int end;
        int end2;
        for(;;)
        {
            start = ex.indexIn(f,start);
            start2 = start;
            if (start != -1)
            {
                for (;;)
                {
                    end = ex.indexIn(f,start2+1);
                    end2 = ex2.indexIn(f,start2+1);
    
                    if (end2 != -1)
                    {
                        end = end2+1;
                        break;
                    }
                    if (f.mid(end-1,1) == "\\")
                    {
                        start2 = end+1;
                        continue;
                    }
                    break;
                }
                if (end != -1)
                {
                    f.remove(start,end-start+1);
                    start = start + (end-start+1);
                }  else
                {
                    break;
                }
            }
            if (start == -1)
            {
                break;
            }
        }
    }

}
