//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#ifndef TEXTEDIT_H
#define TEXTEDIT_H

#include <QWidget>
#include <QHBoxLayout>
#include "highlighter.h"
#include "mainwindow.h"
#include "linenumber.h"

class TextEdit;
class LineNumber;

class objectValues
{
    bool var_shared;
    QString var_type;
    QString var_name;

    bool sub;
    bool sub_export;
    bool sub_overload;
    QString sub_lib;
    QString sub_alias;
    QString sub_name;
    QString sub_parameter;
    QString sub_return;
};





class Text : public QTextEdit
{
    Q_OBJECT
public:
    Highlighter *highlighter;
    QStringList keyWord;
    TextEdit *edit;
    QMap<QString,objectValues*> objects;

public slots:
    void textChange(int position, int charsRemoved, int charsAdded);
    void index();

protected:
    bool event ( QEvent * event );
    void insertFromMimeData ( const QMimeData * source );
};





class TextEdit : public QWidget
{
    Q_OBJECT
public:
    TextEdit(MainWindow *main, QString file, int tabIndex, QWidget *parent = 0);
    ~TextEdit();
    Text *text2;
    QHBoxLayout *h;
    int index;

    LineNumber *getLineNumber() { return lineNumber; }
    MainWindow *getParentWindow() { return parentWindow; }

private:
    MainWindow *parentWindow;
    LineNumber *lineNumber;



public slots:
    void textChange();
    void lineScroll(int value);
};

#endif // TEXTEDIT_H
