#include <QtWebKit>
#include <QtGui>
#include "webview.h"

WebView::WebView(MainWindow *main,int tabIndex) : QWidget()
{
    b = false;
    QVBoxLayout *vbox = new QVBoxLayout;
    view = new QWebView;
    vbox->addWidget(view);
    connect(view->page()->mainFrame(),SIGNAL(loadFinished(bool)),this,SLOT(loadFinish()));
    view->load(QUrl("http://www.freebasic-portal.de/befehlsreferenz/"));

    QWebSettings::globalSettings()->setAttribute(QWebSettings::JavascriptEnabled,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::PluginsEnabled,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::JavaEnabled,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::JavascriptCanOpenWindows,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::AutoLoadImages,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::DeveloperExtrasEnabled,true);
    setLayout(vbox);

    if (main->getTab() == false)
    {
        connect(main->getBar(),SIGNAL(currentChanged(int)),main,SLOT(tabChange(int)));
        main->setTab(true);
    }

    int index = main->getBar()->addTab("Referenz");

    main->getWebMap()->insert(tabIndex, this);
    main->getTypMap()->insert(tabIndex, 2);
    main->getBar()->setTabData(index,QVariant(tabIndex));
    main->getBar()->setCurrentIndex(index);
    main->tabChange(index);
    main->getV()->addWidget(this);
    main->setWeb(this);
}



WebView::WebView(MainWindow *main,int tabIndex, QString name) : QWidget()
{
    b = false;
    QVBoxLayout *vbox = new QVBoxLayout;
    QWebView *view = new QWebView;
    vbox->addWidget(view);
    view->setHtml("<iframe src=\"http://webchat.freenode.net/?channels=freebasic.de&amp;nick=fbp-gast1\" width=\"100%\" height=\"420\"></iframe>");
    setLayout(vbox);

    QWebSettings::globalSettings()->setAttribute(QWebSettings::JavascriptEnabled,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::PluginsEnabled,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::JavaEnabled,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::JavascriptCanOpenWindows,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::AutoLoadImages,true);
    QWebSettings::globalSettings()->setAttribute(QWebSettings::DeveloperExtrasEnabled,true);

    int index = main->getBar()->addTab("IRC");

    main->getWebMap()->insert(tabIndex, this);
    main->getTypMap()->insert(tabIndex, 2);
    main->getBar()->setTabData(index,QVariant(tabIndex));
    main->getBar()->setCurrentIndex(index);
    main->tabChange(index);
    main->getV()->addWidget(this);
    main->setWeb(this);
}




void WebView::reload()
{
    QMessageBox::information(this,"",view->page()->mainFrame()->toHtml());
}




void WebView::loadFinish()
{
    /*if (b == false)
    {
        QString code = view->page()->mainFrame()->toHtml();
        int i1 = code.indexOf("<div id=\"topcontent\"");
        int i2 = code.indexOf("<div id=\"main\"");
        code.remove(i1,i2-i1-1);

        code.replace("\"http://www.freebasic-portal.de/formate.css\"","\"http://users.freebasic-portal.de/stueber/fb.css\"");

        disconnect(view->page()->mainFrame(),SIGNAL(loadFinished(bool)),this,SLOT(loadFinish()));
        view->page()->mainFrame()->setHtml(code);

        QMessageBox::information(this,"",code);
        b = true;
    } else
    {
        b = false;
    }*/
    QWebElement document = view->page()->mainFrame()->documentElement();
    QList<QWebElement> introSpans = document.findAll("div").toList();
    for (int i = 0;i < introSpans.count();i++)
    {
        if (introSpans[i].attribute("id") == "main")
        {
            introSpans[i].setStyleProperty("margin","0 0px");
        } else if (introSpans[i].attribute("id") == "topcontent")
        {
            introSpans[i].setStyleProperty("display","none");
        } else if (introSpans[i].attribute("id") == "whoisonline")
        {
            introSpans[i].setStyleProperty("display","none");
        } else if (introSpans[i].attribute("id") == "links")
        {
            introSpans[i].setStyleProperty("display","none");
        } else if (introSpans[i].attribute("id") == "rechts")
        {
            introSpans[i].setStyleProperty("display","none");
        } else if (introSpans[i].attribute("id") == "footer")
        {
            introSpans[i].setStyleProperty("display","none");
        }
    }

    introSpans = document.findAll("input").toList();
    for (int i = 0;i < introSpans.count();i++)
    {
        if (introSpans[i].attribute("id") == "refsuchfeld")
        {
            introSpans[i].setStyleProperty("top","0px");
            introSpans[i].setStyleProperty("left","10px");

        }
    }
}




void WebView::link(QUrl url)
{
    view->load(url);
}
